module Hat.Control.Monad.Cont
  (MonadCont(..),Cont(Cont,brunCont),aCont,grunCont,hrunCont,arunCont,gmapCont
    ,amapCont,hmapCont,gwithCont,awithCont,hwithCont,ContT(ContT,brunContT)
    ,aContT,grunContT,hrunContT,arunContT,gmapContT,amapContT,hmapContT
    ,gwithContT,awithContT,hwithContT,module Hat.Control.Monad
    ,module Hat.Control.Monad.Trans) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Control.Monad.Trans 
import Hat.Control.Monad.Reader 
import Hat.Control.Monad.Writer 
import Hat.Control.Monad.State 
import Hat.Control.Monad.RWS 

class Monad m => MonadCont m
  where
  
  gcallCC ::
    T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun (T.Fun a (m b)) (m a)) (m a))
  
  scallCC :: T.R (T.Fun (T.Fun (T.Fun a (m b)) (m a)) (m a))
  

newtype Cont r a = Cont {brunCont :: T.R (T.Fun (T.Fun a r) r)}

instance T.WrapVal ((Cont r a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Cont (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aCont z1wrapVal)
  

grunCont prunCont p = T.ufun1 arunCont prunCont p hrunCont

hrunCont (T.R z1runCont _) p = T.projection T.mkNoSrcPos p (brunCont z1runCont)

instance Functor ((Cont r))
  where
  
  gfmap pfmap p =
    T.ufun2 a45v9v45v48fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 Cont T.cn1 T.mkNoSrcPos p aCont)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fc p ->
                T.uap2 T.mkNoSrcPos p (grunCont T.mkNoSrcPos p) fm
                  (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) fc ff)))) p)
    
  

instance Monad ((Cont r))
  where
  
  greturn preturn p =
    T.ufun1 a48v9v48v28return preturn p hreturn
    where
    
    hreturn fa p =
      T.con1 T.mkNoSrcPos p Cont aCont
        (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gflip T.mkNoSrcPos p)
          (T.mkNoSrcPos !$ p) fa)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+&>=##=&>=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 Cont T.cn1 T.mkNoSrcPos p aCont)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fc p ->
                T.uwrapForward p
                  (((T.uwrapForward p (hrunCont fm p))
                      *$
                      (T.ufun1 T.mkLambda T.mkNoSrcPos p
                        (\ fa p ->
                          T.uap2 T.mkNoSrcPos p (grunCont T.mkNoSrcPos p)
                            (T.uap1 T.mkNoSrcPos p fk fa) fc))) p)))) p)
    
  

instance MonadCont ((Cont r))
  where
  
  gcallCC pcallCC p =
    T.ufun1 a52v9v52v70callCC pcallCC p hcallCC
    where
    
    hcallCC ff p =
      T.uwrapForward p
        (((T.pa0 Cont T.cn1 T.mkNoSrcPos p aCont)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fc p ->
                T.uap2 T.mkNoSrcPos p (grunCont T.mkNoSrcPos p)
                  (T.uap1 T.mkNoSrcPos p ff
                    (T.ufun1 T.mkLambda T.mkNoSrcPos p
                      (\ fa p ->
                        T.uwrapForward p
                          (((T.pa0 Cont T.cn1 T.mkNoSrcPos p aCont)
                              *$
                              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                                (\ _ p -> T.uap1 T.mkNoSrcPos p fc fa))) p))))
                  fc))) p)
    
  

gmapCont ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.Fun r r) (T.Fun (Cont r a) (Cont r a)))

hmapCont :: (T.R (T.Fun r r)) -> (T.R (Cont r a)) -> T.RefExp -> T.R (Cont r a)

gmapCont pmapCont p = T.ufun2 amapCont pmapCont p hmapCont

hmapCont ff fm p =
  T.uwrapForward p
    (((T.pa0 Cont T.cn1 T.mkNoSrcPos p aCont)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) ff
          (T.uwrapForward p (hrunCont fm p)))) p)

gwithCont ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (T.Fun (T.Fun b r) (T.Fun a r)) (T.Fun (Cont r a) (Cont r b)))

hwithCont ::
  (T.R (T.Fun (T.Fun b r) (T.Fun a r))) ->
    (T.R (Cont r a)) -> T.RefExp -> T.R (Cont r b)

gwithCont pwithCont p = T.ufun2 awithCont pwithCont p hwithCont

hwithCont ff fm p =
  T.uwrapForward p
    (((T.pa0 Cont T.cn1 T.mkNoSrcPos p aCont)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.uwrapForward p (hrunCont fm p)) ff)) p)

newtype ContT r m a = ContT {brunContT :: T.R (T.Fun (T.Fun a (m r)) (m r))}

instance T.WrapVal ((ContT r m a))
  where
  
  wrapVal pwrapVal (kwrapVal@(ContT (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aContT z1wrapVal)
  

grunContT prunContT p = T.ufun1 arunContT prunContT p hrunContT

hrunContT (T.R z1runContT _) p =
  T.projection T.mkNoSrcPos p (brunContT z1runContT)

instance Monad m => Functor ((ContT r m))
  where
  
  gfmap pfmap p =
    T.ufun2 a66v9v66v50fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 ContT T.cn1 T.mkNoSrcPos p aContT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fc p ->
                T.uap2 T.mkNoSrcPos p (grunContT T.mkNoSrcPos p) fm
                  (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) fc ff)))) p)
    
  

instance Monad m => Monad ((ContT r m))
  where
  
  greturn preturn p =
    T.ufun1 a69v9v69v29return preturn p hreturn
    where
    
    hreturn fa p =
      T.con1 T.mkNoSrcPos p ContT aContT
        (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gflip T.mkNoSrcPos p)
          (T.mkNoSrcPos !$ p) fa)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+^!=##=^!=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 ContT T.cn1 T.mkNoSrcPos p aContT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fc p ->
                T.uap2 T.mkNoSrcPos p (grunContT T.mkNoSrcPos p) fm
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ fa p ->
                      T.uap2 T.mkNoSrcPos p (grunContT T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p fk fa) fc))))) p)
    
  

instance Monad m => MonadCont ((ContT r m))
  where
  
  gcallCC pcallCC p =
    T.ufun1 a73v9v73v73callCC pcallCC p hcallCC
    where
    
    hcallCC ff p =
      T.uwrapForward p
        (((T.pa0 ContT T.cn1 T.mkNoSrcPos p aContT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fc p ->
                T.uap2 T.mkNoSrcPos p (grunContT T.mkNoSrcPos p)
                  (T.uap1 T.mkNoSrcPos p ff
                    (T.ufun1 T.mkLambda T.mkNoSrcPos p
                      (\ fa p ->
                        T.uwrapForward p
                          (((T.pa0 ContT T.cn1 T.mkNoSrcPos p aContT)
                              *$
                              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                                (\ _ p -> T.uap1 T.mkNoSrcPos p fc fa))) p))))
                  fc))) p)
    
  

instance MonadTrans ((ContT r))
  where
  
  glift plift p =
    T.ufun1 a76v9v76v29lift plift p hlift
    where
    
    hlift fm p =
      T.con1 T.mkNoSrcPos p ContT aContT
        (T.uap1 T.mkNoSrcPos p (T.mkNoSrcPos !>>= p) fm)
    
  

instance MonadIO m => MonadIO ((ContT r m))
  where
  
  gliftIO pliftIO p = T.uconstUse pliftIO p sliftIO
  
  sliftIO =
    T.uconstDef T.mkRoot a79v9v79v30liftIO
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gliftIO T.mkNoSrcPos p))
  

instance MonadReader r' m => MonadReader (r') ((ContT r m))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask =
    T.uconstDef T.mkRoot a82v9v82v28ask
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gask T.mkNoSrcPos p))
  
  glocal plocal p =
    T.ufun2 a83v9v85v56local plocal p hlocal
    where
    
    hlocal ff fm p =
      T.uwrapForward p
        (((T.pa0 ContT T.cn1 T.mkNoSrcPos p aContT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fc p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (gask T.mkNoSrcPos p)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fr p ->
                      T.uap2 T.mkNoSrcPos p (glocal T.mkNoSrcPos p) ff
                        (T.uap2 T.mkNoSrcPos p (grunContT T.mkNoSrcPos p) fm
                          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
                            (T.uap1 T.mkNoSrcPos p (glocal T.mkNoSrcPos p)
                              (T.uap1 T.mkNoSrcPos p (gconst T.mkNoSrcPos p)
                                fr)) fc))))))) p)
    
  

instance MonadState s m => MonadState (s) ((ContT r m))
  where
  
  gget pget p = T.uconstUse pget p sget
  
  sget =
    T.uconstDef T.mkRoot a88v9v88v22get
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gget T.mkNoSrcPos p))
  
  gput pput p = T.uconstUse pput p sput
  
  sput =
    T.uconstDef T.mkRoot a89v9v89v24put
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gput T.mkNoSrcPos p))
  

instance MonadCont m => MonadCont ((ReaderT r m))
  where
  
  gcallCC pcallCC p =
    T.ufun1 a95v9v97v60callCC pcallCC p hcallCC
    where
    
    hcallCC ff p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                T.uwrapForward p
                  (((gcallCC T.mkNoSrcPos p)
                      *$
                      (T.ufun1 T.mkLambda T.mkNoSrcPos p
                        (\ fc p ->
                          T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p)
                            (T.uap1 T.mkNoSrcPos p ff
                              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                                (\ fa p ->
                                  T.uwrapForward p
                                    (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p
                                          aReaderT)
                                        *$
                                        (T.ufun1 T.mkLambda T.mkNoSrcPos p
                                          (\ _ p ->
                                            T.uap1 T.mkNoSrcPos p fc fa))) p))))
                            fr))) p)))) p)
    
  

instance MonadCont m => MonadCont ((StateT s m))
  where
  
  gcallCC pcallCC p =
    T.ufun1 a100v9v102v65callCC pcallCC p hcallCC
    where
    
    hcallCC ff p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uwrapForward p
                  (((gcallCC T.mkNoSrcPos p)
                      *$
                      (T.ufun1 T.mkLambda T.mkNoSrcPos p
                        (\ fc p ->
                          T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p)
                            (T.uap1 T.mkNoSrcPos p ff
                              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                                (\ fa p ->
                                  T.uwrapForward p
                                    (((T.pa0 StateT T.cn1 T.mkNoSrcPos p
                                          aStateT)
                                        *$
                                        (T.ufun1 T.mkLambda T.mkNoSrcPos p
                                          (\ fs' p ->
                                            T.uap1 T.mkNoSrcPos p fc
                                              (T.con2 T.mkNoSrcPos p T.Tuple2
                                                T.aTuple2 fa fs')))) p)))) fs)))
                    p)))) p)
    
  

instance (Monoid w,MonadCont m) => MonadCont ((WriterT w m))
  where
  
  gcallCC pcallCC p =
    T.ufun1 a105v9v107v60callCC pcallCC p hcallCC
    where
    
    hcallCC ff p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uwrapForward p
              (((gcallCC T.mkNoSrcPos p)
                  *$
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ fc p ->
                      T.uwrapForward p
                        (hrunWriterT
                          (T.uap1 T.mkNoSrcPos p ff
                            (T.ufun1 T.mkLambda T.mkNoSrcPos p
                              (\ fa p ->
                                T.uwrapForward p
                                  (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p
                                        aWriterT)
                                      *$
                                      (T.uap1 T.mkNoSrcPos p fc
                                        (T.con2 T.mkNoSrcPos p T.Tuple2
                                          T.aTuple2 fa
                                          (gmempty T.mkNoSrcPos p)))) p))))
                          p)))) p))) p)
    
  

instance (Monoid w,MonadCont m) => MonadCont ((RWST r w s m))
  where
  
  gcallCC pcallCC p =
    T.ufun1 a110v9v112v73callCC pcallCC p hcallCC
    where
    
    hcallCC ff p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uwrapForward p
                  (((gcallCC T.mkNoSrcPos p)
                      *$
                      (T.ufun1 T.mkLambda T.mkNoSrcPos p
                        (\ fc p ->
                          T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p)
                            (T.uap1 T.mkNoSrcPos p ff
                              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                                (\ fa p ->
                                  T.uwrapForward p
                                    (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
                                        *$
                                        (T.ufun2 T.mkLambda T.mkNoSrcPos p
                                          (\ _ fs' p ->
                                            T.uap1 T.mkNoSrcPos p fc
                                              (T.con3 T.mkNoSrcPos p T.Tuple3
                                                T.aTuple3 fa fs'
                                                (gmempty T.mkNoSrcPos p)))))
                                      p)))) fr fs))) p)))) p)
    
  

gmapContT ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (T.Fun (m r) (m r)) (T.Fun (ContT r m a) (ContT r m a)))

hmapContT ::
  (T.R (T.Fun (m r) (m r))) ->
    (T.R (ContT r m a)) -> T.RefExp -> T.R (ContT r m a)

gmapContT pmapContT p = T.ufun2 amapContT pmapContT p hmapContT

hmapContT ff fm p =
  T.uwrapForward p
    (((T.pa0 ContT T.cn1 T.mkNoSrcPos p aContT)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) ff
          (T.uwrapForward p (hrunContT fm p)))) p)

gwithContT ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (T.Fun b (m r)) (T.Fun a (m r)))
          (T.Fun (ContT r m a) (ContT r m b)))

hwithContT ::
  (T.R (T.Fun (T.Fun b (m r)) (T.Fun a (m r)))) ->
    (T.R (ContT r m a)) -> T.RefExp -> T.R (ContT r m b)

gwithContT pwithContT p = T.ufun2 awithContT pwithContT p hwithContT

hwithContT ff fm p =
  T.uwrapForward p
    (((T.pa0 ContT T.cn1 T.mkNoSrcPos p aContT)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.uwrapForward p (hrunContT fm p)) ff)) p)

tControl_Monad_Cont =
  T.mkModule "Control.Monad.Cont" "Control/Monad/Cont.hs" Prelude.False

aCont =
  T.mkConstructorWFields tControl_Monad_Cont 420020 420023 3 1 "Cont"
    (arunCont : [])

aContT =
  T.mkConstructorWFields tControl_Monad_Cont 630023 630027 3 1 "ContT"
    (arunContT : [])

arunCont =
  T.mkVariable tControl_Monad_Cont 420027 420033 3 1 "runCont" Prelude.False

a45v9v45v48fmap =
  T.mkVariable tControl_Monad_Cont 450009 450048 3 2 "fmap" Prelude.False

a48v9v48v28return =
  T.mkVariable tControl_Monad_Cont 480009 480028 3 1 "return" Prelude.False

(+&>=##=&>=#%>>=) =
  T.mkVariable tControl_Monad_Cont 490011 490013 6 2 ">>=" Prelude.False

a52v9v52v70callCC =
  T.mkVariable tControl_Monad_Cont 520009 520070 3 1 "callCC" Prelude.False

amapCont =
  T.mkVariable tControl_Monad_Cont 550001 550034 3 2 "mapCont" Prelude.False

awithCont =
  T.mkVariable tControl_Monad_Cont 580001 580035 3 2 "withCont" Prelude.False

arunContT =
  T.mkVariable tControl_Monad_Cont 630031 630038 3 1 "runContT" Prelude.False

a66v9v66v50fmap =
  T.mkVariable tControl_Monad_Cont 660009 660050 3 2 "fmap" Prelude.False

a69v9v69v29return =
  T.mkVariable tControl_Monad_Cont 690009 690029 3 1 "return" Prelude.False

(+^!=##=^!=#%>>=) =
  T.mkVariable tControl_Monad_Cont 700011 700013 6 2 ">>=" Prelude.False

a73v9v73v73callCC =
  T.mkVariable tControl_Monad_Cont 730009 730073 3 1 "callCC" Prelude.False

a76v9v76v29lift =
  T.mkVariable tControl_Monad_Cont 760009 760029 3 1 "lift" Prelude.False

a79v9v79v30liftIO =
  T.mkVariable tControl_Monad_Cont 790009 790030 3 0 "liftIO" Prelude.False

a82v9v82v28ask =
  T.mkVariable tControl_Monad_Cont 820009 820028 3 0 "ask" Prelude.False

a83v9v85v56local =
  T.mkVariable tControl_Monad_Cont 830009 850056 3 2 "local" Prelude.False

a88v9v88v22get =
  T.mkVariable tControl_Monad_Cont 880009 880022 3 0 "get" Prelude.False

a89v9v89v24put =
  T.mkVariable tControl_Monad_Cont 890009 890024 3 0 "put" Prelude.False

a95v9v97v60callCC =
  T.mkVariable tControl_Monad_Cont 950009 970060 3 1 "callCC" Prelude.False

a100v9v102v65callCC =
  T.mkVariable tControl_Monad_Cont 1000009 1020065 3 1 "callCC" Prelude.False

a105v9v107v60callCC =
  T.mkVariable tControl_Monad_Cont 1050009 1070060 3 1 "callCC" Prelude.False

a110v9v112v73callCC =
  T.mkVariable tControl_Monad_Cont 1100009 1120073 3 1 "callCC" Prelude.False

amapContT =
  T.mkVariable tControl_Monad_Cont 1150001 1150037 3 2 "mapContT" Prelude.False

awithContT =
  T.mkVariable tControl_Monad_Cont 1180001 1180038 3 2 "withContT" Prelude.False
