module Hat.Control.Monad.Error
  (Error(..),MonadError(..),ErrorT(ErrorT,brunErrorT),aErrorT,grunErrorT
    ,hrunErrorT,arunErrorT,gmapErrorT,amapErrorT,hmapErrorT
    ,module Hat.Control.Monad,module Hat.Control.Monad.Fix
    ,module Hat.Control.Monad.Trans) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Control.Monad.Fix 
import Hat.Control.Monad.Trans 
import Hat.Control.Monad.Reader 
import Hat.Control.Monad.Writer 
import Hat.Control.Monad.State 
import Hat.Control.Monad.RWS 
import Hat.Control.Monad.Cont 
import Hat.System.IO 

class Error a
  where
  
  gnoMsg :: T.RefSrcPos -> T.RefExp -> T.R a
  
  gstrMsg :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun String a)
  
  gnoMsg pnoMsg p = T.uconstUse pnoMsg p snoMsg
  
  snoMsg =
    T.uconstDef T.mkRoot a55v9v55v28noMsg
      (\ p ->
        T.uap1 T.mkNoSrcPos p (gstrMsg T.mkNoSrcPos p)
          (T.fromLitString T.mkNoSrcPos p ""))
  
  gstrMsg pstrMsg p =
    T.ufun1 a56v9v56v24strMsg pstrMsg p hstrMsg
    where
    
    hstrMsg _ p = gnoMsg T.mkNoSrcPos p
    
  
  snoMsg :: T.R a
  
  sstrMsg :: T.R (T.Fun String a)
  

instance Error ((T.List Char))
  where
  
  gnoMsg pnoMsg p = T.uconstUse pnoMsg p snoMsg
  
  snoMsg =
    T.uconstDef T.mkRoot a59v9v59v19noMsg
      (\ p -> T.fromLitString T.mkNoSrcPos p "")
  
  gstrMsg pstrMsg p = T.uconstUse pstrMsg p sstrMsg
  
  sstrMsg = T.uconstDef T.mkRoot a60v9v60v19strMsg (\ p -> gid T.mkNoSrcPos p)
  

instance Error (IOError)
  where
  
  gstrMsg pstrMsg p = T.uconstUse pstrMsg p sstrMsg
  
  sstrMsg =
    T.uconstDef T.mkRoot a63v9v63v26strMsg (\ p -> guserError T.mkNoSrcPos p)
  

class Monad m => MonadError e m | m->e
  where
  
  gthrowError :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun e (m a))
  
  gcatchError ::
    T.RefSrcPos -> T.RefExp -> T.R (T.Fun (m a) (T.Fun (T.Fun e (m a)) (m a)))
  
  sthrowError :: T.R (T.Fun e (m a))
  
  scatchError :: T.R (T.Fun (m a) (T.Fun (T.Fun e (m a)) (m a)))
  

instance MonadPlus (IO)
  where
  
  gmzero pmzero p = T.uconstUse pmzero p smzero
  
  smzero =
    T.uconstDef T.mkRoot a70v9v70v48mzero
      (\ p ->
        T.uwrapForward p
          (hioError
            (T.uwrapForward p
              (huserError (T.fromLitString T.mkNoSrcPos p "mzero") p)) p))
  
  gmplus pmplus p =
    T.ufun2 a71v12v71v16mplus pmplus p hmplus
    where
    
    hmplus fm fn p =
      T.uwrapForward p
        (hcatch fm
          (T.ufun1 T.mkLambda T.mkNoSrcPos p
            (\ _ p -> T.projection T.mkNoSrcPos p fn)) p)
    
  

instance MonadError (IOError) (IO)
  where
  
  gthrowError pthrowError p = T.uconstUse pthrowError p sthrowError
  
  sthrowError =
    T.uconstDef T.mkRoot a74v9v74v28throwError (\ p -> gioError T.mkNoSrcPos p)
  
  gcatchError pcatchError p = T.uconstUse pcatchError p scatchError
  
  scatchError =
    T.uconstDef T.mkRoot a75v9v75v26catchError (\ p -> gcatch T.mkNoSrcPos p)
  

instance Functor ((Either e))
  where
  
  gfmap pfmap p =
    T.ufun2 a81v9v82v37fmap pfmap p hfmap
    where
    
    hfmap _ (T.R (Left fl) _) p = T.con1 T.mkNoSrcPos p Left aLeft fl
    hfmap ff (T.R (Right fr) _) p =
      T.con1 T.mkNoSrcPos p Right aRight (T.uap1 T.mkNoSrcPos p ff fr)
    hfmap _ _ p = T.fatal p
    
  

instance Error e => Monad ((Either e))
  where
  
  greturn preturn p = T.uconstUse preturn p sreturn
  
  sreturn =
    T.uconstDef T.mkRoot a85v9v85v29return
      (\ p -> T.pa0 Right T.cn1 T.mkNoSrcPos p aRight)
  
  (!>>=) (%>>=) p =
    T.ufun2 (+@+=#^=@^=#>>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) (T.R (Left fl) _) _ p = T.con1 T.mkNoSrcPos p Left aLeft fl
    (*>>=) (T.R (Right fr) _) fk p = T.uap1 T.mkNoSrcPos p fk fr
    (*>>=) _ _ p = T.fatal p
    
  
  gfail pfail p =
    T.ufun1 a88v9v88v40fail pfail p hfail
    where
    
    hfail fmsg p =
      T.con1 T.mkNoSrcPos p Left aLeft
        (T.uap1 T.mkNoSrcPos p (gstrMsg T.mkNoSrcPos p) fmsg)
    
  

instance Error e => MonadPlus ((Either e))
  where
  
  gmzero pmzero p = T.uconstUse pmzero p smzero
  
  smzero =
    T.uconstDef T.mkRoot a91v9v91v37mzero
      (\ p -> T.con1 T.mkNoSrcPos p Left aLeft (gnoMsg T.mkNoSrcPos p))
  
  gmplus pmplus p =
    T.ufun2 a92v17v93v21mplus pmplus p hmplus
    where
    
    hmplus (T.R (Left _) _) fn p = T.projection T.mkNoSrcPos p fn
    hmplus fm _ p = T.projection T.mkNoSrcPos p fm
    
  

instance Error e => MonadFix ((Either e))
  where
  
  gmfix pmfix p =
    T.ufun1 a96v9v100v20mfix pmfix p hmfix
    where
    
    hmfix ff p =
      let
        ga pa p = T.uconstUse pa p sa
        sa =
          T.uconstDef p a97v17v99v62a
            (\ p ->
              T.uwrapForward p
                ((ff
                    *$
                    (T.uccase T.mkNoSrcPos p
                      (let
                        v97v25v99v62v1 (T.R (Right fr) _) p =
                          T.projection T.mkNoSrcPos p fr
                        v97v25v99v62v1 _ p =
                          T.uwrapForward p
                            (herror
                              (T.fromLitString T.mkNoSrcPos p
                                "empty mfix argument") p) in (v97v25v99v62v1))
                      (ga T.mkNoSrcPos p))) p)) in (ga T.mkNoSrcPos p)
    
  

instance Error e => MonadError (e) ((Either e))
  where
  
  gthrowError pthrowError p = T.uconstUse pthrowError p sthrowError
  
  sthrowError =
    T.uconstDef T.mkRoot a103v9v103v37throwError
      (\ p -> T.pa0 Left T.cn1 T.mkNoSrcPos p aLeft)
  
  gcatchError pcatchError p =
    T.ufun2 a104v18v105v27catchError pcatchError p hcatchError
    where
    
    hcatchError (T.R (Left fl) _) fh p = T.uap1 T.mkNoSrcPos p fh fl
    hcatchError (T.R (Right fr) _) _ p = T.con1 T.mkNoSrcPos p Right aRight fr
    hcatchError _ _ p = T.fatal p
    
  

newtype ErrorT e m a = ErrorT {brunErrorT :: T.R (m (Either e a))}

instance T.WrapVal ((ErrorT e m a))
  where
  
  wrapVal pwrapVal (kwrapVal@(ErrorT (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aErrorT z1wrapVal)
  

grunErrorT prunErrorT p = T.ufun1 arunErrorT prunErrorT p hrunErrorT

hrunErrorT (T.R z1runErrorT _) p =
  T.projection T.mkNoSrcPos p (brunErrorT z1runErrorT)

instance Monad m => Functor ((ErrorT e m))
  where
  
  gfmap pfmap p =
    T.ufun2 a127v9v131v53fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunErrorT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uccase T.mkNoSrcPos p
                    (let
                      v129v17v131v53v1 (T.R (Left fl) _) p =
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.con1 T.mkNoSrcPos p Left aLeft fl)
                      v129v17v131v53v1 (T.R (Right fr) _) p =
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.con1 T.mkNoSrcPos p Right aRight
                            (T.uap1 T.mkNoSrcPos p ff fr))
                      v129v17v131v53v1 _ p = T.fatal p in (v129v17v131v53v1))
                    fa)))) p)
    
  

instance (Monad m,Error e) => Monad ((ErrorT e m))
  where
  
  greturn preturn p =
    T.ufun1 a134v9v134v43return preturn p hreturn
    where
    
    hreturn fa p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.con1 T.mkNoSrcPos p Right aRight fa))) p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+#%*=##=#%*=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunErrorT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uccase T.mkNoSrcPos p
                    (let
                      v137v17v139v49v1 (T.R (Left fl) _) p =
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.con1 T.mkNoSrcPos p Left aLeft fl)
                      v137v17v139v49v1 (T.R (Right fr) _) p =
                        T.uwrapForward p
                          (hrunErrorT (T.uap1 T.mkNoSrcPos p fk fr) p)
                      v137v17v139v49v1 _ p = T.fatal p in (v137v17v139v49v1))
                    fa)))) p)
    
  
  gfail pfail p =
    T.ufun1 a140v9v140v52fail pfail p hfail
    where
    
    hfail fmsg p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.con1 T.mkNoSrcPos p Left aLeft
                (T.uap1 T.mkNoSrcPos p (gstrMsg T.mkNoSrcPos p) fmsg)))) p)
    
  

instance (Monad m,Error e) => MonadPlus ((ErrorT e m))
  where
  
  gmzero pmzero p = T.uconstUse pmzero p smzero
  
  smzero =
    T.uconstDef T.mkRoot a143v9v143v49mzero
      (\ p ->
        T.uwrapForward p
          (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
              *$
              (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                (T.con1 T.mkNoSrcPos p Left aLeft (gnoMsg T.mkNoSrcPos p)))) p))
  
  gmplus pmplus p =
    T.ufun2 a144v12v144v16mplus pmplus p hmplus
    where
    
    hmplus fm fn p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunErrorT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uccase T.mkNoSrcPos p
                    (let
                      v146v17v148v50v1 (T.R (Left _) _) p =
                        T.uwrapForward p (hrunErrorT fn p)
                      v146v17v148v50v1 (T.R (Right fr) _) p =
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.con1 T.mkNoSrcPos p Right aRight fr)
                      v146v17v148v50v1 _ p = T.fatal p in (v146v17v148v50v1))
                    fa)))) p)
    
  

instance (MonadFix m,Error e) => MonadFix ((ErrorT e m))
  where
  
  gmfix pmfix p =
    T.ufun1 a151v9v153v54mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uwrapForward p
              (((gmfix T.mkNoSrcPos p)
                  *$
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ fa p ->
                      T.uwrapForward p
                        (((grunErrorT T.mkNoSrcPos p)
                            *$
                            (T.uwrapForward p
                              ((ff
                                  *$
                                  (T.uccase T.mkNoSrcPos p
                                    (let
                                      v151v56v153v54v1 (T.R (Right fr) _) p =
                                        T.projection T.mkNoSrcPos p fr
                                      v151v56v153v54v1 _ p =
                                        T.uwrapForward p
                                          (herror
                                            (T.fromLitString T.mkNoSrcPos p
                                              "empty mfix argument") p) in
                                      (v151v56v153v54v1)) fa)) p))) p)))) p)))
          p)
    
  

instance (Monad m,Error e) => MonadError (e) ((ErrorT e m))
  where
  
  gthrowError pthrowError p =
    T.ufun1 a156v9v156v50throwError pthrowError p hthrowError
    where
    
    hthrowError fl p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.con1 T.mkNoSrcPos p Left aLeft fl))) p)
    
  
  gcatchError pcatchError p =
    T.ufun2 a157v12v157v21catchError pcatchError p hcatchError
    where
    
    hcatchError fm fh p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunErrorT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uccase T.mkNoSrcPos p
                    (let
                      v159v17v161v50v1 (T.R (Left fl) _) p =
                        T.uwrapForward p
                          (hrunErrorT (T.uap1 T.mkNoSrcPos p fh fl) p)
                      v159v17v161v50v1 (T.R (Right fr) _) p =
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.con1 T.mkNoSrcPos p Right aRight fr)
                      v159v17v161v50v1 _ p = T.fatal p in (v159v17v161v50v1))
                    fa)))) p)
    
  

instance Error e => MonadTrans ((ErrorT e))
  where
  
  glift plift p =
    T.ufun1 a164v9v166v31lift plift p hlift
    where
    
    hlift fm p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fm
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                    (T.con1 T.mkNoSrcPos p Right aRight fa))))) p)
    
  

instance (Error e,MonadIO m) => MonadIO ((ErrorT e m))
  where
  
  gliftIO pliftIO p = T.uconstUse pliftIO p sliftIO
  
  sliftIO =
    T.uconstDef T.mkRoot a169v9v169v30liftIO
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gliftIO T.mkNoSrcPos p))
  

instance (Error e,MonadReader r m) => MonadReader (r) ((ErrorT e m))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask =
    T.uconstDef T.mkRoot a172v9v172v28ask
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gask T.mkNoSrcPos p))
  
  glocal plocal p =
    T.ufun2 a173v9v173v49local plocal p hlocal
    where
    
    hlocal ff fm p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap2 T.mkNoSrcPos p (glocal T.mkNoSrcPos p) ff
              (T.uwrapForward p (hrunErrorT fm p)))) p)
    
  

instance (Error e,MonadWriter w m) => MonadWriter (w) ((ErrorT e m))
  where
  
  gtell ptell p = T.uconstUse ptell p stell
  
  stell =
    T.uconstDef T.mkRoot a176v9v176v30tell
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gtell T.mkNoSrcPos p))
  
  glisten plisten p =
    T.ufun1 a177v9v181v47listen plisten p hlisten
    where
    
    hlisten fm p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uap1 T.mkNoSrcPos p (glisten T.mkNoSrcPos p)
                (T.uwrapForward p (hrunErrorT fm p)))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fv178v27v178v45v1 p ->
                  T.uccase T.mkNoSrcPos p
                    (let
                      v178v27v178v45v1 (T.R (T.Tuple2 fa fw) _) p =
                        T.uwrapForward p
                          (((greturn T.mkNoSrcPos p)
                              *$
                              (T.uccase T.mkNoSrcPos p
                                (let
                                  v179v26v181v47v1 (T.R (Left fl) _) p =
                                    T.con1 T.mkNoSrcPos p Left aLeft fl
                                  v179v26v181v47v1 (T.R (Right fr) _) p =
                                    T.con1 T.mkNoSrcPos p Right aRight
                                      (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                                        fr fw)
                                  v179v26v181v47v1 _ p = T.fatal p in
                                  (v179v26v181v47v1)) fa)) p)
                      v178v27v178v45v1 _ p =
                        T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                          (T.fromLitString T.mkNoSrcPos p
                            "pattern-match failure in do expression") in
                      (v178v27v178v45v1)) fv178v27v178v45v1)))) p)
    
  
  gpass ppass p =
    T.ufun1 a182v9v186v52pass ppass p hpass
    where
    
    hpass fm p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uwrapForward p
              (((gpass T.mkNoSrcPos p)
                  *$
                  (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                    (T.uwrapForward p (hrunErrorT fm p))
                    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                      (\ fa p ->
                        T.uwrapForward p
                          (((greturn T.mkNoSrcPos p)
                              *$
                              (T.uccase T.mkNoSrcPos p
                                (let
                                  v184v26v186v52v1 (T.R (Left fl) _) p =
                                    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                                      (T.con1 T.mkNoSrcPos p Left aLeft fl)
                                      (gid T.mkNoSrcPos p)
                                  v184v26v186v52v1
                                    (T.R (Right (T.R (T.Tuple2 fr ff) _)) _) p =
                                    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                                      (T.con1 T.mkNoSrcPos p Right aRight fr) ff
                                  v184v26v186v52v1 _ p = T.fatal p in
                                  (v184v26v186v52v1)) fa)) p))))) p))) p)
    
  

instance (Error e,MonadState s m) => MonadState (s) ((ErrorT e m))
  where
  
  gget pget p = T.uconstUse pget p sget
  
  sget =
    T.uconstDef T.mkRoot a189v9v189v22get
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gget T.mkNoSrcPos p))
  
  gput pput p = T.uconstUse pput p sput
  
  sput =
    T.uconstDef T.mkRoot a190v9v190v24put
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gput T.mkNoSrcPos p))
  

instance (Error e,MonadCont m) => MonadCont ((ErrorT e m))
  where
  
  gcallCC pcallCC p =
    T.ufun1 a193v9v195v55callCC pcallCC p hcallCC
    where
    
    hcallCC ff p =
      T.uwrapForward p
        (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
            *$
            (T.uwrapForward p
              (((gcallCC T.mkNoSrcPos p)
                  *$
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ fc p ->
                      T.uwrapForward p
                        (hrunErrorT
                          (T.uap1 T.mkNoSrcPos p ff
                            (T.ufun1 T.mkLambda T.mkNoSrcPos p
                              (\ fa p ->
                                T.uwrapForward p
                                  (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
                                      *$
                                      (T.uap1 T.mkNoSrcPos p fc
                                        (T.con1 T.mkNoSrcPos p Right aRight
                                          fa))) p)))) p)))) p))) p)
    
  

gmapErrorT ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (m (Either e a)) (n (Either e' b)))
          (T.Fun (ErrorT e m a) (ErrorT e' n b)))

hmapErrorT ::
  (T.R (T.Fun (m (Either e a)) (n (Either e' b)))) ->
    (T.R (ErrorT e m a)) -> T.RefExp -> T.R (ErrorT e' n b)

gmapErrorT pmapErrorT p = T.ufun2 amapErrorT pmapErrorT p hmapErrorT

hmapErrorT ff fm p =
  T.uwrapForward p
    (((T.pa0 ErrorT T.cn1 T.mkNoSrcPos p aErrorT)
        *$
        (T.uap1 T.mkNoSrcPos p ff (T.uwrapForward p (hrunErrorT fm p)))) p)

instance MonadError e m => MonadError (e) ((ReaderT r m))
  where
  
  gthrowError pthrowError p = T.uconstUse pthrowError p sthrowError
  
  sthrowError =
    T.uconstDef T.mkRoot a204v9v204v44throwError
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gthrowError T.mkNoSrcPos p))
  
  gcatchError pcatchError p =
    T.ufun2 a205v12v205v21catchError pcatchError p hcatchError
    where
    
    hcatchError fm fh p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                T.uap2 T.mkNoSrcPos p (gcatchError T.mkNoSrcPos p)
                  (T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p) fm fr)
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ fe p ->
                      T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p fh fe) fr))))) p)
    
  

instance (Monoid w,MonadError e m) => MonadError (e) ((WriterT w m))
  where
  
  gthrowError pthrowError p = T.uconstUse pthrowError p sthrowError
  
  sthrowError =
    T.uconstDef T.mkRoot a209v9v209v44throwError
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gthrowError T.mkNoSrcPos p))
  
  gcatchError pcatchError p =
    T.ufun2 a210v12v210v21catchError pcatchError p hcatchError
    where
    
    hcatchError fm fh p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap2 T.mkNoSrcPos p (gcatchError T.mkNoSrcPos p)
              (T.uwrapForward p (hrunWriterT fm p))
              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                (\ fe p ->
                  T.uwrapForward p
                    (hrunWriterT (T.uap1 T.mkNoSrcPos p fh fe) p))))) p)
    
  

instance MonadError e m => MonadError (e) ((StateT s m))
  where
  
  gthrowError pthrowError p = T.uconstUse pthrowError p sthrowError
  
  sthrowError =
    T.uconstDef T.mkRoot a214v9v214v44throwError
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gthrowError T.mkNoSrcPos p))
  
  gcatchError pcatchError p =
    T.ufun2 a215v12v215v21catchError pcatchError p hcatchError
    where
    
    hcatchError fm fh p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uap2 T.mkNoSrcPos p (gcatchError T.mkNoSrcPos p)
                  (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fm fs)
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ fe p ->
                      T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p fh fe) fs))))) p)
    
  

instance (Monoid w,MonadError e m) => MonadError (e) ((RWST r w s m))
  where
  
  gthrowError pthrowError p = T.uconstUse pthrowError p sthrowError
  
  sthrowError =
    T.uconstDef T.mkRoot a219v9v219v44throwError
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gthrowError T.mkNoSrcPos p))
  
  gcatchError pcatchError p =
    T.ufun2 a220v12v220v21catchError pcatchError p hcatchError
    where
    
    hcatchError fm fh p =
      T.uwrapForward p
        (((T.pa0 RWST T.cn1 T.mkNoSrcPos p aRWST)
            *$
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ fr fs p ->
                T.uap2 T.mkNoSrcPos p (gcatchError T.mkNoSrcPos p)
                  (T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p) fm fr fs)
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ fe p ->
                      T.uap3 T.mkNoSrcPos p (grunRWST T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p fh fe) fr fs))))) p)
    
  

tControl_Monad_Error =
  T.mkModule "Control.Monad.Error" "Control/Monad/Error.hs" Prelude.False

aErrorT =
  T.mkConstructorWFields tControl_Monad_Error 1100024 1100029 3 1 "ErrorT"
    (arunErrorT : [])

a55v9v55v28noMsg =
  T.mkVariable tControl_Monad_Error 550009 550028 3 0 "noMsg" Prelude.False

a56v9v56v24strMsg =
  T.mkVariable tControl_Monad_Error 560009 560024 3 1 "strMsg" Prelude.False

a59v9v59v19noMsg =
  T.mkVariable tControl_Monad_Error 590009 590019 3 0 "noMsg" Prelude.False

a60v9v60v19strMsg =
  T.mkVariable tControl_Monad_Error 600009 600019 3 0 "strMsg" Prelude.False

a63v9v63v26strMsg =
  T.mkVariable tControl_Monad_Error 630009 630026 3 0 "strMsg" Prelude.False

a70v9v70v48mzero =
  T.mkVariable tControl_Monad_Error 700009 700048 3 0 "mzero" Prelude.False

a71v12v71v16mplus =
  T.mkVariable tControl_Monad_Error 710012 710016 3 2 "mplus" Prelude.False

a74v9v74v28throwError =
  T.mkVariable tControl_Monad_Error 740009 740028 3 0 "throwError" Prelude.False

a75v9v75v26catchError =
  T.mkVariable tControl_Monad_Error 750009 750026 3 0 "catchError" Prelude.False

a81v9v82v37fmap =
  T.mkVariable tControl_Monad_Error 810009 820037 3 2 "fmap" Prelude.False

a85v9v85v29return =
  T.mkVariable tControl_Monad_Error 850009 850029 3 0 "return" Prelude.False

(+@+=#^=@^=#>>>=) =
  T.mkVariable tControl_Monad_Error 860017 870019 6 2 ">>=" Prelude.False

a88v9v88v40fail =
  T.mkVariable tControl_Monad_Error 880009 880040 3 1 "fail" Prelude.False

a91v9v91v37mzero =
  T.mkVariable tControl_Monad_Error 910009 910037 3 0 "mzero" Prelude.False

a92v17v93v21mplus =
  T.mkVariable tControl_Monad_Error 920017 930021 3 2 "mplus" Prelude.False

a96v9v100v20mfix =
  T.mkVariable tControl_Monad_Error 960009 1000020 3 1 "mfix" Prelude.False

a103v9v103v37throwError =
  T.mkVariable tControl_Monad_Error 1030009 1030037 3 0 "throwError"
    Prelude.False

a104v18v105v27catchError =
  T.mkVariable tControl_Monad_Error 1040018 1050027 3 2 "catchError"
    Prelude.False

arunErrorT =
  T.mkVariable tControl_Monad_Error 1100033 1100041 3 1 "runErrorT"
    Prelude.False

a127v9v131v53fmap =
  T.mkVariable tControl_Monad_Error 1270009 1310053 3 2 "fmap" Prelude.False

a134v9v134v43return =
  T.mkVariable tControl_Monad_Error 1340009 1340043 3 1 "return" Prelude.False

(+#%*=##=#%*=#%>>=) =
  T.mkVariable tControl_Monad_Error 1350011 1350013 6 2 ">>=" Prelude.False

a140v9v140v52fail =
  T.mkVariable tControl_Monad_Error 1400009 1400052 3 1 "fail" Prelude.False

a143v9v143v49mzero =
  T.mkVariable tControl_Monad_Error 1430009 1430049 3 0 "mzero" Prelude.False

a144v12v144v16mplus =
  T.mkVariable tControl_Monad_Error 1440012 1440016 3 2 "mplus" Prelude.False

a151v9v153v54mfix =
  T.mkVariable tControl_Monad_Error 1510009 1530054 3 1 "mfix" Prelude.False

a156v9v156v50throwError =
  T.mkVariable tControl_Monad_Error 1560009 1560050 3 1 "throwError"
    Prelude.False

a157v12v157v21catchError =
  T.mkVariable tControl_Monad_Error 1570012 1570021 3 2 "catchError"
    Prelude.False

a164v9v166v31lift =
  T.mkVariable tControl_Monad_Error 1640009 1660031 3 1 "lift" Prelude.False

a169v9v169v30liftIO =
  T.mkVariable tControl_Monad_Error 1690009 1690030 3 0 "liftIO" Prelude.False

a172v9v172v28ask =
  T.mkVariable tControl_Monad_Error 1720009 1720028 3 0 "ask" Prelude.False

a173v9v173v49local =
  T.mkVariable tControl_Monad_Error 1730009 1730049 3 2 "local" Prelude.False

a176v9v176v30tell =
  T.mkVariable tControl_Monad_Error 1760009 1760030 3 0 "tell" Prelude.False

a177v9v181v47listen =
  T.mkVariable tControl_Monad_Error 1770009 1810047 3 1 "listen" Prelude.False

a182v9v186v52pass =
  T.mkVariable tControl_Monad_Error 1820009 1860052 3 1 "pass" Prelude.False

a189v9v189v22get =
  T.mkVariable tControl_Monad_Error 1890009 1890022 3 0 "get" Prelude.False

a190v9v190v24put =
  T.mkVariable tControl_Monad_Error 1900009 1900024 3 0 "put" Prelude.False

a193v9v195v55callCC =
  T.mkVariable tControl_Monad_Error 1930009 1950055 3 1 "callCC" Prelude.False

amapErrorT =
  T.mkVariable tControl_Monad_Error 1980001 1980039 3 2 "mapErrorT"
    Prelude.False

a204v9v204v44throwError =
  T.mkVariable tControl_Monad_Error 2040009 2040044 3 0 "throwError"
    Prelude.False

a205v12v205v21catchError =
  T.mkVariable tControl_Monad_Error 2050012 2050021 3 2 "catchError"
    Prelude.False

a209v9v209v44throwError =
  T.mkVariable tControl_Monad_Error 2090009 2090044 3 0 "throwError"
    Prelude.False

a210v12v210v21catchError =
  T.mkVariable tControl_Monad_Error 2100012 2100021 3 2 "catchError"
    Prelude.False

a214v9v214v44throwError =
  T.mkVariable tControl_Monad_Error 2140009 2140044 3 0 "throwError"
    Prelude.False

a215v12v215v21catchError =
  T.mkVariable tControl_Monad_Error 2150012 2150021 3 2 "catchError"
    Prelude.False

a219v9v219v44throwError =
  T.mkVariable tControl_Monad_Error 2190009 2190044 3 0 "throwError"
    Prelude.False

a220v12v220v21catchError =
  T.mkVariable tControl_Monad_Error 2200012 2200021 3 2 "catchError"
    Prelude.False

a97v17v99v62a =
  T.mkVariable tControl_Monad_Error 970017 990062 3 0 "a" Prelude.True
