module Hat.Control.Monad.Fix (MonadFix(gmfix,smfix),gfix,afix,hfix) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.System.IO 

gfix :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun a a) a)

hfix :: (T.R (T.Fun a a)) -> T.RefExp -> T.R a

gfix pfix p = T.ufun1 afix pfix p hfix

hfix ff p =
  let
    gx px p = T.uconstUse px p sx
    sx =
      T.uconstDef p a11v13v11v19x
        (\ p -> T.uap1 T.mkNoSrcPos p ff (gx T.mkNoSrcPos p)) in
    (gx T.mkNoSrcPos p)

class Monad m => MonadFix m
  where
  
  gmfix :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun a (m a)) (m a))
  
  smfix :: T.R (T.Fun (T.Fun a (m a)) (m a))
  

instance MonadFix (Maybe)
  where
  
  gmfix pmfix p =
    T.ufun1 a20v5v21v38mfix pmfix p hmfix
    where
    
    hmfix ff p =
      let
        ga pa p = T.uconstUse pa p sa
        sa =
          T.uconstDef p a20v18v20v32a
            (\ p ->
              T.uap1 T.mkNoSrcPos p ff
                (T.uwrapForward p (hunJust (ga T.mkNoSrcPos p) p))) in
        (ga T.mkNoSrcPos p)
      where
      
      gunJust punJust p = T.ufun1 a21v20v21v38unJust punJust p hunJust
      
      aunJust = a21v20v21v38unJust
      
      hunJust (T.R (Just fx) _) p = T.projection T.mkNoSrcPos p fx
      hunJust _ p = T.fatal p
      
    
  

instance MonadFix (T.List)
  where
  
  gmfix pmfix p =
    T.ufun1 a25v5v27v42mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.uccase T.mkNoSrcPos p
        (let
          v25v14v27v42v1 (T.R T.List _) p = T.con0 T.mkNoSrcPos p T.List T.aList
          v25v14v27v42v1 (T.R (T.Cons fx _) _) p =
            T.con2 T.mkNoSrcPos p T.Cons T.aCons fx
              (T.uap1 T.mkNoSrcPos p (gmfix T.mkNoSrcPos p)
                (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
                  (gtail T.mkNoSrcPos p) ff))
          v25v14v27v42v1 _ p = T.fatal p in (v25v14v27v42v1))
        (T.uwrapForward p
          (hfix
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) ff
              (ghead T.mkNoSrcPos p)) p))
    
  

instance MonadFix (IO)
  where
  
  gmfix pmfix p = T.uconstUse pmfix p smfix
  
  smfix = T.uconstDef T.mkRoot a31v5v31v16mfix (\ p -> gfixIO T.mkNoSrcPos p)
  

tControl_Monad_Fix =
  T.mkModule "Control.Monad.Fix" "Control/Monad/Fix.hs" Prelude.False

afix = T.mkVariable tControl_Monad_Fix 110001 110024 3 1 "fix" Prelude.False

a20v5v21v38mfix =
  T.mkVariable tControl_Monad_Fix 200005 210038 3 1 "mfix" Prelude.False

a25v5v27v42mfix =
  T.mkVariable tControl_Monad_Fix 250005 270042 3 1 "mfix" Prelude.False

a31v5v31v16mfix =
  T.mkVariable tControl_Monad_Fix 310005 310016 3 0 "mfix" Prelude.False

a11v13v11v19x =
  T.mkVariable tControl_Monad_Fix 110013 110019 3 0 "x" Prelude.True

a21v20v21v38unJust =
  T.mkVariable tControl_Monad_Fix 210020 210038 3 1 "unJust" Prelude.True

a20v18v20v32a =
  T.mkVariable tControl_Monad_Fix 200018 200032 3 0 "a" Prelude.True
