module Hat.Control.Monad.Reader
  (MonadReader(..),gasks,aasks,hasks,Reader(Reader,brunReader),aReader
    ,grunReader,hrunReader,arunReader,gmapReader,amapReader,hmapReader
    ,gwithReader,awithReader,hwithReader,ReaderT(ReaderT,brunReaderT),aReaderT
    ,grunReaderT,hrunReaderT,arunReaderT,gmapReaderT,amapReaderT,hmapReaderT
    ,gwithReaderT,awithReaderT,hwithReaderT,module Hat.Control.Monad
    ,module Hat.Control.Monad.Fix,module Hat.Control.Monad.Trans) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Control.Monad.Fix 
import Hat.Control.Monad.Trans 

class Monad m => MonadReader r m | m->r
  where
  
  gask :: T.RefSrcPos -> T.RefExp -> T.R (m r)
  
  glocal ::
    T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun r r) (T.Fun (m a) (m a)))
  
  sask :: T.R (m r)
  
  slocal :: T.R (T.Fun (T.Fun r r) (T.Fun (m a) (m a)))
  

gasks ::
  MonadReader r m => T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun r a) (m a))

hasks :: MonadReader r m => (T.R (T.Fun r a)) -> T.RefExp -> T.R (m a)

gasks pasks p = T.ufun1 aasks pasks p hasks

hasks ff p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) (gask T.mkNoSrcPos p)
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fr p ->
        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
          (T.uap1 T.mkNoSrcPos p ff fr)))

instance Functor ((T.Fun r))
  where
  
  gfmap pfmap p = T.uconstUse pfmap p sfmap
  
  sfmap = T.uconstDef T.mkRoot a60v9v60v17fmap (\ p -> (T.mkNoSrcPos !. p))
  

instance Monad ((T.Fun r))
  where
  
  greturn preturn p = T.uconstUse preturn p sreturn
  
  sreturn =
    T.uconstDef T.mkRoot a63v9v63v23return (\ p -> gconst T.mkNoSrcPos p)
  
  (!>>=) (%>>=) p =
    T.ufun2 (++&=##=+&=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.ufun1 T.mkLambda T.mkNoSrcPos p
        (\ fr p -> T.uap2 T.mkNoSrcPos p fk (T.uap1 T.mkNoSrcPos p fm fr) fr)
    
  

instance MonadFix ((T.Fun r))
  where
  
  gmfix pmfix p =
    T.ufun1 a67v9v67v41mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.ufun1 T.mkLambda T.mkNoSrcPos p
        (\ fr p ->
          let
            ga pa p = T.uconstUse pa p sa
            sa =
              T.uconstDef p a67v28v67v36a
                (\ p -> T.uap2 T.mkNoSrcPos p ff (ga T.mkNoSrcPos p) fr) in
            (ga T.mkNoSrcPos p))
    
  

instance MonadReader (r) ((T.Fun r))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask = T.uconstDef T.mkRoot a70v9v70v22ask (\ p -> gid T.mkNoSrcPos p)
  
  glocal plocal p =
    T.ufun2 a71v9v71v25local plocal p hlocal
    where
    
    hlocal ff fm p = T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) fm ff
    
  

newtype Reader r a = Reader {brunReader :: T.R (T.Fun r a)}

instance T.WrapVal ((Reader r a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Reader (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aReader z1wrapVal)
  

grunReader prunReader p = T.ufun1 arunReader prunReader p hrunReader

hrunReader (T.R z1runReader _) p =
  T.projection T.mkNoSrcPos p (brunReader z1runReader)

instance Functor ((Reader r))
  where
  
  gfmap pfmap p =
    T.ufun2 a79v9v79v50fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 Reader T.cn1 T.mkNoSrcPos p aReader)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                T.uap1 T.mkNoSrcPos p ff
                  (T.uap2 T.mkNoSrcPos p (grunReader T.mkNoSrcPos p) fm fr))))
          p)
    
  

instance Monad ((Reader r))
  where
  
  greturn preturn p =
    T.ufun1 a82v9v82v35return preturn p hreturn
    where
    
    hreturn fa p =
      T.uwrapForward p
        (((T.pa0 Reader T.cn1 T.mkNoSrcPos p aReader)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ _ p -> T.projection T.mkNoSrcPos p fa))) p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+@%=##=@%=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 Reader T.cn1 T.mkNoSrcPos p aReader)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                T.uap2 T.mkNoSrcPos p (grunReader T.mkNoSrcPos p)
                  (T.uap1 T.mkNoSrcPos p fk
                    (T.uap2 T.mkNoSrcPos p (grunReader T.mkNoSrcPos p) fm fr))
                  fr))) p)
    
  

instance MonadFix ((Reader r))
  where
  
  gmfix pmfix p =
    T.ufun1 a86v9v86v62mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.uwrapForward p
        (((T.pa0 Reader T.cn1 T.mkNoSrcPos p aReader)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                let
                  ga pa p = T.uconstUse pa p sa
                  sa =
                    T.uconstDef p a86v37v86v57a
                      (\ p ->
                        T.uap2 T.mkNoSrcPos p (grunReader T.mkNoSrcPos p)
                          (T.uap1 T.mkNoSrcPos p ff (ga T.mkNoSrcPos p)) fr) in
                  (ga T.mkNoSrcPos p)))) p)
    
  

instance MonadReader (r) ((Reader r))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask =
    T.uconstDef T.mkRoot a89v9v89v29ask
      (\ p -> T.con1 T.mkNoSrcPos p Reader aReader (gid T.mkNoSrcPos p))
  
  glocal plocal p =
    T.ufun2 a90v9v90v44local plocal p hlocal
    where
    
    hlocal ff fm p =
      T.uwrapForward p
        (((T.pa0 Reader T.cn1 T.mkNoSrcPos p aReader)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
              (T.uwrapForward p (hrunReader fm p)) ff)) p)
    
  

gmapReader ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.Fun a b) (T.Fun (Reader r a) (Reader r b)))

hmapReader ::
  (T.R (T.Fun a b)) -> (T.R (Reader r a)) -> T.RefExp -> T.R (Reader r b)

gmapReader pmapReader p = T.ufun2 amapReader pmapReader p hmapReader

hmapReader ff fm p =
  T.uwrapForward p
    (((T.pa0 Reader T.cn1 T.mkNoSrcPos p aReader)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) ff
          (T.uwrapForward p (hrunReader fm p)))) p)

gwithReader ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.Fun r' r) (T.Fun (Reader r a) (Reader r' a)))

hwithReader ::
  (T.R (T.Fun r' r)) -> (T.R (Reader r a)) -> T.RefExp -> T.R (Reader r' a)

gwithReader pwithReader p = T.ufun2 awithReader pwithReader p hwithReader

hwithReader ff fm p =
  T.uwrapForward p
    (((T.pa0 Reader T.cn1 T.mkNoSrcPos p aReader)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.uwrapForward p (hrunReader fm p)) ff)) p)

newtype ReaderT r m a = ReaderT {brunReaderT :: T.R (T.Fun r (m a))}

instance T.WrapVal ((ReaderT r m a))
  where
  
  wrapVal pwrapVal (kwrapVal@(ReaderT (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aReaderT z1wrapVal)
  

grunReaderT prunReaderT p = T.ufun1 arunReaderT prunReaderT p hrunReaderT

hrunReaderT (T.R z1runReaderT _) p =
  T.projection T.mkNoSrcPos p (brunReaderT z1runReaderT)

instance Monad m => Functor ((ReaderT r m))
  where
  
  gfmap pfmap p =
    T.ufun2 a106v9v108v27fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p) fm fr)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fa p ->
                      T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p ff fa)))))) p)
    
  

instance Monad m => Monad ((ReaderT r m))
  where
  
  greturn preturn p =
    T.ufun1 a111v9v111v43return preturn p hreturn
    where
    
    hreturn fa p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ _ p -> T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fa))) p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+##$=##=##$=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p) fm fr)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fa p ->
                      T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p fk fa) fr))))) p)
    
  
  gfail pfail p =
    T.ufun1 a115v9v115v43fail pfail p hfail
    where
    
    hfail fmsg p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ _ p -> T.uap1 T.mkNoSrcPos p (gfail T.mkNoSrcPos p) fmsg))) p)
    
  

instance MonadPlus m => MonadPlus ((ReaderT r m))
  where
  
  gmzero pmzero p = T.uconstUse pmzero p smzero
  
  smzero =
    T.uconstDef T.mkRoot a118v9v118v43mzero
      (\ p ->
        T.uwrapForward p
          (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
              *$
              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                (\ _ p -> gmzero T.mkNoSrcPos p))) p))
  
  gmplus pmplus p =
    T.ufun2 a119v12v119v16mplus pmplus p hmplus
    where
    
    hmplus fm fn p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                T.uap2 T.mkNoSrcPos p (gmplus T.mkNoSrcPos p)
                  (T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p) fm fr)
                  (T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p) fn fr))))
          p)
    
  

instance MonadFix m => MonadFix ((ReaderT r m))
  where
  
  gmfix pmfix p =
    T.ufun1 a122v9v122v64mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                T.uwrapForward p
                  (((gmfix T.mkNoSrcPos p)
                      *$
                      (T.ufun1 T.mkLambda T.mkNoSrcPos p
                        (\ fa p ->
                          T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p)
                            (T.uap1 T.mkNoSrcPos p ff fa) fr))) p)))) p)
    
  

instance Monad m => MonadReader (r) ((ReaderT r m))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask =
    T.uconstDef T.mkRoot a125v9v125v34ask
      (\ p -> T.con1 T.mkNoSrcPos p ReaderT aReaderT (greturn T.mkNoSrcPos p))
  
  glocal plocal p =
    T.ufun2 a126v9v126v53local plocal p hlocal
    where
    
    hlocal ff fm p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fr p ->
                T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p) fm
                  (T.uap1 T.mkNoSrcPos p ff fr)))) p)
    
  

instance MonadTrans ((ReaderT r))
  where
  
  glift plift p =
    T.ufun1 a129v9v129v34lift plift p hlift
    where
    
    hlift fm p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ _ p -> T.projection T.mkNoSrcPos p fm))) p)
    
  

instance MonadIO m => MonadIO ((ReaderT r m))
  where
  
  gliftIO pliftIO p = T.uconstUse pliftIO p sliftIO
  
  sliftIO =
    T.uconstDef T.mkRoot a132v9v132v30liftIO
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gliftIO T.mkNoSrcPos p))
  

gmapReaderT ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (T.Fun (m a) (n b)) (T.Fun (ReaderT w m a) (ReaderT w n b)))

hmapReaderT ::
  (T.R (T.Fun (m a) (n b))) ->
    (T.R (ReaderT w m a)) -> T.RefExp -> T.R (ReaderT w n b)

gmapReaderT pmapReaderT p = T.ufun2 amapReaderT pmapReaderT p hmapReaderT

hmapReaderT ff fm p =
  T.uwrapForward p
    (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) ff
          (T.uwrapForward p (hrunReaderT fm p)))) p)

gwithReaderT ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (T.Fun r' r) (T.Fun (ReaderT r m a) (ReaderT r' m a)))

hwithReaderT ::
  (T.R (T.Fun r' r)) ->
    (T.R (ReaderT r m a)) -> T.RefExp -> T.R (ReaderT r' m a)

gwithReaderT pwithReaderT p = T.ufun2 awithReaderT pwithReaderT p hwithReaderT

hwithReaderT ff fm p =
  T.uwrapForward p
    (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.uwrapForward p (hrunReaderT fm p)) ff)) p)

tControl_Monad_Reader =
  T.mkModule "Control.Monad.Reader" "Control/Monad/Reader.hs" Prelude.False

aReader =
  T.mkConstructorWFields tControl_Monad_Reader 760022 760027 3 1 "Reader"
    (arunReader : [])

aReaderT =
  T.mkConstructorWFields tControl_Monad_Reader 1030025 1030031 3 1 "ReaderT"
    (arunReaderT : [])

aasks =
  T.mkVariable tControl_Monad_Reader 520001 540019 3 1 "asks" Prelude.False

a60v9v60v17fmap =
  T.mkVariable tControl_Monad_Reader 600009 600017 3 0 "fmap" Prelude.False

a63v9v63v23return =
  T.mkVariable tControl_Monad_Reader 630009 630023 3 0 "return" Prelude.False

(++&=##=+&=#%>>=) =
  T.mkVariable tControl_Monad_Reader 640011 640013 6 2 ">>=" Prelude.False

a67v9v67v41mfix =
  T.mkVariable tControl_Monad_Reader 670009 670041 3 1 "mfix" Prelude.False

a70v9v70v22ask =
  T.mkVariable tControl_Monad_Reader 700009 700022 3 0 "ask" Prelude.False

a71v9v71v25local =
  T.mkVariable tControl_Monad_Reader 710009 710025 3 2 "local" Prelude.False

arunReader =
  T.mkVariable tControl_Monad_Reader 760031 760039 3 1 "runReader" Prelude.False

a79v9v79v50fmap =
  T.mkVariable tControl_Monad_Reader 790009 790050 3 2 "fmap" Prelude.False

a82v9v82v35return =
  T.mkVariable tControl_Monad_Reader 820009 820035 3 1 "return" Prelude.False

(+@%=##=@%=#%>>=) =
  T.mkVariable tControl_Monad_Reader 830011 830013 6 2 ">>=" Prelude.False

a86v9v86v62mfix =
  T.mkVariable tControl_Monad_Reader 860009 860062 3 1 "mfix" Prelude.False

a89v9v89v29ask =
  T.mkVariable tControl_Monad_Reader 890009 890029 3 0 "ask" Prelude.False

a90v9v90v44local =
  T.mkVariable tControl_Monad_Reader 900009 900044 3 2 "local" Prelude.False

amapReader =
  T.mkVariable tControl_Monad_Reader 930001 930040 3 2 "mapReader" Prelude.False

awithReader =
  T.mkVariable tControl_Monad_Reader 980001 980041 3 2 "withReader"
    Prelude.False

arunReaderT =
  T.mkVariable tControl_Monad_Reader 1030035 1030044 3 1 "runReaderT"
    Prelude.False

a106v9v108v27fmap =
  T.mkVariable tControl_Monad_Reader 1060009 1080027 3 2 "fmap" Prelude.False

a111v9v111v43return =
  T.mkVariable tControl_Monad_Reader 1110009 1110043 3 1 "return" Prelude.False

(+##$=##=##$=#%>>=) =
  T.mkVariable tControl_Monad_Reader 1120011 1120013 6 2 ">>=" Prelude.False

a115v9v115v43fail =
  T.mkVariable tControl_Monad_Reader 1150009 1150043 3 1 "fail" Prelude.False

a118v9v118v43mzero =
  T.mkVariable tControl_Monad_Reader 1180009 1180043 3 0 "mzero" Prelude.False

a119v12v119v16mplus =
  T.mkVariable tControl_Monad_Reader 1190012 1190016 3 2 "mplus" Prelude.False

a122v9v122v64mfix =
  T.mkVariable tControl_Monad_Reader 1220009 1220064 3 1 "mfix" Prelude.False

a125v9v125v34ask =
  T.mkVariable tControl_Monad_Reader 1250009 1250034 3 0 "ask" Prelude.False

a126v9v126v53local =
  T.mkVariable tControl_Monad_Reader 1260009 1260053 3 2 "local" Prelude.False

a129v9v129v34lift =
  T.mkVariable tControl_Monad_Reader 1290009 1290034 3 1 "lift" Prelude.False

a132v9v132v30liftIO =
  T.mkVariable tControl_Monad_Reader 1320009 1320030 3 0 "liftIO" Prelude.False

amapReaderT =
  T.mkVariable tControl_Monad_Reader 1350001 1350043 3 2 "mapReaderT"
    Prelude.False

awithReaderT =
  T.mkVariable tControl_Monad_Reader 1380001 1380044 3 2 "withReaderT"
    Prelude.False

a67v28v67v36a =
  T.mkVariable tControl_Monad_Reader 670028 670036 3 0 "a" Prelude.True

a86v37v86v57a =
  T.mkVariable tControl_Monad_Reader 860037 860057 3 0 "a" Prelude.True
