module Hat.Control.Monad.State
  (MonadState(..),gmodify,amodify,hmodify,ggets,agets,hgets,State(State
      ,brunState),aState,grunState,hrunState,arunState,gevalState,aevalState
    ,hevalState,gexecState,aexecState,hexecState,gmapState,amapState,hmapState
    ,gwithState,awithState,hwithState,StateT(StateT,brunStateT),aStateT
    ,grunStateT,hrunStateT,arunStateT,gevalStateT,aevalStateT,hevalStateT
    ,gexecStateT,aexecStateT,hexecStateT,gmapStateT,amapStateT,hmapStateT
    ,gwithStateT,awithStateT,hwithStateT,module Hat.Control.Monad
    ,module Hat.Control.Monad.Fix,module Hat.Control.Monad.Trans) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Control.Monad.Fix 
import Hat.Control.Monad.Trans 
import Hat.Control.Monad.Reader 
import Hat.Control.Monad.Writer 

class Monad m => MonadState s m | m->s
  where
  
  gget :: T.RefSrcPos -> T.RefExp -> T.R (m s)
  
  gput :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun s (m T.Tuple0))
  
  sget :: T.R (m s)
  
  sput :: T.R (T.Fun s (m T.Tuple0))
  

gmodify ::
  MonadState s m =>
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun s s) (m T.Tuple0))

hmodify :: MonadState s m => (T.R (T.Fun s s)) -> T.RefExp -> T.R (m T.Tuple0)

gmodify pmodify p = T.ufun1 amodify pmodify p hmodify

hmodify ff p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) (gget T.mkNoSrcPos p)
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fs p ->
        T.uap1 T.mkNoSrcPos p (gput T.mkNoSrcPos p)
          (T.uap1 T.mkNoSrcPos p ff fs)))

ggets ::
  MonadState s m => T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun s a) (m a))

hgets :: MonadState s m => (T.R (T.Fun s a)) -> T.RefExp -> T.R (m a)

ggets pgets p = T.ufun1 agets pgets p hgets

hgets ff p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) (gget T.mkNoSrcPos p)
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fs p ->
        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
          (T.uap1 T.mkNoSrcPos p ff fs)))

newtype State s a = State {brunState :: T.R (T.Fun s (T.Tuple2 a s))}

instance T.WrapVal ((State s a))
  where
  
  wrapVal pwrapVal (kwrapVal@(State (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aState z1wrapVal)
  

grunState prunState p = T.ufun1 arunState prunState p hrunState

hrunState (T.R z1runState _) p =
  T.projection T.mkNoSrcPos p (brunState z1runState)

instance Functor ((State s))
  where
  
  gfmap pfmap p =
    T.ufun2 a99v9v101v28fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 State T.cn1 T.mkNoSrcPos p aState)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                let
                  ga pa p = T.uconstUse pa p sa
                  gs' pa p = T.uconstUse pa p ss'
                  j100v17v100v23a =
                    case
                      T.uap2 T.mkNoSrcPos p (grunState T.mkNoSrcPos p) fm fs of
                      T.R (T.Tuple2 fa fs') ka -> (ka,fa,fs')
                      _ -> T.fatal p
                  sa =
                    T.uconstDef p a100v18v100v18a
                      (\ _ -> case j100v17v100v23a of (ka,fa,fs') -> fa)
                  ss' =
                    T.uconstDef p a100v21v100v22s'
                      (\ _ -> case j100v17v100v23a of (ka,fa,fs') -> fs') in
                  (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                    (T.uap1 T.mkNoSrcPos p ff (ga T.mkNoSrcPos p))
                    (gs' T.mkNoSrcPos p))))) p)
    
  

instance Monad ((State s))
  where
  
  greturn preturn p =
    T.ufun1 a104v9v104v39return preturn p hreturn
    where
    
    hreturn fa p =
      T.uwrapForward p
        (((T.pa0 State T.cn1 T.mkNoSrcPos p aState)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p -> T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa fs))) p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+#!*=##=#!*=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 State T.cn1 T.mkNoSrcPos p aState)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                let
                  ga pa p = T.uconstUse pa p sa
                  gs' pa p = T.uconstUse pa p ss'
                  j106v17v106v23a =
                    case
                      T.uap2 T.mkNoSrcPos p (grunState T.mkNoSrcPos p) fm fs of
                      T.R (T.Tuple2 fa fs') ka -> (ka,fa,fs')
                      _ -> T.fatal p
                  sa =
                    T.uconstDef p a106v18v106v18a
                      (\ _ -> case j106v17v106v23a of (ka,fa,fs') -> fa)
                  ss' =
                    T.uconstDef p a106v21v106v22s'
                      (\ _ -> case j106v17v106v23a of (ka,fa,fs') -> fs') in
                  (T.uap2 T.mkNoSrcPos p (grunState T.mkNoSrcPos p)
                    (T.uap1 T.mkNoSrcPos p fk (ga T.mkNoSrcPos p))
                    (gs' T.mkNoSrcPos p))))) p)
    
  

instance MonadFix ((State s))
  where
  
  gmfix pmfix p =
    T.ufun1 a110v9v110v72mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.uwrapForward p
        (((T.pa0 State T.cn1 T.mkNoSrcPos p aState)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                let
                  ga pa p = T.uconstUse pa p sa
                  gs' pa p = T.uconstUse pa p ss'
                  j110v36v110v42a =
                    case
                      T.uap2 T.mkNoSrcPos p (grunState T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p ff (ga T.mkNoSrcPos p)) fs of
                      T.R (T.Tuple2 fa fs') ka -> (ka,fa,fs')
                      _ -> T.fatal p
                  sa =
                    T.uconstDef p a110v37v110v37a
                      (\ _ -> case j110v36v110v42a of (ka,fa,fs') -> fa)
                  ss' =
                    T.uconstDef p a110v40v110v41s'
                      (\ _ -> case j110v36v110v42a of (ka,fa,fs') -> fs') in
                  (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (ga T.mkNoSrcPos p)
                    (gs' T.mkNoSrcPos p))))) p)
    
  

instance MonadState (s) ((State s))
  where
  
  gget pget p = T.uconstUse pget p sget
  
  sget =
    T.uconstDef T.mkRoot a113v9v113v36get
      (\ p ->
        T.uwrapForward p
          (((T.pa0 State T.cn1 T.mkNoSrcPos p aState)
              *$
              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                (\ fs p -> T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fs fs))) p))
  
  gput pput p =
    T.ufun1 a114v9v114v38put pput p hput
    where
    
    hput fs p =
      T.uwrapForward p
        (((T.pa0 State T.cn1 T.mkNoSrcPos p aState)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ _ p ->
                T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                  (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0) fs))) p)
    
  

gevalState :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (State s a) (T.Fun s a))

hevalState :: (T.R (State s a)) -> (T.R s) -> T.RefExp -> T.R a

gevalState pevalState p = T.ufun2 aevalState pevalState p hevalState

hevalState fm fs p =
  T.uwrapForward p
    (hfst (T.uap2 T.mkNoSrcPos p (grunState T.mkNoSrcPos p) fm fs) p)

gexecState :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (State s a) (T.Fun s s))

hexecState :: (T.R (State s a)) -> (T.R s) -> T.RefExp -> T.R s

gexecState pexecState p = T.ufun2 aexecState pexecState p hexecState

hexecState fm fs p =
  T.uwrapForward p
    (hsnd (T.uap2 T.mkNoSrcPos p (grunState T.mkNoSrcPos p) fm fs) p)

gmapState ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (T.Tuple2 a s) (T.Tuple2 b s))
          (T.Fun (State s a) (State s b)))

hmapState ::
  (T.R (T.Fun (T.Tuple2 a s) (T.Tuple2 b s))) ->
    (T.R (State s a)) -> T.RefExp -> T.R (State s b)

gmapState pmapState p = T.ufun2 amapState pmapState p hmapState

hmapState ff fm p =
  T.uwrapForward p
    (((T.pa0 State T.cn1 T.mkNoSrcPos p aState)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) ff
          (T.uwrapForward p (hrunState fm p)))) p)

gwithState ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.Fun s s) (T.Fun (State s a) (State s a)))

hwithState ::
  (T.R (T.Fun s s)) -> (T.R (State s a)) -> T.RefExp -> T.R (State s a)

gwithState pwithState p = T.ufun2 awithState pwithState p hwithState

hwithState ff fm p =
  T.uwrapForward p
    (((T.pa0 State T.cn1 T.mkNoSrcPos p aState)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.uwrapForward p (hrunState fm p)) ff)) p)

newtype StateT s m a = StateT {brunStateT :: T.R (T.Fun s (m (T.Tuple2 a s)))}

instance T.WrapVal ((StateT s m a))
  where
  
  wrapVal pwrapVal (kwrapVal@(StateT (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aStateT z1wrapVal)
  

grunStateT prunStateT p = T.ufun1 arunStateT prunStateT p hrunStateT

hrunStateT (T.R z1runStateT _) p =
  T.projection T.mkNoSrcPos p (brunStateT z1runStateT)

instance Monad m => Functor ((StateT s m))
  where
  
  gfmap pfmap p =
    T.ufun2 a185v9v187v32fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fm fs)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fv186v28v186v40v1 p ->
                      T.uccase T.mkNoSrcPos p
                        (let
                          v186v28v186v40v1 (T.R (T.Tuple2 fx fs') _) p =
                            T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                                (T.uap1 T.mkNoSrcPos p ff fx) fs')
                          v186v28v186v40v1 _ p =
                            T.uap1 T.mkNoSrcPos p
                              (Hat.Prelude.gfail T.mkNoSrcPos p)
                              (T.fromLitString T.mkNoSrcPos p
                                "pattern-match failure in do expression") in
                          (v186v28v186v40v1)) fv186v28v186v40v1))))) p)
    
  

instance Monad m => Monad ((StateT s m))
  where
  
  greturn preturn p =
    T.ufun1 a190v9v190v47return preturn p hreturn
    where
    
    hreturn fa p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                  (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa fs)))) p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+#>#=##=#>#=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fm fs)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fv192v28v192v40v1 p ->
                      T.uccase T.mkNoSrcPos p
                        (let
                          v192v28v192v40v1 (T.R (T.Tuple2 fa fs') _) p =
                            T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p)
                              (T.uap1 T.mkNoSrcPos p fk fa) fs'
                          v192v28v192v40v1 _ p =
                            T.uap1 T.mkNoSrcPos p
                              (Hat.Prelude.gfail T.mkNoSrcPos p)
                              (T.fromLitString T.mkNoSrcPos p
                                "pattern-match failure in do expression") in
                          (v192v28v192v40v1)) fv192v28v192v40v1))))) p)
    
  
  gfail pfail p =
    T.ufun1 a194v9v194v42fail pfail p hfail
    where
    
    hfail fstr p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ _ p -> T.uap1 T.mkNoSrcPos p (gfail T.mkNoSrcPos p) fstr))) p)
    
  

instance MonadPlus m => MonadPlus ((StateT s m))
  where
  
  gmzero pmzero p = T.uconstUse pmzero p smzero
  
  smzero =
    T.uconstDef T.mkRoot a197v9v197v42mzero
      (\ p ->
        T.uwrapForward p
          (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
              *$
              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                (\ _ p -> gmzero T.mkNoSrcPos p))) p))
  
  gmplus pmplus p =
    T.ufun2 a198v12v198v16mplus pmplus p hmplus
    where
    
    hmplus fm fn p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uap2 T.mkNoSrcPos p (gmplus T.mkNoSrcPos p)
                  (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fm fs)
                  (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fn fs))))
          p)
    
  

instance MonadFix m => MonadFix ((StateT s m))
  where
  
  gmfix pmfix p =
    T.ufun1 a201v9v201v69mfix pmfix p hmfix
    where
    
    hmfix ff p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uwrapForward p
                  (((gmfix T.mkNoSrcPos p)
                      *$
                      (T.ufun1 T.mkLambda T.mkNoSrcPos p
                        (\ (T.R ~(T.Tuple2 fa _) _) p ->
                          let
                            ga pa p = T.uconstUse pa p sa
                            sa =
                              T.uconstDef p a0v0v0v0a
                                (\ p -> T.projection T.mkNoSrcPos p fa) in
                            (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p)
                              (T.uap1 T.mkNoSrcPos p ff (ga T.mkNoSrcPos p))
                              fs)))) p)))) p)
    
  

instance Monad m => MonadState (s) ((StateT s m))
  where
  
  gget pget p = T.uconstUse pget p sget
  
  sget =
    T.uconstDef T.mkRoot a204v9v204v44get
      (\ p ->
        T.uwrapForward p
          (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
              *$
              (T.ufun1 T.mkLambda T.mkNoSrcPos p
                (\ fs p ->
                  T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                    (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fs fs)))) p))
  
  gput pput p =
    T.ufun1 a205v9v205v46put pput p hput
    where
    
    hput fs p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ _ p ->
                T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                  (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                    (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0) fs)))) p)
    
  

instance MonadTrans ((StateT s))
  where
  
  glift plift p =
    T.ufun1 a208v9v210v29lift plift p hlift
    where
    
    hlift fm p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fm
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fa p ->
                      T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                        (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa fs)))))) p)
    
  

instance MonadIO m => MonadIO ((StateT s m))
  where
  
  gliftIO pliftIO p = T.uconstUse pliftIO p sliftIO
  
  sliftIO =
    T.uconstDef T.mkRoot a213v9v213v30liftIO
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gliftIO T.mkNoSrcPos p))
  

instance MonadReader r m => MonadReader (r) ((StateT s m))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask =
    T.uconstDef T.mkRoot a216v9v216v28ask
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gask T.mkNoSrcPos p))
  
  glocal plocal p =
    T.ufun2 a217v9v217v57local plocal p hlocal
    where
    
    hlocal ff fm p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uap2 T.mkNoSrcPos p (glocal T.mkNoSrcPos p) ff
                  (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fm fs))))
          p)
    
  

instance MonadWriter w m => MonadWriter (w) ((StateT s m))
  where
  
  gtell ptell p = T.uconstUse ptell p stell
  
  stell =
    T.uconstDef T.mkRoot a220v9v220v30tell
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gtell T.mkNoSrcPos p))
  
  glisten plisten p =
    T.ufun1 a221v9v223v35listen plisten p hlisten
    where
    
    hlisten fm p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uap1 T.mkNoSrcPos p (glisten T.mkNoSrcPos p)
                    (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fm fs))
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fv222v33v222v53v1 p ->
                      T.uccase T.mkNoSrcPos p
                        (let
                          v222v33v222v53v1
                            (T.R (T.Tuple2 (T.R (T.Tuple2 fa fs') _) fw) _) p =
                            T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                                (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa fw)
                                fs')
                          v222v33v222v53v1 _ p =
                            T.uap1 T.mkNoSrcPos p
                              (Hat.Prelude.gfail T.mkNoSrcPos p)
                              (T.fromLitString T.mkNoSrcPos p
                                "pattern-match failure in do expression") in
                          (v222v33v222v53v1)) fv222v33v222v53v1))))) p)
    
  
  gpass ppass p =
    T.ufun1 a224v9v226v35pass ppass p hpass
    where
    
    hpass fm p =
      T.uwrapForward p
        (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fs p ->
                T.uwrapForward p
                  (((gpass T.mkNoSrcPos p)
                      *$
                      (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                        (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fm
                          fs)
                        (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                          (\ fv225v33v225v45v1 p ->
                            T.uccase T.mkNoSrcPos p
                              (let
                                v225v33v225v45v1
                                  (T.R (T.Tuple2 (T.R (T.Tuple2 fa ff) _) fs')
                                    _) p =
                                  T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                                    (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                                      (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                                        fa fs') ff)
                                v225v33v225v45v1 _ p =
                                  T.uap1 T.mkNoSrcPos p
                                    (Hat.Prelude.gfail T.mkNoSrcPos p)
                                    (T.fromLitString T.mkNoSrcPos p
                                      "pattern-match failure in do expression")
                                in (v225v33v225v45v1)) fv225v33v225v45v1))))
                    p)))) p)
    
  

gevalStateT ::
  Monad m =>
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (StateT s m a) (T.Fun s (m a)))

hevalStateT ::
  Monad m => (T.R (StateT s m a)) -> (T.R s) -> T.RefExp -> T.R (m a)

gevalStateT pevalStateT p = T.ufun2 aevalStateT pevalStateT p hevalStateT

hevalStateT fm fs p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
    (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fm fs)
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fv231v19v231v31v1 p ->
        T.uccase T.mkNoSrcPos p
          (let
            v231v19v231v31v1 (T.R (T.Tuple2 fa _) _) p =
              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fa
            v231v19v231v31v1 _ p =
              T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                (T.fromLitString T.mkNoSrcPos p
                  "pattern-match failure in do expression") in
            (v231v19v231v31v1)) fv231v19v231v31v1))

gexecStateT ::
  Monad m =>
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (StateT s m a) (T.Fun s (m s)))

hexecStateT ::
  Monad m => (T.R (StateT s m a)) -> (T.R s) -> T.RefExp -> T.R (m s)

gexecStateT pexecStateT p = T.ufun2 aexecStateT pexecStateT p hexecStateT

hexecStateT fm fs p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
    (T.uap2 T.mkNoSrcPos p (grunStateT T.mkNoSrcPos p) fm fs)
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fv237v20v237v32v1 p ->
        T.uccase T.mkNoSrcPos p
          (let
            v237v20v237v32v1 (T.R (T.Tuple2 _ fs') _) p =
              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fs'
            v237v20v237v32v1 _ p =
              T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                (T.fromLitString T.mkNoSrcPos p
                  "pattern-match failure in do expression") in
            (v237v20v237v32v1)) fv237v20v237v32v1))

gmapStateT ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (m (T.Tuple2 a s)) (n (T.Tuple2 b s)))
          (T.Fun (StateT s m a) (StateT s n b)))

hmapStateT ::
  (T.R (T.Fun (m (T.Tuple2 a s)) (n (T.Tuple2 b s)))) ->
    (T.R (StateT s m a)) -> T.RefExp -> T.R (StateT s n b)

gmapStateT pmapStateT p = T.ufun2 amapStateT pmapStateT p hmapStateT

hmapStateT ff fm p =
  T.uwrapForward p
    (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) ff
          (T.uwrapForward p (hrunStateT fm p)))) p)

gwithStateT ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.Fun s s) (T.Fun (StateT s m a) (StateT s m a)))

hwithStateT ::
  (T.R (T.Fun s s)) -> (T.R (StateT s m a)) -> T.RefExp -> T.R (StateT s m a)

gwithStateT pwithStateT p = T.ufun2 awithStateT pwithStateT p hwithStateT

hwithStateT ff fm p =
  T.uwrapForward p
    (((T.pa0 StateT T.cn1 T.mkNoSrcPos p aStateT)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.uwrapForward p (hrunStateT fm p)) ff)) p)

instance MonadState s m => MonadState (s) ((ReaderT r m))
  where
  
  gget pget p = T.uconstUse pget p sget
  
  sget =
    T.uconstDef T.mkRoot a252v9v252v22get
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gget T.mkNoSrcPos p))
  
  gput pput p = T.uconstUse pput p sput
  
  sput =
    T.uconstDef T.mkRoot a253v9v253v24put
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gput T.mkNoSrcPos p))
  

instance (Monoid w,MonadState s m) => MonadState (s) ((WriterT w m))
  where
  
  gget pget p = T.uconstUse pget p sget
  
  sget =
    T.uconstDef T.mkRoot a256v9v256v22get
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gget T.mkNoSrcPos p))
  
  gput pput p = T.uconstUse pput p sput
  
  sput =
    T.uconstDef T.mkRoot a257v9v257v24put
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gput T.mkNoSrcPos p))
  

tControl_Monad_State =
  T.mkModule "Control.Monad.State" "Control/Monad/State.hs" Prelude.False

aState =
  T.mkConstructorWFields tControl_Monad_State 940021 940025 3 1 "State"
    (arunState : [])

aStateT =
  T.mkConstructorWFields tControl_Monad_State 1820024 1820029 3 1 "StateT"
    (arunStateT : [])

amodify =
  T.mkVariable tControl_Monad_State 780001 800016 3 1 "modify" Prelude.False

agets = T.mkVariable tControl_Monad_State 860001 880019 3 1 "gets" Prelude.False

arunState =
  T.mkVariable tControl_Monad_State 940029 940036 3 1 "runState" Prelude.False

a99v9v101v28fmap =
  T.mkVariable tControl_Monad_State 990009 1010028 3 2 "fmap" Prelude.False

a104v9v104v39return =
  T.mkVariable tControl_Monad_State 1040009 1040039 3 1 "return" Prelude.False

(+#!*=##=#!*=#%>>=) =
  T.mkVariable tControl_Monad_State 1050011 1050013 6 2 ">>=" Prelude.False

a110v9v110v72mfix =
  T.mkVariable tControl_Monad_State 1100009 1100072 3 1 "mfix" Prelude.False

a113v9v113v36get =
  T.mkVariable tControl_Monad_State 1130009 1130036 3 0 "get" Prelude.False

a114v9v114v38put =
  T.mkVariable tControl_Monad_State 1140009 1140038 3 1 "put" Prelude.False

aevalState =
  T.mkVariable tControl_Monad_State 1230001 1230033 3 2 "evalState"
    Prelude.False

aexecState =
  T.mkVariable tControl_Monad_State 1320001 1320033 3 2 "execState"
    Prelude.False

amapState =
  T.mkVariable tControl_Monad_State 1440001 1440037 3 2 "mapState" Prelude.False

awithState =
  T.mkVariable tControl_Monad_State 1480001 1480038 3 2 "withState"
    Prelude.False

arunStateT =
  T.mkVariable tControl_Monad_State 1820033 1820041 3 1 "runStateT"
    Prelude.False

a185v9v187v32fmap =
  T.mkVariable tControl_Monad_State 1850009 1870032 3 2 "fmap" Prelude.False

a190v9v190v47return =
  T.mkVariable tControl_Monad_State 1900009 1900047 3 1 "return" Prelude.False

(+#>#=##=#>#=#%>>=) =
  T.mkVariable tControl_Monad_State 1910011 1910013 6 2 ">>=" Prelude.False

a194v9v194v42fail =
  T.mkVariable tControl_Monad_State 1940009 1940042 3 1 "fail" Prelude.False

a197v9v197v42mzero =
  T.mkVariable tControl_Monad_State 1970009 1970042 3 0 "mzero" Prelude.False

a198v12v198v16mplus =
  T.mkVariable tControl_Monad_State 1980012 1980016 3 2 "mplus" Prelude.False

a201v9v201v69mfix =
  T.mkVariable tControl_Monad_State 2010009 2010069 3 1 "mfix" Prelude.False

a204v9v204v44get =
  T.mkVariable tControl_Monad_State 2040009 2040044 3 0 "get" Prelude.False

a205v9v205v46put =
  T.mkVariable tControl_Monad_State 2050009 2050046 3 1 "put" Prelude.False

a208v9v210v29lift =
  T.mkVariable tControl_Monad_State 2080009 2100029 3 1 "lift" Prelude.False

a213v9v213v30liftIO =
  T.mkVariable tControl_Monad_State 2130009 2130030 3 0 "liftIO" Prelude.False

a216v9v216v28ask =
  T.mkVariable tControl_Monad_State 2160009 2160028 3 0 "ask" Prelude.False

a217v9v217v57local =
  T.mkVariable tControl_Monad_State 2170009 2170057 3 2 "local" Prelude.False

a220v9v220v30tell =
  T.mkVariable tControl_Monad_State 2200009 2200030 3 0 "tell" Prelude.False

a221v9v223v35listen =
  T.mkVariable tControl_Monad_State 2210009 2230035 3 1 "listen" Prelude.False

a224v9v226v35pass =
  T.mkVariable tControl_Monad_State 2240009 2260035 3 1 "pass" Prelude.False

aevalStateT =
  T.mkVariable tControl_Monad_State 2300001 2320016 3 2 "evalStateT"
    Prelude.False

aexecStateT =
  T.mkVariable tControl_Monad_State 2360001 2380017 3 2 "execStateT"
    Prelude.False

amapStateT =
  T.mkVariable tControl_Monad_State 2420001 2420040 3 2 "mapStateT"
    Prelude.False

awithStateT =
  T.mkVariable tControl_Monad_State 2460001 2460041 3 2 "withStateT"
    Prelude.False

a252v9v252v22get =
  T.mkVariable tControl_Monad_State 2520009 2520022 3 0 "get" Prelude.False

a253v9v253v24put =
  T.mkVariable tControl_Monad_State 2530009 2530024 3 0 "put" Prelude.False

a256v9v256v22get =
  T.mkVariable tControl_Monad_State 2560009 2560022 3 0 "get" Prelude.False

a257v9v257v24put =
  T.mkVariable tControl_Monad_State 2570009 2570024 3 0 "put" Prelude.False

a100v18v100v18a =
  T.mkVariable tControl_Monad_State 1000018 1000018 3 0 "a" Prelude.True

a100v21v100v22s' =
  T.mkVariable tControl_Monad_State 1000021 1000022 3 0 "s'" Prelude.True

a106v18v106v18a =
  T.mkVariable tControl_Monad_State 1060018 1060018 3 0 "a" Prelude.True

a106v21v106v22s' =
  T.mkVariable tControl_Monad_State 1060021 1060022 3 0 "s'" Prelude.True

a110v37v110v37a =
  T.mkVariable tControl_Monad_State 1100037 1100037 3 0 "a" Prelude.True

a110v40v110v41s' =
  T.mkVariable tControl_Monad_State 1100040 1100041 3 0 "s'" Prelude.True

a0v0v0v0a = T.mkVariable tControl_Monad_State 0 0 3 0 "a" Prelude.True
