module Hat.Control.Monad.Writer
  (MonadWriter(..),glistens,alistens,hlistens,gcensor,acensor,hcensor
    ,Writer(Writer,brunWriter),aWriter,grunWriter,hrunWriter,arunWriter
    ,gexecWriter,aexecWriter,hexecWriter,gmapWriter,amapWriter,hmapWriter
    ,WriterT(WriterT,brunWriterT),aWriterT,grunWriterT,hrunWriterT,arunWriterT
    ,gexecWriterT,aexecWriterT,hexecWriterT,gmapWriterT,amapWriterT,hmapWriterT
    ,module Hat.Control.Monad,module Hat.Control.Monad.Fix
    ,module Hat.Control.Monad.Trans,module Hat.Data.Monoid) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Control.Monad.Fix 
import Hat.Control.Monad.Trans 
import Hat.Control.Monad.Reader 
import Hat.Data.Monoid 

class (Monoid w,Monad m) => MonadWriter w m | m->w
  where
  
  gtell :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun w (m T.Tuple0))
  
  glisten :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (m a) (m (T.Tuple2 a w)))
  
  gpass ::
    T.RefSrcPos -> T.RefExp -> T.R (T.Fun (m (T.Tuple2 a (T.Fun w w))) (m a))
  
  stell :: T.R (T.Fun w (m T.Tuple0))
  
  slisten :: T.R (T.Fun (m a) (m (T.Tuple2 a w)))
  
  spass :: T.R (T.Fun (m (T.Tuple2 a (T.Fun w w))) (m a))
  

glistens ::
  MonadWriter w m =>
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.Fun w w) (T.Fun (m a) (m (T.Tuple2 a w))))

hlistens ::
  MonadWriter w m =>
  (T.R (T.Fun w w)) -> (T.R (m a)) -> T.RefExp -> T.R (m (T.Tuple2 a w))

glistens plistens p = T.ufun2 alistens plistens p hlistens

hlistens ff fm p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
    (T.uap1 T.mkNoSrcPos p (glisten T.mkNoSrcPos p) fm)
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fv64v19v64v26v1 p ->
        T.uccase T.mkNoSrcPos p
          (let
            v64v19v64v26v1 (T.R (T.Tuple2 fa fw) _) p =
              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa
                  (T.uap1 T.mkNoSrcPos p ff fw))
            v64v19v64v26v1 _ p =
              T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                (T.fromLitString T.mkNoSrcPos p
                  "pattern-match failure in do expression") in (v64v19v64v26v1))
          fv64v19v64v26v1))

gcensor ::
  MonadWriter w m =>
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun w w) (T.Fun (m a) (m a)))

hcensor ::
  MonadWriter w m => (T.R (T.Fun w w)) -> (T.R (m a)) -> T.RefExp -> T.R (m a)

gcensor pcensor p = T.ufun2 acensor pcensor p hcensor

hcensor ff fm p =
  T.uwrapForward p
    (((gpass T.mkNoSrcPos p)
        *$
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fm
          (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
            (\ fa p ->
              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa ff))))) p)

newtype Writer w a = Writer {brunWriter :: T.R (T.Tuple2 a w)}

instance T.WrapVal ((Writer w a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Writer (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aWriter z1wrapVal)
  

grunWriter prunWriter p = T.ufun1 arunWriter prunWriter p hrunWriter

hrunWriter (T.R z1runWriter _) p =
  T.projection T.mkNoSrcPos p (brunWriter z1runWriter)

instance Functor ((Writer w))
  where
  
  gfmap pfmap p =
    T.ufun2 a79v9v79v64fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 Writer T.cn1 T.mkNoSrcPos p aWriter)
            *$
            (let
              ga pa p = T.uconstUse pa p sa
              gw pa p = T.uconstUse pa p sw
              j79v33v79v38a =
                case T.uwrapForward p (hrunWriter fm p) of
                  T.R (T.Tuple2 fa fw) ka -> (ka,fa,fw)
                  _ -> T.fatal p
              sa =
                T.uconstDef p a79v34v79v34a
                  (\ _ -> case j79v33v79v38a of (ka,fa,fw) -> fa)
              sw =
                T.uconstDef p a79v37v79v37w
                  (\ _ -> case j79v33v79v38a of (ka,fa,fw) -> fw) in
              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                (T.uap1 T.mkNoSrcPos p ff (ga T.mkNoSrcPos p))
                (gw T.mkNoSrcPos p)))) p)
    
  

instance Monoid w => Monad ((Writer w))
  where
  
  greturn preturn p =
    T.ufun1 a82v9v82v37return preturn p hreturn
    where
    
    hreturn fa p =
      T.con1 T.mkNoSrcPos p Writer aWriter
        (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa (gmempty T.mkNoSrcPos p))
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+@%=##=@%=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 Writer T.cn1 T.mkNoSrcPos p aWriter)
            *$
            (let
              ga pa p = T.uconstUse pa p sa
              gw pa p = T.uconstUse pa p sw
              j84v17v84v22a =
                case T.uwrapForward p (hrunWriter fm p) of
                  T.R (T.Tuple2 fa fw) ka -> (ka,fa,fw)
                  _ -> T.fatal p
              sa =
                T.uconstDef p a84v18v84v18a
                  (\ _ -> case j84v17v84v22a of (ka,fa,fw) -> fa)
              sw =
                T.uconstDef p a84v21v84v21w
                  (\ _ -> case j84v17v84v22a of (ka,fa,fw) -> fw)
              gb pb p = T.uconstUse pb p sb
              gw' pb p = T.uconstUse pb p sw'
              j85v17v85v23b =
                case
                  T.uwrapForward p
                    (hrunWriter (T.uap1 T.mkNoSrcPos p fk (ga T.mkNoSrcPos p))
                      p) of
                  T.R (T.Tuple2 fb fw') kb -> (kb,fb,fw')
                  _ -> T.fatal p
              sb =
                T.uconstDef p a85v18v85v18b
                  (\ _ -> case j85v17v85v23b of (kb,fb,fw') -> fb)
              sw' =
                T.uconstDef p a85v21v85v22w'
                  (\ _ -> case j85v17v85v23b of (kb,fb,fw') -> fw') in
              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (gb T.mkNoSrcPos p)
                (T.uap2 T.mkNoSrcPos p (gmappend T.mkNoSrcPos p)
                  (gw T.mkNoSrcPos p) (gw' T.mkNoSrcPos p))))) p)
    
  

instance Monoid w => MonadFix ((Writer w))
  where
  
  gmfix pmfix p =
    T.ufun1 a89v9v89v64mfix pmfix p hmfix
    where
    
    hmfix fm p =
      T.uwrapForward p
        (((T.pa0 Writer T.cn1 T.mkNoSrcPos p aWriter)
            *$
            (let
              ga pa p = T.uconstUse pa p sa
              gw pa p = T.uconstUse pa p sw
              j89v31v89v36a =
                case
                  T.uwrapForward p
                    (hrunWriter (T.uap1 T.mkNoSrcPos p fm (ga T.mkNoSrcPos p))
                      p) of
                  T.R (T.Tuple2 fa fw) ka -> (ka,fa,fw)
                  _ -> T.fatal p
              sa =
                T.uconstDef p a89v32v89v32a
                  (\ _ -> case j89v31v89v36a of (ka,fa,fw) -> fa)
              sw =
                T.uconstDef p a89v35v89v35w
                  (\ _ -> case j89v31v89v36a of (ka,fa,fw) -> fw) in
              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (ga T.mkNoSrcPos p)
                (gw T.mkNoSrcPos p)))) p)
    
  

instance Monoid w => MonadWriter (w) ((Writer w))
  where
  
  gtell ptell p =
    T.ufun1 a92v9v92v34tell ptell p htell
    where
    
    htell fw p =
      T.con1 T.mkNoSrcPos p Writer aWriter
        (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
          (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0) fw)
    
  
  glisten plisten p =
    T.ufun1 a93v9v93v67listen plisten p hlisten
    where
    
    hlisten fm p =
      T.uwrapForward p
        (((T.pa0 Writer T.cn1 T.mkNoSrcPos p aWriter)
            *$
            (let
              ga pa p = T.uconstUse pa p sa
              gw pa p = T.uconstUse pa p sw
              j93v33v93v38a =
                case T.uwrapForward p (hrunWriter fm p) of
                  T.R (T.Tuple2 fa fw) ka -> (ka,fa,fw)
                  _ -> T.fatal p
              sa =
                T.uconstDef p a93v34v93v34a
                  (\ _ -> case j93v33v93v38a of (ka,fa,fw) -> fa)
              sw =
                T.uconstDef p a93v37v93v37w
                  (\ _ -> case j93v33v93v38a of (ka,fa,fw) -> fw) in
              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (ga T.mkNoSrcPos p)
                  (gw T.mkNoSrcPos p)) (gw T.mkNoSrcPos p)))) p)
    
  
  gpass ppass p =
    T.ufun1 a94v9v94v69pass ppass p hpass
    where
    
    hpass fm p =
      T.uwrapForward p
        (((T.pa0 Writer T.cn1 T.mkNoSrcPos p aWriter)
            *$
            (let
              ga pa p = T.uconstUse pa p sa
              gf pa p = T.uconstUse pa p sf
              gw pa p = T.uconstUse pa p sw
              j94v33v94v43a =
                case T.uwrapForward p (hrunWriter fm p) of
                  T.R (T.Tuple2 (T.R (T.Tuple2 fa ff) _) fw) ka -> (ka,fa,ff,fw)
                  _ -> T.fatal p
              sa =
                T.uconstDef p a94v35v94v35a
                  (\ _ -> case j94v33v94v43a of (ka,fa,ff,fw) -> fa)
              sf =
                T.uconstDef p a94v38v94v38f
                  (\ _ -> case j94v33v94v43a of (ka,fa,ff,fw) -> ff)
              sw =
                T.uconstDef p a94v42v94v42w
                  (\ _ -> case j94v33v94v43a of (ka,fa,ff,fw) -> fw) in
              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (ga T.mkNoSrcPos p)
                (T.uap1 T.mkNoSrcPos p (gf T.mkNoSrcPos p)
                  (gw T.mkNoSrcPos p))))) p)
    
  

gexecWriter :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (Writer w a) w)

hexecWriter :: (T.R (Writer w a)) -> T.RefExp -> T.R w

gexecWriter pexecWriter p = T.ufun1 aexecWriter pexecWriter p hexecWriter

hexecWriter fm p =
  T.uwrapForward p (hsnd (T.uwrapForward p (hrunWriter fm p)) p)

gmapWriter ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (T.Tuple2 a w) (T.Tuple2 b w'))
          (T.Fun (Writer w a) (Writer w' b)))

hmapWriter ::
  (T.R (T.Fun (T.Tuple2 a w) (T.Tuple2 b w'))) ->
    (T.R (Writer w a)) -> T.RefExp -> T.R (Writer w' b)

gmapWriter pmapWriter p = T.ufun2 amapWriter pmapWriter p hmapWriter

hmapWriter ff fm p =
  T.uwrapForward p
    (((T.pa0 Writer T.cn1 T.mkNoSrcPos p aWriter)
        *$
        (T.uap1 T.mkNoSrcPos p ff (T.uwrapForward p (hrunWriter fm p)))) p)

newtype WriterT w m a = WriterT {brunWriterT :: T.R (m (T.Tuple2 a w))}

instance T.WrapVal ((WriterT w m a))
  where
  
  wrapVal pwrapVal (kwrapVal@(WriterT (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aWriterT z1wrapVal)
  

grunWriterT prunWriterT p = T.ufun1 arunWriterT prunWriterT p hrunWriterT

hrunWriterT (T.R z1runWriterT _) p =
  T.projection T.mkNoSrcPos p (brunWriterT z1runWriterT)

instance Monad m => Functor ((WriterT w m))
  where
  
  gfmap pfmap p =
    T.ufun2 a110v9v112v31fmap pfmap p hfmap
    where
    
    hfmap ff fm p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunWriterT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fv111v27v111v38v1 p ->
                  T.uccase T.mkNoSrcPos p
                    (let
                      v111v27v111v38v1 (T.R (T.Tuple2 fa fw) _) p =
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                            (T.uap1 T.mkNoSrcPos p ff fa) fw)
                      v111v27v111v38v1 _ p =
                        T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                          (T.fromLitString T.mkNoSrcPos p
                            "pattern-match failure in do expression") in
                      (v111v27v111v38v1)) fv111v27v111v38v1)))) p)
    
  

instance (Monoid w,Monad m) => Monad ((WriterT w m))
  where
  
  greturn preturn p =
    T.ufun1 a115v9v115v47return preturn p hreturn
    where
    
    hreturn fa p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa
                (gmempty T.mkNoSrcPos p)))) p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+##+=##=##+=#%>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fm fk p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunWriterT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fv117v28v117v39v1 p ->
                  T.uccase T.mkNoSrcPos p
                    (let
                      v117v28v117v39v1 (T.R (T.Tuple2 fa fw) _) p =
                        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                          (T.uwrapForward p
                            (hrunWriterT (T.uap1 T.mkNoSrcPos p fk fa) p))
                          (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                            (\ fv118v28v118v42v1 p ->
                              T.uccase T.mkNoSrcPos p
                                (let
                                  v118v28v118v42v1 (T.R (T.Tuple2 fb fw') _) p =
                                    T.uap1 T.mkNoSrcPos p
                                      (greturn T.mkNoSrcPos p)
                                      (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                                        fb
                                        (T.uap2 T.mkNoSrcPos p
                                          (gmappend T.mkNoSrcPos p) fw fw'))
                                  v118v28v118v42v1 _ p =
                                    T.uap1 T.mkNoSrcPos p
                                      (Hat.Prelude.gfail T.mkNoSrcPos p)
                                      (T.fromLitString T.mkNoSrcPos p
                                        "pattern-match failure in do expression")
                                  in (v118v28v118v42v1)) fv118v28v118v42v1))
                      v117v28v117v39v1 _ p =
                        T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                          (T.fromLitString T.mkNoSrcPos p
                            "pattern-match failure in do expression") in
                      (v117v28v117v39v1)) fv117v28v117v39v1)))) p)
    
  
  gfail pfail p =
    T.ufun1 a120v9v120v37fail pfail p hfail
    where
    
    hfail fmsg p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap1 T.mkNoSrcPos p (gfail T.mkNoSrcPos p) fmsg)) p)
    
  

instance (Monoid w,MonadPlus m) => MonadPlus ((WriterT w m))
  where
  
  gmzero pmzero p = T.uconstUse pmzero p smzero
  
  smzero =
    T.uconstDef T.mkRoot a123v9v123v35mzero
      (\ p -> T.con1 T.mkNoSrcPos p WriterT aWriterT (gmzero T.mkNoSrcPos p))
  
  gmplus pmplus p =
    T.ufun2 a124v12v124v16mplus pmplus p hmplus
    where
    
    hmplus fm fn p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap2 T.mkNoSrcPos p (gmplus T.mkNoSrcPos p)
              (T.uwrapForward p (hrunWriterT fm p))
              (T.uwrapForward p (hrunWriterT fn p)))) p)
    
  

instance (Monoid w,MonadFix m) => MonadFix ((WriterT w m))
  where
  
  gmfix pmfix p =
    T.ufun1 a127v9v127v62mfix pmfix p hmfix
    where
    
    hmfix fm p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uwrapForward p
              (((gmfix T.mkNoSrcPos p)
                  *$
                  (T.ufun1 T.mkLambda T.mkNoSrcPos p
                    (\ (T.R ~(T.Tuple2 fa _) _) p ->
                      let
                        ga pa p = T.uconstUse pa p sa
                        sa =
                          T.uconstDef p a0v0v0v0a
                            (\ p -> T.projection T.mkNoSrcPos p fa) in
                        (T.uwrapForward p
                          (hrunWriterT
                            (T.uap1 T.mkNoSrcPos p fm (ga T.mkNoSrcPos p))
                            p))))) p))) p)
    
  

instance (Monoid w,Monad m) => MonadWriter (w) ((WriterT w m))
  where
  
  gtell ptell p =
    T.ufun1 a130v9v130v44tell ptell p htell
    where
    
    htell fw p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0) fw))) p)
    
  
  glisten plisten p =
    T.ufun1 a131v9v133v34listen plisten p hlisten
    where
    
    hlisten fm p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunWriterT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fv132v27v132v38v1 p ->
                  T.uccase T.mkNoSrcPos p
                    (let
                      v132v27v132v38v1 (T.R (T.Tuple2 fa fw) _) p =
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                            (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa fw) fw)
                      v132v27v132v38v1 _ p =
                        T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                          (T.fromLitString T.mkNoSrcPos p
                            "pattern-match failure in do expression") in
                      (v132v27v132v38v1)) fv132v27v132v38v1)))) p)
    
  
  gpass ppass p =
    T.ufun1 a134v9v136v31pass ppass p hpass
    where
    
    hpass fm p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (T.uwrapForward p (hrunWriterT fm p))
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fv135v32v135v43v1 p ->
                  T.uccase T.mkNoSrcPos p
                    (let
                      v135v32v135v43v1
                        (T.R (T.Tuple2 (T.R (T.Tuple2 fa ff) _) fw) _) p =
                        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                          (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa
                            (T.uap1 T.mkNoSrcPos p ff fw))
                      v135v32v135v43v1 _ p =
                        T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                          (T.fromLitString T.mkNoSrcPos p
                            "pattern-match failure in do expression") in
                      (v135v32v135v43v1)) fv135v32v135v43v1)))) p)
    
  

instance Monoid w => MonadTrans ((WriterT w))
  where
  
  glift plift p =
    T.ufun1 a139v9v141v34lift plift p hlift
    where
    
    hlift fm p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fm
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fa p ->
                  T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                    (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fa
                      (gmempty T.mkNoSrcPos p)))))) p)
    
  

instance (Monoid w,MonadIO m) => MonadIO ((WriterT w m))
  where
  
  gliftIO pliftIO p = T.uconstUse pliftIO p sliftIO
  
  sliftIO =
    T.uconstDef T.mkRoot a144v9v144v30liftIO
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gliftIO T.mkNoSrcPos p))
  

instance (Monoid w,MonadReader r m) => MonadReader (r) ((WriterT w m))
  where
  
  gask pask p = T.uconstUse pask p sask
  
  sask =
    T.uconstDef T.mkRoot a147v9v147v28ask
      (\ p ->
        T.uap1 T.mkNoSrcPos p (glift T.mkNoSrcPos p) (gask T.mkNoSrcPos p))
  
  glocal plocal p =
    T.ufun2 a148v9v148v51local plocal p hlocal
    where
    
    hlocal ff fm p =
      T.uwrapForward p
        (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
            *$
            (T.uap2 T.mkNoSrcPos p (glocal T.mkNoSrcPos p) ff
              (T.uwrapForward p (hrunWriterT fm p)))) p)
    
  

gexecWriterT ::
  Monad m => T.RefSrcPos -> T.RefExp -> T.R (T.Fun (WriterT w m a) (m w))

hexecWriterT :: Monad m => (T.R (WriterT w m a)) -> T.RefExp -> T.R (m w)

gexecWriterT pexecWriterT p = T.ufun1 aexecWriterT pexecWriterT p hexecWriterT

hexecWriterT fm p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
    (T.uwrapForward p (hrunWriterT fm p))
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fv153v19v153v30v1 p ->
        T.uccase T.mkNoSrcPos p
          (let
            v153v19v153v30v1 (T.R (T.Tuple2 _ fw) _) p =
              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fw
            v153v19v153v30v1 _ p =
              T.uap1 T.mkNoSrcPos p (Hat.Prelude.gfail T.mkNoSrcPos p)
                (T.fromLitString T.mkNoSrcPos p
                  "pattern-match failure in do expression") in
            (v153v19v153v30v1)) fv153v19v153v30v1))

gmapWriterT ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (m (T.Tuple2 a w)) (n (T.Tuple2 b w')))
          (T.Fun (WriterT w m a) (WriterT w' n b)))

hmapWriterT ::
  (T.R (T.Fun (m (T.Tuple2 a w)) (n (T.Tuple2 b w')))) ->
    (T.R (WriterT w m a)) -> T.RefExp -> T.R (WriterT w' n b)

gmapWriterT pmapWriterT p = T.ufun2 amapWriterT pmapWriterT p hmapWriterT

hmapWriterT ff fm p =
  T.uwrapForward p
    (((T.pa0 WriterT T.cn1 T.mkNoSrcPos p aWriterT)
        *$
        (T.uap1 T.mkNoSrcPos p ff (T.uwrapForward p (hrunWriterT fm p)))) p)

instance MonadWriter w m => MonadWriter (w) ((ReaderT r m))
  where
  
  gtell ptell p = T.uconstUse ptell p stell
  
  stell =
    T.uconstDef T.mkRoot a163v9v163v30tell
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (glift T.mkNoSrcPos p)
          (gtell T.mkNoSrcPos p))
  
  glisten plisten p =
    T.ufun1 a164v9v164v57listen plisten p hlisten
    where
    
    hlisten fm p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fw p ->
                T.uap1 T.mkNoSrcPos p (glisten T.mkNoSrcPos p)
                  (T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p) fm fw))))
          p)
    
  
  gpass ppass p =
    T.ufun1 a165v9v165v57pass ppass p hpass
    where
    
    hpass fm p =
      T.uwrapForward p
        (((T.pa0 ReaderT T.cn1 T.mkNoSrcPos p aReaderT)
            *$
            (T.ufun1 T.mkLambda T.mkNoSrcPos p
              (\ fw p ->
                T.uap1 T.mkNoSrcPos p (gpass T.mkNoSrcPos p)
                  (T.uap2 T.mkNoSrcPos p (grunReaderT T.mkNoSrcPos p) fm fw))))
          p)
    
  

tControl_Monad_Writer =
  T.mkModule "Control.Monad.Writer" "Control/Monad/Writer.hs" Prelude.False

aWriter =
  T.mkConstructorWFields tControl_Monad_Writer 750022 750027 3 1 "Writer"
    (arunWriter : [])

aWriterT =
  T.mkConstructorWFields tControl_Monad_Writer 1060025 1060031 3 1 "WriterT"
    (arunWriterT : [])

alistens =
  T.mkVariable tControl_Monad_Writer 630001 650023 3 2 "listens" Prelude.False

acensor =
  T.mkVariable tControl_Monad_Writer 680001 700021 3 2 "censor" Prelude.False

arunWriter =
  T.mkVariable tControl_Monad_Writer 750031 750039 3 1 "runWriter" Prelude.False

a79v9v79v64fmap =
  T.mkVariable tControl_Monad_Writer 790009 790064 3 2 "fmap" Prelude.False

a82v9v82v37return =
  T.mkVariable tControl_Monad_Writer 820009 820037 3 1 "return" Prelude.False

(+@%=##=@%=#%>>=) =
  T.mkVariable tControl_Monad_Writer 830011 830013 6 2 ">>=" Prelude.False

a89v9v89v64mfix =
  T.mkVariable tControl_Monad_Writer 890009 890064 3 1 "mfix" Prelude.False

a92v9v92v34tell =
  T.mkVariable tControl_Monad_Writer 920009 920034 3 1 "tell" Prelude.False

a93v9v93v67listen =
  T.mkVariable tControl_Monad_Writer 930009 930067 3 1 "listen" Prelude.False

a94v9v94v69pass =
  T.mkVariable tControl_Monad_Writer 940009 940069 3 1 "pass" Prelude.False

aexecWriter =
  T.mkVariable tControl_Monad_Writer 980001 980031 3 1 "execWriter"
    Prelude.False

amapWriter =
  T.mkVariable tControl_Monad_Writer 1010001 1010039 3 2 "mapWriter"
    Prelude.False

arunWriterT =
  T.mkVariable tControl_Monad_Writer 1060035 1060044 3 1 "runWriterT"
    Prelude.False

a110v9v112v31fmap =
  T.mkVariable tControl_Monad_Writer 1100009 1120031 3 2 "fmap" Prelude.False

a115v9v115v47return =
  T.mkVariable tControl_Monad_Writer 1150009 1150047 3 1 "return" Prelude.False

(+##+=##=##+=#%>>=) =
  T.mkVariable tControl_Monad_Writer 1160011 1160013 6 2 ">>=" Prelude.False

a120v9v120v37fail =
  T.mkVariable tControl_Monad_Writer 1200009 1200037 3 1 "fail" Prelude.False

a123v9v123v35mzero =
  T.mkVariable tControl_Monad_Writer 1230009 1230035 3 0 "mzero" Prelude.False

a124v12v124v16mplus =
  T.mkVariable tControl_Monad_Writer 1240012 1240016 3 2 "mplus" Prelude.False

a127v9v127v62mfix =
  T.mkVariable tControl_Monad_Writer 1270009 1270062 3 1 "mfix" Prelude.False

a130v9v130v44tell =
  T.mkVariable tControl_Monad_Writer 1300009 1300044 3 1 "tell" Prelude.False

a131v9v133v34listen =
  T.mkVariable tControl_Monad_Writer 1310009 1330034 3 1 "listen" Prelude.False

a134v9v136v31pass =
  T.mkVariable tControl_Monad_Writer 1340009 1360031 3 1 "pass" Prelude.False

a139v9v141v34lift =
  T.mkVariable tControl_Monad_Writer 1390009 1410034 3 1 "lift" Prelude.False

a144v9v144v30liftIO =
  T.mkVariable tControl_Monad_Writer 1440009 1440030 3 0 "liftIO" Prelude.False

a147v9v147v28ask =
  T.mkVariable tControl_Monad_Writer 1470009 1470028 3 0 "ask" Prelude.False

a148v9v148v51local =
  T.mkVariable tControl_Monad_Writer 1480009 1480051 3 2 "local" Prelude.False

aexecWriterT =
  T.mkVariable tControl_Monad_Writer 1520001 1540016 3 1 "execWriterT"
    Prelude.False

amapWriterT =
  T.mkVariable tControl_Monad_Writer 1570001 1570042 3 2 "mapWriterT"
    Prelude.False

a163v9v163v30tell =
  T.mkVariable tControl_Monad_Writer 1630009 1630030 3 0 "tell" Prelude.False

a164v9v164v57listen =
  T.mkVariable tControl_Monad_Writer 1640009 1640057 3 1 "listen" Prelude.False

a165v9v165v57pass =
  T.mkVariable tControl_Monad_Writer 1650009 1650057 3 1 "pass" Prelude.False

a79v34v79v34a =
  T.mkVariable tControl_Monad_Writer 790034 790034 3 0 "a" Prelude.True

a79v37v79v37w =
  T.mkVariable tControl_Monad_Writer 790037 790037 3 0 "w" Prelude.True

a84v18v84v18a =
  T.mkVariable tControl_Monad_Writer 840018 840018 3 0 "a" Prelude.True

a84v21v84v21w =
  T.mkVariable tControl_Monad_Writer 840021 840021 3 0 "w" Prelude.True

a85v18v85v18b =
  T.mkVariable tControl_Monad_Writer 850018 850018 3 0 "b" Prelude.True

a85v21v85v22w' =
  T.mkVariable tControl_Monad_Writer 850021 850022 3 0 "w'" Prelude.True

a89v32v89v32a =
  T.mkVariable tControl_Monad_Writer 890032 890032 3 0 "a" Prelude.True

a89v35v89v35w =
  T.mkVariable tControl_Monad_Writer 890035 890035 3 0 "w" Prelude.True

a93v34v93v34a =
  T.mkVariable tControl_Monad_Writer 930034 930034 3 0 "a" Prelude.True

a93v37v93v37w =
  T.mkVariable tControl_Monad_Writer 930037 930037 3 0 "w" Prelude.True

a94v35v94v35a =
  T.mkVariable tControl_Monad_Writer 940035 940035 3 0 "a" Prelude.True

a94v38v94v38f =
  T.mkVariable tControl_Monad_Writer 940038 940038 3 0 "f" Prelude.True

a94v42v94v42w =
  T.mkVariable tControl_Monad_Writer 940042 940042 3 0 "w" Prelude.True

a0v0v0v0a = T.mkVariable tControl_Monad_Writer 0 0 3 0 "a" Prelude.True
