module Hat.Foreign.Marshal.Error
  (gthrowIf,athrowIf,hthrowIf,gthrowIf_,athrowIf_,hthrowIf_,gthrowIfNeg
    ,gthrowIfNeg_,gthrowIfNull,gvoid,avoid,hvoid) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Foreign.Ptr 

gthrowIf ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (T.Fun a Bool) (T.Fun (T.Fun a String) (T.Fun (IO a) (IO a))))

hthrowIf ::
  (T.R (T.Fun a Bool)) ->
    (T.R (T.Fun a String)) -> (T.R (IO a)) -> T.RefExp -> T.R (IO a)

gthrowIf pthrowIf p = T.ufun3 athrowIf pthrowIf p hthrowIf

hthrowIf fpred fmsgfct fact p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fact
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fres p ->
        T.uap1 T.mkNoSrcPos p
          (T.ucif p (T.uap1 T.mkNoSrcPos p fpred fres)
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (gioError T.mkNoSrcPos p)
              (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
                (guserError T.mkNoSrcPos p) fmsgfct)) (greturn T.mkNoSrcPos p))
          fres))

gthrowIf_ ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun a Bool)
          (T.Fun (T.Fun a String) (T.Fun (IO a) (IO T.Tuple0))))

hthrowIf_ ::
  (T.R (T.Fun a Bool)) ->
    (T.R (T.Fun a String)) -> (T.R (IO a)) -> T.RefExp -> T.R (IO T.Tuple0)

gthrowIf_ pthrowIf_ p = T.ufun3 athrowIf_ pthrowIf_ p hthrowIf_

hthrowIf_ fpred fmsgfct fact p =
  T.uwrapForward p
    (((gvoid T.mkNoSrcPos p)
        *$
        (T.uwrapForward p (hthrowIf fpred fmsgfct fact p))) p)

gthrowIfNeg ::
  (Ord a,Num a) =>
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun a String) (T.Fun (IO a) (IO a)))

sthrowIfNeg ::
  (Ord a,Num a) => T.R (T.Fun (T.Fun a String) (T.Fun (IO a) (IO a)))

gthrowIfNeg pthrowIfNeg p = T.uconstUse pthrowIfNeg p sthrowIfNeg

sthrowIfNeg =
  T.uconstDef T.mkRoot athrowIfNeg
    (\ p ->
      T.uap1 T.mkNoSrcPos p (gthrowIf T.mkNoSrcPos p)
        (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gflip T.mkNoSrcPos p)
          (T.mkNoSrcPos !< p)
          (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
            (T.conInteger T.mkNoSrcPos p 0))))

gthrowIfNeg_ ::
  (Ord a,Num a) =>
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.Fun a String) (T.Fun (IO a) (IO T.Tuple0)))

sthrowIfNeg_ ::
  (Ord a,Num a) => T.R (T.Fun (T.Fun a String) (T.Fun (IO a) (IO T.Tuple0)))

gthrowIfNeg_ pthrowIfNeg_ p = T.uconstUse pthrowIfNeg_ p sthrowIfNeg_

sthrowIfNeg_ =
  T.uconstDef T.mkRoot athrowIfNeg_
    (\ p ->
      T.uap1 T.mkNoSrcPos p (gthrowIf_ T.mkNoSrcPos p)
        (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gflip T.mkNoSrcPos p)
          (T.mkNoSrcPos !< p)
          (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
            (T.conInteger T.mkNoSrcPos p 0))))

gthrowIfNull ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun String (T.Fun (IO (Ptr a)) (IO (Ptr a))))

sthrowIfNull :: T.R (T.Fun String (T.Fun (IO (Ptr a)) (IO (Ptr a))))

gthrowIfNull pthrowIfNull p = T.uconstUse pthrowIfNull p sthrowIfNull

sthrowIfNull =
  T.uconstDef T.mkRoot athrowIfNull
    (\ p ->
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
        (T.uap1 T.mkNoSrcPos p (gthrowIf T.mkNoSrcPos p)
          (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gflip T.mkNoSrcPos p)
            (T.mkNoSrcPos !== p) (gnullPtr T.mkNoSrcPos p)))
        (gconst T.mkNoSrcPos p))

gvoid :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (IO a) (IO T.Tuple0))

hvoid :: (T.R (IO a)) -> T.RefExp -> T.R (IO T.Tuple0)

gvoid pvoid p = T.ufun1 avoid pvoid p hvoid

hvoid fact p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>> p) fact
    (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0))

tForeign_Marshal_Error =
  T.mkModule "Foreign.Marshal.Error" "Foreign/Marshal/Error.hs" Prelude.False

athrowIf =
  T.mkVariable tForeign_Marshal_Error 150001 180067 3 3 "throwIf" Prelude.False

athrowIf_ =
  T.mkVariable tForeign_Marshal_Error 210001 210058 3 3 "throwIf_" Prelude.False

athrowIfNeg =
  T.mkVariable tForeign_Marshal_Error 240001 240026 3 0 "throwIfNeg"
    Prelude.False

athrowIfNeg_ =
  T.mkVariable tForeign_Marshal_Error 270001 270028 3 0 "throwIfNeg_"
    Prelude.False

athrowIfNull =
  T.mkVariable tForeign_Marshal_Error 300001 300043 3 0 "throwIfNull"
    Prelude.False

avoid =
  T.mkVariable tForeign_Marshal_Error 330001 330029 3 1 "void" Prelude.False
