module Hat.System.Console.GetOpt
  (ggetOpt,agetOpt,hgetOpt,gusageInfo,ausageInfo,husageInfo
    ,ArgOrder(RequireOrder,Permute,ReturnInOrder),aRequireOrder,aPermute
    ,aReturnInOrder,OptDescr(Option),aOption,ArgDescr(NoArg,ReqArg,OptArg)
    ,aNoArg,aReqArg,aOptArg) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Data.List  (gisPrefixOf,aisPrefixOf,hisPrefixOf)

data ArgOrder a =
  RequireOrder  | Permute  | ReturnInOrder (T.R (T.Fun String a))

instance T.WrapVal ((ArgOrder a))
  where
  
  wrapVal pwrapVal (kwrapVal@RequireOrder) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aRequireOrder)
  wrapVal pwrapVal (kwrapVal@Permute) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aPermute)
  wrapVal pwrapVal (kwrapVal@(ReturnInOrder (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aReturnInOrder z1wrapVal)
  

data OptDescr a =
  Option
    (T.R (T.List Char)) (T.R (T.List String)) (T.R (ArgDescr a)) (T.R String)

instance T.WrapVal ((OptDescr a))
  where
  
  wrapVal pwrapVal
    (kwrapVal@(Option (T.R _ z1wrapVal) (T.R _ z2wrapVal) (T.R _ z3wrapVal)
        (T.R _ z4wrapVal))) p =
    T.R kwrapVal
      (T.mkValueApp4 p pwrapVal aOption z1wrapVal z2wrapVal z3wrapVal z4wrapVal)
  

data ArgDescr a =
  NoArg (T.R a) | ReqArg (T.R (T.Fun String a)) (T.R String)
  | OptArg (T.R (T.Fun (Maybe String) a)) (T.R String)

instance T.WrapVal ((ArgDescr a))
  where
  
  wrapVal pwrapVal (kwrapVal@(NoArg (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aNoArg z1wrapVal)
  wrapVal pwrapVal (kwrapVal@(ReqArg (T.R _ z1wrapVal) (T.R _ z2wrapVal))) p =
    T.R kwrapVal (T.mkValueApp2 p pwrapVal aReqArg z1wrapVal z2wrapVal)
  wrapVal pwrapVal (kwrapVal@(OptArg (T.R _ z1wrapVal) (T.R _ z2wrapVal))) p =
    T.R kwrapVal (T.mkValueApp2 p pwrapVal aOptArg z1wrapVal z2wrapVal)
  

data OptKind a =
  Opt (T.R a) | NonOpt (T.R String) | EndOfOpts  | OptErr (T.R String)

instance T.WrapVal ((OptKind a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Opt (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aOpt z1wrapVal)
  wrapVal pwrapVal (kwrapVal@(NonOpt (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aNonOpt z1wrapVal)
  wrapVal pwrapVal (kwrapVal@EndOfOpts) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aEndOfOpts)
  wrapVal pwrapVal (kwrapVal@(OptErr (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aOptErr z1wrapVal)
  

gusageInfo ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun String (T.Fun (T.List (OptDescr a)) String))

husageInfo ::
  (T.R String) -> (T.R (T.List (OptDescr a))) -> T.RefExp -> T.R String

gusageInfo pusageInfo p = T.ufun2 ausageInfo pusageInfo p husageInfo

husageInfo fheader foptDescr p =
  T.uap1 T.mkNoSrcPos p (gunlines T.mkNoSrcPos p)
    (T.con2 T.mkNoSrcPos p T.Cons T.aCons fheader (gtable T.mkNoSrcPos p))
  where
  
  gss pss p = T.uconstUse pss p sss
  
  gls pss p = T.uconstUse pss p sls
  
  gds pss p = T.uconstUse pss p sds
  
  j73v10v73v19ss =
    case
      T.uap1 T.mkNoSrcPos p
        (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (gunzip3 T.mkNoSrcPos p)
          (T.uap1 T.mkNoSrcPos p (gmap T.mkNoSrcPos p)
            (gfmtOpt T.mkNoSrcPos p))) foptDescr of
      T.R (T.Tuple3 fss fls fds) kss -> (kss,fss,fls,fds)
      _ -> T.fatal p
  
  sss =
    T.uconstDef p a73v11v73v12ss
      (\ _ -> case j73v10v73v19ss of (kss,fss,fls,fds) -> fss)
  
  sls =
    T.uconstDef p a73v14v73v15ls
      (\ _ -> case j73v10v73v19ss of (kss,fss,fls,fds) -> fls)
  
  sds =
    T.uconstDef p a73v17v73v18ds
      (\ _ -> case j73v10v73v19ss of (kss,fss,fls,fds) -> fds)
  
  gtable ptable p = T.uconstUse ptable p stable
  
  stable =
    T.uconstDef p a74v10v74v69table
      (\ p ->
        T.uwrapForward p
          (hzipWith3 (gpaste T.mkNoSrcPos p)
            (T.uwrapForward p (hsameLen (gss T.mkNoSrcPos p) p))
            (T.uwrapForward p (hsameLen (gls T.mkNoSrcPos p) p))
            (gds T.mkNoSrcPos p) p))
  
  gpaste ppaste p = T.ufun3 a75v10v75v61paste ppaste p hpaste
  
  apaste = a75v10v75v61paste
  
  hpaste fx fy fz p =
    T.uwrapForward p
      (((T.fromLitString T.mkNoSrcPos p "  ")
          *++
          (T.uwrapForward p
            ((fx
                *++
                (T.uwrapForward p
                  (((T.fromLitString T.mkNoSrcPos p "  ")
                      *++
                      (T.uwrapForward p
                        ((fy
                            *++
                            (T.uwrapForward p
                              (((T.fromLitString T.mkNoSrcPos p "  ") *++ fz)
                                p))) p))) p))) p))) p)
  
  gsameLen psameLen p = T.ufun1 a76v10v76v66sameLen psameLen p hsameLen
  
  asameLen = a76v10v76v66sameLen
  
  hsameLen fxs p =
    T.uwrapForward p
      (hflushLeft
        (T.uap1 T.mkNoSrcPos p
          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (gmaximum T.mkNoSrcPos p)
            (T.uap1 T.mkNoSrcPos p (gmap T.mkNoSrcPos p)
              (glength T.mkNoSrcPos p))) fxs) fxs p)
  
  gflushLeft pflushLeft p =
    T.ufun2 a77v10v77v18flushLeft pflushLeft p hflushLeft
  
  aflushLeft = a77v10v77v18flushLeft
  
  hflushLeft fn fxs p =
    T.uap1 T.mkNoSrcPos p
      (T.uap2 T.mkNoSrcPos p (Hat.Prelude.g_foldr T.mkNoSrcPos p)
        (T.ufun2 T.mkLambda T.mkNoSrcPos p
          (\ f_x f_y p ->
            T.uccase T.mkNoSrcPos p
              (let
                v0v0v0v0v1 fx p =
                  T.uap1 T.mkNoSrcPos p
                    (T.pa1 T.Cons T.cn1 T.mkNoSrcPos p T.aCons
                      (T.uwrapForward p
                        (htake fn
                          (T.uwrapForward p
                            ((fx
                                *++
                                (T.uwrapForward p
                                  (hrepeat (T.conChar T.mkNoSrcPos p ' ') p)))
                              p)) p))) f_y
                v0v0v0v0v1 _ p = T.projection T.mkNoSrcPos p f_y in
                (v0v0v0v0v1)) f_x)) fxs) (T.fromExpList T.mkNoSrcPos p [])
  

gfmtOpt ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (OptDescr a) (T.Tuple3 String String String))

hfmtOpt :: (T.R (OptDescr a)) -> T.RefExp -> T.R (T.Tuple3 String String String)

gfmtOpt pfmtOpt p = T.ufun1 afmtOpt pfmtOpt p hfmtOpt

hfmtOpt (T.R (Option fsos flos fad fdescr) _) p =
  T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
    (T.uwrapForward p
      (hsepBy (T.conChar T.mkNoSrcPos p ',')
        (T.uwrapForward p
          (hmap (T.uap1 T.mkNoSrcPos p (gfmtShort T.mkNoSrcPos p) fad) fsos p))
        p))
    (T.uwrapForward p
      (hsepBy (T.conChar T.mkNoSrcPos p ',')
        (T.uwrapForward p
          (hmap (T.uap1 T.mkNoSrcPos p (gfmtLong T.mkNoSrcPos p) fad) flos p))
        p)) fdescr
  where
  
  gsepBy psepBy p = T.ufun2 a83v10v85v50sepBy psepBy p hsepBy
  
  asepBy = a83v10v85v50sepBy
  
  hsepBy _ (T.R T.List _) p = T.fromLitString T.mkNoSrcPos p ""
  hsepBy _ (T.R (T.Cons fx (T.R T.List _)) _) p = T.projection T.mkNoSrcPos p fx
  hsepBy fch (T.R (T.Cons fx fxs) _) p =
    T.uwrapForward p
      ((fx
          *++
          (T.con2 T.mkNoSrcPos p T.Cons T.aCons fch
            (T.con2 T.mkNoSrcPos p T.Cons T.aCons (T.conChar T.mkNoSrcPos p ' ')
              (T.uwrapForward p (hsepBy fch fxs p))))) p)
  hsepBy _ _ p = T.fatal p
  
hfmtOpt _ p = T.fatal p

gfmtShort ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (ArgDescr a) (T.Fun Char String))

hfmtShort :: (T.R (ArgDescr a)) -> (T.R Char) -> T.RefExp -> T.R String

gfmtShort pfmtShort p = T.ufun2 afmtShort pfmtShort p hfmtShort

hfmtShort (T.R (NoArg _) _) fso p =
  T.uwrapForward p
    (((T.fromLitString T.mkNoSrcPos p "-")
        *++
        (T.fromExpList T.mkNoSrcPos p [fso])) p)
hfmtShort (T.R (ReqArg _ fad) _) fso p =
  T.uwrapForward p
    (((T.fromLitString T.mkNoSrcPos p "-")
        *++
        (T.uwrapForward p
          (((T.fromExpList T.mkNoSrcPos p [fso])
              *++
              (T.uwrapForward p
                (((T.fromLitString T.mkNoSrcPos p " ") *++ fad) p))) p))) p)
hfmtShort (T.R (OptArg _ fad) _) fso p =
  T.uwrapForward p
    (((T.fromLitString T.mkNoSrcPos p "-")
        *++
        (T.uwrapForward p
          (((T.fromExpList T.mkNoSrcPos p [fso])
              *++
              (T.uwrapForward p
                (((T.fromLitString T.mkNoSrcPos p "[")
                    *++
                    (T.uwrapForward p
                      ((fad *++ (T.fromLitString T.mkNoSrcPos p "]")) p))) p)))
            p))) p)
hfmtShort _ _ p = T.fatal p

gfmtLong ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (ArgDescr a) (T.Fun String String))

hfmtLong :: (T.R (ArgDescr a)) -> (T.R String) -> T.RefExp -> T.R String

gfmtLong pfmtLong p = T.ufun2 afmtLong pfmtLong p hfmtLong

hfmtLong (T.R (NoArg _) _) flo p =
  T.uwrapForward p (((T.fromLitString T.mkNoSrcPos p "--") *++ flo) p)
hfmtLong (T.R (ReqArg _ fad) _) flo p =
  T.uwrapForward p
    (((T.fromLitString T.mkNoSrcPos p "--")
        *++
        (T.uwrapForward p
          ((flo
              *++
              (T.uwrapForward p
                (((T.fromLitString T.mkNoSrcPos p "=") *++ fad) p))) p))) p)
hfmtLong (T.R (OptArg _ fad) _) flo p =
  T.uwrapForward p
    (((T.fromLitString T.mkNoSrcPos p "--")
        *++
        (T.uwrapForward p
          ((flo
              *++
              (T.uwrapForward p
                (((T.fromLitString T.mkNoSrcPos p "[=")
                    *++
                    (T.uwrapForward p
                      ((fad *++ (T.fromLitString T.mkNoSrcPos p "]")) p))) p)))
            p))) p)
hfmtLong _ _ p = T.fatal p

ggetOpt ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (ArgOrder a)
          (T.Fun (T.List (OptDescr a))
            (T.Fun (T.List String)
              (T.Tuple3 (T.List a) (T.List String) (T.List String)))))

hgetOpt ::
  (T.R (ArgOrder a)) ->
    (T.R (T.List (OptDescr a))) ->
      (T.R (T.List String)) ->
        T.RefExp -> T.R (T.Tuple3 (T.List a) (T.List String) (T.List String))

ggetOpt pgetOpt p = T.ufun3 agetOpt pgetOpt p hgetOpt

hgetOpt _ _ (T.R T.List _) p =
  T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
    (T.con0 T.mkNoSrcPos p T.List T.aList)
    (T.con0 T.mkNoSrcPos p T.List T.aList)
    (T.con0 T.mkNoSrcPos p T.List T.aList)
hgetOpt fordering foptDescr (T.R (T.Cons farg fargs) _) p =
  T.uwrapForward p (hprocNextOpt (gopt T.mkNoSrcPos p) fordering p)
  where
  
  gprocNextOpt pprocNextOpt p =
    T.ufun2 a117v10v124v64procNextOpt pprocNextOpt p hprocNextOpt
  
  aprocNextOpt = a117v10v124v64procNextOpt
  
  hprocNextOpt (T.R (Opt fo) _) _ p =
    T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
      (T.con2 T.mkNoSrcPos p T.Cons T.aCons fo (gos T.mkNoSrcPos p))
      (gxs T.mkNoSrcPos p) (ges T.mkNoSrcPos p)
  hprocNextOpt (T.R (NonOpt fx) _) (T.R RequireOrder _) p =
    T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
      (T.con0 T.mkNoSrcPos p T.List T.aList)
      (T.con2 T.mkNoSrcPos p T.Cons T.aCons fx (grest T.mkNoSrcPos p))
      (T.con0 T.mkNoSrcPos p T.List T.aList)
  hprocNextOpt (T.R (NonOpt fx) _) (T.R Permute _) p =
    T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 (gos T.mkNoSrcPos p)
      (T.con2 T.mkNoSrcPos p T.Cons T.aCons fx (gxs T.mkNoSrcPos p))
      (ges T.mkNoSrcPos p)
  hprocNextOpt (T.R (NonOpt fx) _) (T.R (ReturnInOrder ff) _) p =
    T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
      (T.con2 T.mkNoSrcPos p T.Cons T.aCons (T.uap1 T.mkNoSrcPos p ff fx)
        (gos T.mkNoSrcPos p)) (gxs T.mkNoSrcPos p) (ges T.mkNoSrcPos p)
  hprocNextOpt (T.R EndOfOpts _) (T.R RequireOrder _) p =
    T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
      (T.con0 T.mkNoSrcPos p T.List T.aList) (grest T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.List T.aList)
  hprocNextOpt (T.R EndOfOpts _) (T.R Permute _) p =
    T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
      (T.con0 T.mkNoSrcPos p T.List T.aList) (grest T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.List T.aList)
  hprocNextOpt (T.R EndOfOpts _) (T.R (ReturnInOrder ff) _) p =
    T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3
      (T.uwrapForward p (hmap ff (grest T.mkNoSrcPos p) p))
      (T.con0 T.mkNoSrcPos p T.List T.aList)
      (T.con0 T.mkNoSrcPos p T.List T.aList)
  hprocNextOpt (T.R (OptErr fe) _) _ p =
    T.con3 T.mkNoSrcPos p T.Tuple3 T.aTuple3 (gos T.mkNoSrcPos p)
      (gxs T.mkNoSrcPos p)
      (T.con2 T.mkNoSrcPos p T.Cons T.aCons fe (ges T.mkNoSrcPos p))
  hprocNextOpt _ _ p = T.fatal p
  
  gopt popt p = T.uconstUse popt p sopt
  
  grest popt p = T.uconstUse popt p srest
  
  j126v10v126v19opt =
    case T.uwrapForward p (hgetNext farg fargs foptDescr p) of
      T.R (T.Tuple2 fopt frest) kopt -> (kopt,fopt,frest)
      _ -> T.fatal p
  
  sopt =
    T.uconstDef p a126v11v126v13opt
      (\ _ -> case j126v10v126v19opt of (kopt,fopt,frest) -> fopt)
  
  srest =
    T.uconstDef p a126v15v126v18rest
      (\ _ -> case j126v10v126v19opt of (kopt,fopt,frest) -> frest)
  
  gos pos p = T.uconstUse pos p sos
  
  gxs pos p = T.uconstUse pos p sxs
  
  ges pos p = T.uconstUse pos p ses
  
  j127v10v127v19os =
    case
      T.uwrapForward p (hgetOpt fordering foptDescr (grest T.mkNoSrcPos p) p) of
      T.R (T.Tuple3 fos fxs fes) kos -> (kos,fos,fxs,fes)
      _ -> T.fatal p
  
  sos =
    T.uconstDef p a127v11v127v12os
      (\ _ -> case j127v10v127v19os of (kos,fos,fxs,fes) -> fos)
  
  sxs =
    T.uconstDef p a127v14v127v15xs
      (\ _ -> case j127v10v127v19os of (kos,fos,fxs,fes) -> fxs)
  
  ses =
    T.uconstDef p a127v17v127v18es
      (\ _ -> case j127v10v127v19os of (kos,fos,fxs,fes) -> fes)
  
hgetOpt _ _ _ p = T.fatal p

ggetNext ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun String
          (T.Fun (T.List String)
            (T.Fun (T.List (OptDescr a))
              (T.Tuple2 (OptKind a) (T.List String)))))

hgetNext ::
  (T.R String) ->
    (T.R (T.List String)) ->
      (T.R (T.List (OptDescr a))) ->
        T.RefExp -> T.R (T.Tuple2 (OptKind a) (T.List String))

ggetNext pgetNext p = T.ufun3 agetNext pgetNext p hgetNext

hgetNext
  (T.R (T.Cons (T.R '-' _) (T.R (T.Cons (T.R '-' _) (T.R T.List _)) _)) _) frest
  _ p =
  T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
    (T.con0 T.mkNoSrcPos p EndOfOpts aEndOfOpts) frest
hgetNext (T.R (T.Cons (T.R '-' _) (T.R (T.Cons (T.R '-' _) fxs) _)) _) frest
  foptDescr p =
  T.uwrapForward p (hlongOpt fxs frest foptDescr p)
hgetNext (T.R (T.Cons (T.R '-' _) (T.R (T.Cons fx fxs) _)) _) frest foptDescr
  p =
  T.uwrapForward p (hshortOpt fx fxs frest foptDescr p)
hgetNext fa frest _ p =
  T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
    (T.con1 T.mkNoSrcPos p NonOpt aNonOpt fa) frest

glongOpt ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun String
          (T.Fun (T.List String)
            (T.Fun (T.List (OptDescr a))
              (T.Tuple2 (OptKind a) (T.List String)))))

hlongOpt ::
  (T.R String) ->
    (T.R (T.List String)) ->
      (T.R (T.List (OptDescr a))) ->
        T.RefExp -> T.R (T.Tuple2 (OptKind a) (T.List String))

glongOpt plongOpt p = T.ufun3 alongOpt plongOpt p hlongOpt

hlongOpt fls frs foptDescr p =
  T.uwrapForward p (hlong (gads T.mkNoSrcPos p) (garg T.mkNoSrcPos p) frs p)
  where
  
  gopt popt p = T.uconstUse popt p sopt
  
  garg popt p = T.uconstUse popt p sarg
  
  j139v10v139v18opt =
    case
      T.uap2 T.mkNoSrcPos p (gbreak T.mkNoSrcPos p)
        (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gflip T.mkNoSrcPos p)
          (T.mkNoSrcPos !== p) (T.conChar T.mkNoSrcPos p '=')) fls of
      T.R (T.Tuple2 fopt farg) kopt -> (kopt,fopt,farg)
      _ -> T.fatal p
  
  sopt =
    T.uconstDef p a139v11v139v13opt
      (\ _ -> case j139v10v139v18opt of (kopt,fopt,farg) -> fopt)
  
  sarg =
    T.uconstDef p a139v15v139v17arg
      (\ _ -> case j139v10v139v18opt of (kopt,fopt,farg) -> farg)
  
  goptions poptions p = T.uconstUse poptions p soptions
  
  soptions =
    T.uconstDef p a140v10v140v16options
      (\ p ->
        T.uap1 T.mkNoSrcPos p
          (T.uap2 T.mkNoSrcPos p (Hat.Prelude.g_foldr T.mkNoSrcPos p)
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ f_x f_y p ->
                T.uccase T.mkNoSrcPos p
                  (let
                    v0v0v0v0v1 (fo@(T.R (Option _ fls _ _) _)) p =
                      T.uap1 T.mkNoSrcPos p
                        (T.uap2 T.mkNoSrcPos p
                          (Hat.Prelude.g_foldr T.mkNoSrcPos p)
                          (T.ufun2 T.mkLambda T.mkNoSrcPos p
                            (\ f_x f_y p ->
                              T.uccase T.mkNoSrcPos p
                                (let
                                  v0v0v0v0v1 fl p =
                                    T.uap1 T.mkNoSrcPos p
                                      (T.uap2 T.mkNoSrcPos p
                                        (Hat.Prelude.g_filter T.mkNoSrcPos p)
                                        (T.uwrapForward p
                                          (hisPrefixOf (gopt T.mkNoSrcPos p) fl
                                            p))
                                        (T.pa1 T.Cons T.cn1 T.mkNoSrcPos p
                                          T.aCons fo)) f_y
                                  v0v0v0v0v1 _ p =
                                    T.projection T.mkNoSrcPos p f_y in
                                  (v0v0v0v0v1)) f_x)) fls) f_y
                    v0v0v0v0v1 _ p = T.projection T.mkNoSrcPos p f_y in
                    (v0v0v0v0v1)) f_x)) foptDescr)
          (T.fromExpList T.mkNoSrcPos p []))
  
  gads pads p = T.uconstUse pads p sads
  
  sads =
    T.uconstDef p a141v10v141v12ads
      (\ p ->
        T.uap1 T.mkNoSrcPos p
          (T.uap2 T.mkNoSrcPos p (Hat.Prelude.g_foldr T.mkNoSrcPos p)
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ f_x f_y p ->
                T.uccase T.mkNoSrcPos p
                  (let
                    v0v0v0v0v1 (T.R (Option _ _ fad _) _) p =
                      T.uap1 T.mkNoSrcPos p
                        (T.pa1 T.Cons T.cn1 T.mkNoSrcPos p T.aCons fad) f_y
                    v0v0v0v0v1 _ p = T.projection T.mkNoSrcPos p f_y in
                    (v0v0v0v0v1)) f_x)) (goptions T.mkNoSrcPos p))
          (T.fromExpList T.mkNoSrcPos p []))
  
  goptStr poptStr p = T.uconstUse poptStr p soptStr
  
  soptStr =
    T.uconstDef p a142v10v142v31optStr
      (\ p ->
        T.uwrapForward p
          (((T.fromLitString T.mkNoSrcPos p "--") *++ (gopt T.mkNoSrcPos p)) p))
  
  glong plong p = T.ufun3 a144v10v152v69long plong p hlong
  
  along = a144v10v152v69long
  
  hlong (T.R (T.Cons _ (T.R (T.Cons _ _) _)) _) _ frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.uwrapForward p
        (herrAmbig (goptions T.mkNoSrcPos p) (goptStr T.mkNoSrcPos p) p)) frest
  hlong (T.R (T.Cons (T.R (NoArg fa) _) (T.R T.List _)) _) (T.R T.List _) frest
    p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (T.con1 T.mkNoSrcPos p Opt aOpt fa)
      frest
  hlong (T.R (T.Cons (T.R (NoArg _) _) (T.R T.List _)) _)
    (T.R (T.Cons (T.R '=' _) _) _) frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.uwrapForward p (herrNoArg (goptStr T.mkNoSrcPos p) p)) frest
  hlong (T.R (T.Cons (T.R (ReqArg _ fd) _) (T.R T.List _)) _) (T.R T.List _)
    (T.R T.List _) p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.uwrapForward p (herrReq fd (goptStr T.mkNoSrcPos p) p))
      (T.con0 T.mkNoSrcPos p T.List T.aList)
  hlong (T.R (T.Cons (T.R (ReqArg ff _) _) (T.R T.List _)) _) (T.R T.List _)
    (T.R (T.Cons fr frest) _) p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.con1 T.mkNoSrcPos p Opt aOpt (T.uap1 T.mkNoSrcPos p ff fr)) frest
  hlong (T.R (T.Cons (T.R (ReqArg ff _) _) (T.R T.List _)) _)
    (T.R (T.Cons (T.R '=' _) fxs) _) frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.con1 T.mkNoSrcPos p Opt aOpt (T.uap1 T.mkNoSrcPos p ff fxs)) frest
  hlong (T.R (T.Cons (T.R (OptArg ff _) _) (T.R T.List _)) _) (T.R T.List _)
    frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.con1 T.mkNoSrcPos p Opt aOpt
        (T.uap1 T.mkNoSrcPos p ff (T.con0 T.mkNoSrcPos p Nothing aNothing)))
      frest
  hlong (T.R (T.Cons (T.R (OptArg ff _) _) (T.R T.List _)) _)
    (T.R (T.Cons (T.R '=' _) fxs) _) frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.con1 T.mkNoSrcPos p Opt aOpt
        (T.uap1 T.mkNoSrcPos p ff (T.con1 T.mkNoSrcPos p Just aJust fxs))) frest
  hlong _ _ frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.uwrapForward p (herrUnrec (goptStr T.mkNoSrcPos p) p)) frest
  

gshortOpt ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun Char
          (T.Fun String
            (T.Fun (T.List String)
              (T.Fun (T.List (OptDescr a))
                (T.Tuple2 (OptKind a) (T.List String))))))

hshortOpt ::
  (T.R Char) ->
    (T.R String) ->
      (T.R (T.List String)) ->
        (T.R (T.List (OptDescr a))) ->
          T.RefExp -> T.R (T.Tuple2 (OptKind a) (T.List String))

gshortOpt pshortOpt p = T.ufun4 ashortOpt pshortOpt p hshortOpt

hshortOpt fx fxs frest foptDescr p =
  T.uwrapForward p (hshort (gads T.mkNoSrcPos p) fxs frest p)
  where
  
  goptions poptions p = T.uconstUse poptions p soptions
  
  soptions =
    T.uconstDef p a157v9v157v15options
      (\ p ->
        T.uap1 T.mkNoSrcPos p
          (T.uap2 T.mkNoSrcPos p (Hat.Prelude.g_foldr T.mkNoSrcPos p)
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ f_x f_y p ->
                T.uccase T.mkNoSrcPos p
                  (let
                    v0v0v0v0v1 (fo@(T.R (Option fss _ _ _) _)) p =
                      T.uap1 T.mkNoSrcPos p
                        (T.uap2 T.mkNoSrcPos p
                          (Hat.Prelude.g_foldr T.mkNoSrcPos p)
                          (T.ufun2 T.mkLambda T.mkNoSrcPos p
                            (\ f_x f_y p ->
                              T.uccase T.mkNoSrcPos p
                                (let
                                  v0v0v0v0v1 fs p =
                                    T.uap1 T.mkNoSrcPos p
                                      (T.uap2 T.mkNoSrcPos p
                                        (Hat.Prelude.g_filter T.mkNoSrcPos p)
                                        (T.uap2 T.mkNoSrcPos p
                                          (T.mkNoSrcPos !== p) fx fs)
                                        (T.pa1 T.Cons T.cn1 T.mkNoSrcPos p
                                          T.aCons fo)) f_y
                                  v0v0v0v0v1 _ p =
                                    T.projection T.mkNoSrcPos p f_y in
                                  (v0v0v0v0v1)) f_x)) fss) f_y
                    v0v0v0v0v1 _ p = T.projection T.mkNoSrcPos p f_y in
                    (v0v0v0v0v1)) f_x)) foptDescr)
          (T.fromExpList T.mkNoSrcPos p []))
  
  gads pads p = T.uconstUse pads p sads
  
  sads =
    T.uconstDef p a158v9v158v11ads
      (\ p ->
        T.uap1 T.mkNoSrcPos p
          (T.uap2 T.mkNoSrcPos p (Hat.Prelude.g_foldr T.mkNoSrcPos p)
            (T.ufun2 T.mkLambda T.mkNoSrcPos p
              (\ f_x f_y p ->
                T.uccase T.mkNoSrcPos p
                  (let
                    v0v0v0v0v1 (T.R (Option _ _ fad _) _) p =
                      T.uap1 T.mkNoSrcPos p
                        (T.pa1 T.Cons T.cn1 T.mkNoSrcPos p T.aCons fad) f_y
                    v0v0v0v0v1 _ p = T.projection T.mkNoSrcPos p f_y in
                    (v0v0v0v0v1)) f_x)) (goptions T.mkNoSrcPos p))
          (T.fromExpList T.mkNoSrcPos p []))
  
  goptStr poptStr p = T.uconstUse poptStr p soptStr
  
  soptStr =
    T.uconstDef p a159v9v159v25optStr
      (\ p ->
        T.con2 T.mkNoSrcPos p T.Cons T.aCons (T.conChar T.mkNoSrcPos p '-')
          (T.fromExpList T.mkNoSrcPos p [fx]))
  
  gshort pshort p = T.ufun3 a161v9v170v74short pshort p hshort
  
  ashort = a161v9v170v74short
  
  hshort (T.R (T.Cons _ (T.R (T.Cons _ _) _)) _) _ frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.uwrapForward p
        (herrAmbig (goptions T.mkNoSrcPos p) (goptStr T.mkNoSrcPos p) p)) frest
  hshort (T.R (T.Cons (T.R (NoArg fa) _) _) _) (T.R T.List _) frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (T.con1 T.mkNoSrcPos p Opt aOpt fa)
      frest
  hshort (T.R (T.Cons (T.R (NoArg fa) _) _) _) fxs frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 (T.con1 T.mkNoSrcPos p Opt aOpt fa)
      (T.con2 T.mkNoSrcPos p T.Cons T.aCons
        (T.con2 T.mkNoSrcPos p T.Cons T.aCons (T.conChar T.mkNoSrcPos p '-')
          fxs) frest)
  hshort (T.R (T.Cons (T.R (ReqArg _ fd) _) _) _) (T.R T.List _) (T.R T.List _)
    p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.uwrapForward p (herrReq fd (goptStr T.mkNoSrcPos p) p))
      (T.con0 T.mkNoSrcPos p T.List T.aList)
  hshort (T.R (T.Cons (T.R (ReqArg ff _) _) _) _) (T.R T.List _)
    (T.R (T.Cons fr frest) _) p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.con1 T.mkNoSrcPos p Opt aOpt (T.uap1 T.mkNoSrcPos p ff fr)) frest
  hshort (T.R (T.Cons (T.R (ReqArg ff _) _) _) _) fxs frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.con1 T.mkNoSrcPos p Opt aOpt (T.uap1 T.mkNoSrcPos p ff fxs)) frest
  hshort (T.R (T.Cons (T.R (OptArg ff _) _) _) _) (T.R T.List _) frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.con1 T.mkNoSrcPos p Opt aOpt
        (T.uap1 T.mkNoSrcPos p ff (T.con0 T.mkNoSrcPos p Nothing aNothing)))
      frest
  hshort (T.R (T.Cons (T.R (OptArg ff _) _) _) _) fxs frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.con1 T.mkNoSrcPos p Opt aOpt
        (T.uap1 T.mkNoSrcPos p ff (T.con1 T.mkNoSrcPos p Just aJust fxs))) frest
  hshort (T.R T.List _) (T.R T.List _) frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.uwrapForward p (herrUnrec (goptStr T.mkNoSrcPos p) p)) frest
  hshort (T.R T.List _) fxs frest p =
    T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
      (T.uwrapForward p (herrUnrec (goptStr T.mkNoSrcPos p) p))
      (T.con2 T.mkNoSrcPos p T.Cons T.aCons
        (T.con2 T.mkNoSrcPos p T.Cons T.aCons (T.conChar T.mkNoSrcPos p '-')
          fxs) frest)
  hshort _ _ _ p = T.fatal p
  

gerrAmbig ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.List (OptDescr a)) (T.Fun String (OptKind a)))

herrAmbig ::
  (T.R (T.List (OptDescr a))) -> (T.R String) -> T.RefExp -> T.R (OptKind a)

gerrAmbig perrAmbig p = T.ufun2 aerrAmbig perrAmbig p herrAmbig

herrAmbig fods foptStr p =
  T.con1 T.mkNoSrcPos p OptErr aOptErr
    (T.uwrapForward p (husageInfo (gheader T.mkNoSrcPos p) fods p))
  where
  
  gheader pheader p = T.uconstUse pheader p sheader
  
  sheader =
    T.uconstDef p a176v10v176v76header
      (\ p ->
        T.uwrapForward p
          (((T.fromLitString T.mkNoSrcPos p "option `")
              *++
              (T.uwrapForward p
                ((foptStr
                    *++
                    (T.fromLitString T.mkNoSrcPos p
                      "' is ambiguous; could be one of:")) p))) p))
  

gerrReq ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun String (T.Fun String (OptKind a)))

herrReq :: (T.R String) -> (T.R String) -> T.RefExp -> T.R (OptKind a)

gerrReq perrReq p = T.ufun2 aerrReq perrReq p herrReq

herrReq fd foptStr p =
  T.con1 T.mkNoSrcPos p OptErr aOptErr
    (T.uwrapForward p
      (((T.fromLitString T.mkNoSrcPos p "option `")
          *++
          (T.uwrapForward p
            ((foptStr
                *++
                (T.uwrapForward p
                  (((T.fromLitString T.mkNoSrcPos p "' requires an argument ")
                      *++
                      (T.uwrapForward p
                        ((fd *++ (T.fromLitString T.mkNoSrcPos p "\n")) p)))
                    p))) p))) p))

gerrUnrec :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun String (OptKind a))

herrUnrec :: (T.R String) -> T.RefExp -> T.R (OptKind a)

gerrUnrec perrUnrec p = T.ufun1 aerrUnrec perrUnrec p herrUnrec

herrUnrec foptStr p =
  T.con1 T.mkNoSrcPos p OptErr aOptErr
    (T.uwrapForward p
      (((T.fromLitString T.mkNoSrcPos p "unrecognized option `")
          *++
          (T.uwrapForward p
            ((foptStr *++ (T.fromLitString T.mkNoSrcPos p "'\n")) p))) p))

gerrNoArg :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun String (OptKind a))

herrNoArg :: (T.R String) -> T.RefExp -> T.R (OptKind a)

gerrNoArg perrNoArg p = T.ufun1 aerrNoArg perrNoArg p herrNoArg

herrNoArg foptStr p =
  T.con1 T.mkNoSrcPos p OptErr aOptErr
    (T.uwrapForward p
      (((T.fromLitString T.mkNoSrcPos p "option `")
          *++
          (T.uwrapForward p
            ((foptStr
                *++
                (T.fromLitString T.mkNoSrcPos p
                  "' doesn't allow an argument\n")) p))) p))

tSystem_Console_GetOpt =
  T.mkModule "System.Console.GetOpt" "System/Console/GetOpt.hs" Prelude.False

aRequireOrder =
  T.mkConstructor tSystem_Console_GetOpt 300005 300016 3 0 "RequireOrder"

aPermute = T.mkConstructor tSystem_Console_GetOpt 310005 310011 3 0 "Permute"

aReturnInOrder =
  T.mkConstructor tSystem_Console_GetOpt 320005 320017 3 1 "ReturnInOrder"

aOption = T.mkConstructor tSystem_Console_GetOpt 480004 480009 3 4 "Option"

aNoArg = T.mkConstructor tSystem_Console_GetOpt 560006 560010 3 1 "NoArg"

aReqArg = T.mkConstructor tSystem_Console_GetOpt 570006 570011 3 2 "ReqArg"

aOptArg = T.mkConstructor tSystem_Console_GetOpt 580006 580011 3 2 "OptArg"

aOpt = T.mkConstructor tSystem_Console_GetOpt 610006 610008 3 1 "Opt"

aNonOpt = T.mkConstructor tSystem_Console_GetOpt 620006 620011 3 1 "NonOpt"

aEndOfOpts =
  T.mkConstructor tSystem_Console_GetOpt 630006 630014 3 0 "EndOfOpts"

aOptErr = T.mkConstructor tSystem_Console_GetOpt 640006 640011 3 1 "OptErr"

ausageInfo =
  T.mkVariable tSystem_Console_GetOpt 720001 770018 3 2 "usageInfo"
    Prelude.False

afmtOpt =
  T.mkVariable tSystem_Console_GetOpt 800001 850050 3 1 "fmtOpt" Prelude.False

afmtShort =
  T.mkVariable tSystem_Console_GetOpt 880001 900059 3 2 "fmtShort" Prelude.False

afmtLong =
  T.mkVariable tSystem_Console_GetOpt 930001 950058 3 2 "fmtLong" Prelude.False

agetOpt =
  T.mkVariable tSystem_Console_GetOpt 1150001 1270051 3 3 "getOpt" Prelude.False

agetNext =
  T.mkVariable tSystem_Console_GetOpt 1310001 1340052 3 3 "getNext"
    Prelude.False

alongOpt =
  T.mkVariable tSystem_Console_GetOpt 1380001 1520069 3 3 "longOpt"
    Prelude.False

ashortOpt =
  T.mkVariable tSystem_Console_GetOpt 1560001 1700074 3 4 "shortOpt"
    Prelude.False

aerrAmbig =
  T.mkVariable tSystem_Console_GetOpt 1750001 1760076 3 2 "errAmbig"
    Prelude.False

aerrReq =
  T.mkVariable tSystem_Console_GetOpt 1790001 1790088 3 2 "errReq" Prelude.False

aerrUnrec =
  T.mkVariable tSystem_Console_GetOpt 1820001 1820068 3 1 "errUnrec"
    Prelude.False

aerrNoArg =
  T.mkVariable tSystem_Console_GetOpt 1850001 1850081 3 1 "errNoArg"
    Prelude.False

a73v11v73v12ss =
  T.mkVariable tSystem_Console_GetOpt 730011 730012 3 0 "ss" Prelude.True

a73v14v73v15ls =
  T.mkVariable tSystem_Console_GetOpt 730014 730015 3 0 "ls" Prelude.True

a73v17v73v18ds =
  T.mkVariable tSystem_Console_GetOpt 730017 730018 3 0 "ds" Prelude.True

a74v10v74v69table =
  T.mkVariable tSystem_Console_GetOpt 740010 740069 3 0 "table" Prelude.True

a75v10v75v61paste =
  T.mkVariable tSystem_Console_GetOpt 750010 750061 3 3 "paste" Prelude.True

a76v10v76v66sameLen =
  T.mkVariable tSystem_Console_GetOpt 760010 760066 3 1 "sameLen" Prelude.True

a77v10v77v18flushLeft =
  T.mkVariable tSystem_Console_GetOpt 770010 770018 3 2 "flushLeft" Prelude.True

a83v10v85v50sepBy =
  T.mkVariable tSystem_Console_GetOpt 830010 850050 3 2 "sepBy" Prelude.True

a117v10v124v64procNextOpt =
  T.mkVariable tSystem_Console_GetOpt 1170010 1240064 3 2 "procNextOpt"
    Prelude.True

a126v11v126v13opt =
  T.mkVariable tSystem_Console_GetOpt 1260011 1260013 3 0 "opt" Prelude.True

a126v15v126v18rest =
  T.mkVariable tSystem_Console_GetOpt 1260015 1260018 3 0 "rest" Prelude.True

a127v11v127v12os =
  T.mkVariable tSystem_Console_GetOpt 1270011 1270012 3 0 "os" Prelude.True

a127v14v127v15xs =
  T.mkVariable tSystem_Console_GetOpt 1270014 1270015 3 0 "xs" Prelude.True

a127v17v127v18es =
  T.mkVariable tSystem_Console_GetOpt 1270017 1270018 3 0 "es" Prelude.True

a139v11v139v13opt =
  T.mkVariable tSystem_Console_GetOpt 1390011 1390013 3 0 "opt" Prelude.True

a139v15v139v17arg =
  T.mkVariable tSystem_Console_GetOpt 1390015 1390017 3 0 "arg" Prelude.True

a140v10v140v16options =
  T.mkVariable tSystem_Console_GetOpt 1400010 1400016 3 0 "options" Prelude.True

a141v10v141v12ads =
  T.mkVariable tSystem_Console_GetOpt 1410010 1410012 3 0 "ads" Prelude.True

a142v10v142v31optStr =
  T.mkVariable tSystem_Console_GetOpt 1420010 1420031 3 0 "optStr" Prelude.True

a144v10v152v69long =
  T.mkVariable tSystem_Console_GetOpt 1440010 1520069 3 3 "long" Prelude.True

a157v9v157v15options =
  T.mkVariable tSystem_Console_GetOpt 1570009 1570015 3 0 "options" Prelude.True

a158v9v158v11ads =
  T.mkVariable tSystem_Console_GetOpt 1580009 1580011 3 0 "ads" Prelude.True

a159v9v159v25optStr =
  T.mkVariable tSystem_Console_GetOpt 1590009 1590025 3 0 "optStr" Prelude.True

a161v9v170v74short =
  T.mkVariable tSystem_Console_GetOpt 1610009 1700074 3 3 "short" Prelude.True

a176v10v176v76header =
  T.mkVariable tSystem_Console_GetOpt 1760010 1760076 3 0 "header" Prelude.True
