module Hat.System.IO.Unsafe
  (gunsafePerformIO,aunsafePerformIO,hunsafePerformIO,gunsafeInterleaveIO
    ,aunsafeInterleaveIO,hunsafeInterleaveIO) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import qualified System.IO.Unsafe 

gunsafePerformIO :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (IO a) a)

gunsafePerformIO punsafePerformIO p =
  T.ufun1 aunsafePerformIO punsafePerformIO p hunsafePerformIO

hunsafePerformIO z1unsafePerformIO kunsafePerformIO =
  T.fromId kunsafePerformIO
    (System.IO.Unsafe.unsafePerformIO
      ((T.toIO T.toId) kunsafePerformIO z1unsafePerformIO))

gunsafeInterleaveIO :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun (IO a) (IO a))

gunsafeInterleaveIO punsafeInterleaveIO p =
  T.ufun1 aunsafeInterleaveIO punsafeInterleaveIO p hunsafeInterleaveIO

hunsafeInterleaveIO z1unsafeInterleaveIO kunsafeInterleaveIO =
  (T.fromIO T.fromId) kunsafeInterleaveIO
    (System.IO.Unsafe.unsafeInterleaveIO
      ((T.toIO T.toId) kunsafeInterleaveIO z1unsafeInterleaveIO))

tSystem_IO_Unsafe =
  T.mkModule "System.IO.Unsafe" "System/IO/Unsafe.hs" Prelude.False

aunsafePerformIO =
  T.mkVariable tSystem_IO_Unsafe 80001 90032 3 1 "unsafePerformIO" Prelude.False

aunsafeInterleaveIO =
  T.mkVariable tSystem_IO_Unsafe 100001 110036 3 1 "unsafeInterleaveIO"
    Prelude.False
