module Hat.System.Locale
  (TimeLocale(TimeLocale,bwDays,bmonths,bamPm,bdateTimeFmt,bdateFmt,btimeFmt
      ,btime12Fmt),aTimeLocale,gwDays,gmonths,gamPm,gdateTimeFmt,gdateFmt
    ,gtimeFmt,gtime12Fmt,hwDays,hmonths,hamPm,hdateTimeFmt,hdateFmt,htimeFmt
    ,htime12Fmt,awDays,amonths,aamPm,adateTimeFmt,adateFmt,atimeFmt,atime12Fmt
    ,gdefaultTimeLocale,giso8601DateFormat,aiso8601DateFormat,hiso8601DateFormat
    ,grfc822DateFormat) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Locale 

giso8601DateFormat ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (Maybe String) String)

hiso8601DateFormat :: (T.R (Maybe String)) -> T.RefExp -> T.R String

giso8601DateFormat piso8601DateFormat p =
  T.ufun1 aiso8601DateFormat piso8601DateFormat p hiso8601DateFormat

hiso8601DateFormat ftimeFmt p =
  T.uwrapForward p
    (((T.fromLitString T.mkNoSrcPos p "%Y-%m-%d")
        *++
        (T.uccase T.mkNoSrcPos p
          (let
            v12v19v14v34v1 (T.R Nothing _) p = T.fromLitString T.mkNoSrcPos p ""
            v12v19v14v34v1 (T.R (Just ffmt) _) p =
              T.con2 T.mkNoSrcPos p T.Cons T.aCons
                (T.conChar T.mkNoSrcPos p ' ') ffmt
            v12v19v14v34v1 _ p = T.fatal p in (v12v19v14v34v1)) ftimeFmt)) p)

grfc822DateFormat :: T.RefSrcPos -> T.RefExp -> T.R String

srfc822DateFormat :: T.R String

grfc822DateFormat prfc822DateFormat p =
  T.uconstUse prfc822DateFormat p srfc822DateFormat

srfc822DateFormat =
  T.uconstDef T.mkRoot arfc822DateFormat
    (\ p -> T.fromLitString T.mkNoSrcPos p "%a, %_d %b %Y %H:%M:%S %Z")

tSystem_Locale = T.mkModule "System.Locale" "System/Locale.hs" Prelude.False

aiso8601DateFormat =
  T.mkVariable tSystem_Locale 110001 140034 3 1 "iso8601DateFormat"
    Prelude.False

arfc822DateFormat =
  T.mkVariable tSystem_Locale 170001 170046 3 0 "rfc822DateFormat" Prelude.False
