module Hat.Text.ParserCombinators.Parsec.Char
  (CharParser(),gspaces,gspace,gnewline,gtab,gupper,glower,galphaNum,gletter
    ,gdigit,ghexDigit,goctDigit,gchar,achar,hchar,gstring,astring,hstring
    ,ganyChar,goneOf,aoneOf,honeOf,gnoneOf,anoneOf,hnoneOf,gsatisfy,asatisfy
    ,hsatisfy) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Data.Char 
import Hat.Text.ParserCombinators.Parsec.Pos  (gupdatePosChar,aupdatePosChar
  ,hupdatePosChar,gupdatePosString,aupdatePosString,hupdatePosString)
import Hat.Text.ParserCombinators.Parsec.Prim 

type CharParser st a = GenParser Char st a

goneOf poneOf p = T.ufun1 aoneOf poneOf p honeOf

honeOf fcs p =
  T.uwrapForward p
    (hsatisfy
      (T.ufun1 T.mkLambda T.mkNoSrcPos p
        (\ fc p -> T.uap2 T.mkNoSrcPos p (gelem T.mkNoSrcPos p) fc fcs)) p)

gnoneOf pnoneOf p = T.ufun1 anoneOf pnoneOf p hnoneOf

hnoneOf fcs p =
  T.uwrapForward p
    (hsatisfy
      (T.ufun1 T.mkLambda T.mkNoSrcPos p
        (\ fc p ->
          T.uwrapForward p
            (hnot (T.uap2 T.mkNoSrcPos p (gelem T.mkNoSrcPos p) fc fcs) p))) p)

gspaces pspaces p = T.uconstUse pspaces p sspaces

sspaces =
  T.uconstDef T.mkRoot aspaces
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hskipMany (gspace T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "white space")) p))

gspace pspace p = T.uconstUse pspace p sspace

sspace =
  T.uconstDef T.mkRoot aspace
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hsatisfy (gisSpace T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "space")) p))

gnewline pnewline p = T.uconstUse pnewline p snewline

snewline =
  T.uconstDef T.mkRoot anewline
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '\n') p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "new-line")) p))

gtab ptab p = T.uconstUse ptab p stab

stab =
  T.uconstDef T.mkRoot atab
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hchar (T.conChar T.mkNoSrcPos p '\t') p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "tab")) p))

gupper pupper p = T.uconstUse pupper p supper

supper =
  T.uconstDef T.mkRoot aupper
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hsatisfy (gisUpper T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "uppercase letter")) p))

glower plower p = T.uconstUse plower p slower

slower =
  T.uconstDef T.mkRoot alower
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hsatisfy (gisLower T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "lowercase letter")) p))

galphaNum palphaNum p = T.uconstUse palphaNum p salphaNum

salphaNum =
  T.uconstDef T.mkRoot aalphaNum
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hsatisfy (gisAlphaNum T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "letter or digit")) p))

gletter pletter p = T.uconstUse pletter p sletter

sletter =
  T.uconstDef T.mkRoot aletter
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hsatisfy (gisAlpha T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "letter")) p))

gdigit pdigit p = T.uconstUse pdigit p sdigit

sdigit =
  T.uconstDef T.mkRoot adigit
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hsatisfy (gisDigit T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "digit")) p))

ghexDigit phexDigit p = T.uconstUse phexDigit p shexDigit

shexDigit =
  T.uconstDef T.mkRoot ahexDigit
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hsatisfy (gisHexDigit T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "hexadecimal digit")) p))

goctDigit poctDigit p = T.uconstUse poctDigit p soctDigit

soctDigit =
  T.uconstDef T.mkRoot aoctDigit
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hsatisfy (gisOctDigit T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "octal digit")) p))

gchar pchar p = T.ufun1 achar pchar p hchar

hchar fc p =
  T.uwrapForward p
    (((T.uwrapForward p
          (hsatisfy
            (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gflip T.mkNoSrcPos p)
              (T.mkNoSrcPos !== p) fc) p))
        *<?>
        (T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p)
          (T.fromExpList T.mkNoSrcPos p [fc]))) p)

ganyChar panyChar p = T.uconstUse panyChar p sanyChar

sanyChar =
  T.uconstDef T.mkRoot aanyChar
    (\ p ->
      T.uwrapForward p
        (hsatisfy
          (T.uap1 T.mkNoSrcPos p (gconst T.mkNoSrcPos p)
            (T.con0 T.mkNoSrcPos p True aTrue)) p))

gsatisfy ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun (T.Fun Char Bool) (CharParser st Char))

hsatisfy :: (T.R (T.Fun Char Bool)) -> T.RefExp -> T.R (CharParser st Char)

gsatisfy psatisfy p = T.ufun1 asatisfy psatisfy p hsatisfy

hsatisfy ff p =
  T.uwrapForward p
    (htokenPrim
      (T.ufun1 T.mkLambda T.mkNoSrcPos p
        (\ fc p ->
          T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p)
            (T.fromExpList T.mkNoSrcPos p [fc])))
      (T.ufun3 T.mkLambda T.mkNoSrcPos p
        (\ fpos fc fcs p -> T.uwrapForward p (hupdatePosChar fpos fc p)))
      (T.ufun1 T.mkLambda T.mkNoSrcPos p
        (\ fc p ->
          T.ucif p (T.uap1 T.mkNoSrcPos p ff fc)
            (T.con1 T.mkNoSrcPos p Just aJust fc)
            (T.con0 T.mkNoSrcPos p Nothing aNothing))) p)

gstring :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun String (CharParser st String))

hstring :: (T.R String) -> T.RefExp -> T.R (CharParser st String)

gstring pstring p = T.ufun1 astring pstring p hstring

hstring fs p =
  T.uwrapForward p
    (htokens (gshow T.mkNoSrcPos p) (gupdatePosString T.mkNoSrcPos p) fs p)

tText_ParserCombinators_Parsec_Char =
  T.mkModule "Text.ParserCombinators.Parsec.Char"
    "Text/ParserCombinators/Parsec/Char.hs" Prelude.False

aoneOf =
  T.mkVariable tText_ParserCombinators_Parsec_Char 390001 390046 3 1 "oneOf"
    Prelude.False

anoneOf =
  T.mkVariable tText_ParserCombinators_Parsec_Char 400001 400051 3 1 "noneOf"
    Prelude.False

aspaces =
  T.mkVariable tText_ParserCombinators_Parsec_Char 420001 420061 3 0 "spaces"
    Prelude.False

aspace =
  T.mkVariable tText_ParserCombinators_Parsec_Char 430001 430055 3 0 "space"
    Prelude.False

anewline =
  T.mkVariable tText_ParserCombinators_Parsec_Char 450001 450058 3 0 "newline"
    Prelude.False

atab =
  T.mkVariable tText_ParserCombinators_Parsec_Char 460001 460053 3 0 "tab"
    Prelude.False

aupper =
  T.mkVariable tText_ParserCombinators_Parsec_Char 480001 480066 3 0 "upper"
    Prelude.False

alower =
  T.mkVariable tText_ParserCombinators_Parsec_Char 490001 490066 3 0 "lower"
    Prelude.False

aalphaNum =
  T.mkVariable tText_ParserCombinators_Parsec_Char 500001 500065 3 0 "alphaNum"
    Prelude.False

aletter =
  T.mkVariable tText_ParserCombinators_Parsec_Char 510001 510056 3 0 "letter"
    Prelude.False

adigit =
  T.mkVariable tText_ParserCombinators_Parsec_Char 520001 520055 3 0 "digit"
    Prelude.False

ahexDigit =
  T.mkVariable tText_ParserCombinators_Parsec_Char 530001 530067 3 0 "hexDigit"
    Prelude.False

aoctDigit =
  T.mkVariable tText_ParserCombinators_Parsec_Char 540001 540061 3 0 "octDigit"
    Prelude.False

achar =
  T.mkVariable tText_ParserCombinators_Parsec_Char 560001 560049 3 1 "char"
    Prelude.False

aanyChar =
  T.mkVariable tText_ParserCombinators_Parsec_Char 570001 570041 3 0 "anyChar"
    Prelude.False

asatisfy =
  T.mkVariable tText_ParserCombinators_Parsec_Char 630001 650070 3 1 "satisfy"
    Prelude.False

astring =
  T.mkVariable tText_ParserCombinators_Parsec_Char 680001 680051 3 1 "string"
    Prelude.False
