module Hat.Text.ParserCombinators.Parsec.Combinator
  (gchoice,achoice,hchoice,gcount,acount,hcount,gbetween,abetween,hbetween
    ,goption,aoption,hoption,goptional,aoptional,hoptional,gskipMany1,askipMany1
    ,hskipMany1,gmany1,amany1,hmany1,gsepBy,asepBy,hsepBy,gsepBy1,asepBy1
    ,hsepBy1,gendBy,aendBy,hendBy,gendBy1,aendBy1,hendBy1,gsepEndBy,asepEndBy
    ,hsepEndBy,gsepEndBy1,asepEndBy1,hsepEndBy1,gchainl,achainl,hchainl,gchainl1
    ,achainl1,hchainl1,gchainr,achainr,hchainr,gchainr1,achainr1,hchainr1,geof
    ,gnotFollowedBy,anotFollowedBy,hnotFollowedBy,gmanyTill,amanyTill,hmanyTill
    ,glookAhead,alookAhead,hlookAhead,ganyToken) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Control.Monad 
import Hat.Text.ParserCombinators.Parsec.Prim 

gchoice ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.List (GenParser tok st a)) (GenParser tok st a))

hchoice ::
  (T.R (T.List (GenParser tok st a))) -> T.RefExp -> T.R (GenParser tok st a)

gchoice pchoice p = T.ufun1 achoice pchoice p hchoice

hchoice fps p =
  T.uwrapForward p (hfoldr (T.mkNoSrcPos !<|> p) (gmzero T.mkNoSrcPos p) fps p)

goption ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun a (T.Fun (GenParser tok st a) (GenParser tok st a)))

hoption ::
  (T.R a) -> (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st a)

goption poption p = T.ufun2 aoption poption p hoption

hoption fx fp p =
  T.uwrapForward p
    ((fp *<|> (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)) p)

goptional ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (GenParser tok st a) (GenParser tok st T.Tuple0))

hoptional ::
  (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st T.Tuple0)

goptional poptional p = T.ufun1 aoptional poptional p hoptional

hoptional fp p =
  T.uwrapForward p
    (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p) fp
          (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
            (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0)))
        *<|>
        (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
          (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0))) p)

gbetween ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st open)
          (T.Fun (GenParser tok st close)
            (T.Fun (GenParser tok st a) (GenParser tok st a))))

hbetween ::
  (T.R (GenParser tok st open)) ->
    (T.R (GenParser tok st close)) ->
      (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st a)

gbetween pbetween p = T.ufun3 abetween pbetween p hbetween

hbetween fopen fclose fp p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p) fopen
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
      (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
        (\ fx p ->
          T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p) fclose
            (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx))))

gskipMany1 ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (GenParser tok st a) (GenParser tok st T.Tuple0))

hskipMany1 ::
  (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st T.Tuple0)

gskipMany1 pskipMany1 p = T.ufun1 askipMany1 pskipMany1 p hskipMany1

hskipMany1 fp p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p) fp
    (T.uwrapForward p (hskipMany fp p))

gmany1 ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (GenParser tok st a) (GenParser tok st (T.List a)))

hmany1 ::
  (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st (T.List a))

gmany1 pmany1 p = T.ufun1 amany1 pmany1 p hmany1

hmany1 fp p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fx p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
          (T.uwrapForward p (hmany fp p))
          (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
            (\ fxs p ->
              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                (T.con2 T.mkNoSrcPos p T.Cons T.aCons fx fxs)))))

gsepBy1,gsepBy ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun (GenParser tok st sep) (GenParser tok st (T.List a))))

hsepBy1 ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st sep)) ->
      T.RefExp -> T.R (GenParser tok st (T.List a))

hsepBy ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st sep)) ->
      T.RefExp -> T.R (GenParser tok st (T.List a))

gsepBy psepBy p = T.ufun2 asepBy psepBy p hsepBy

hsepBy fp fsep p =
  T.uwrapForward p
    (((T.uwrapForward p (hsepBy1 fp fsep p))
        *<|>
        (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
          (T.con0 T.mkNoSrcPos p T.List T.aList))) p)

gsepBy1 psepBy1 p = T.ufun2 asepBy1 psepBy1 p hsepBy1

hsepBy1 fp fsep p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fx p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
          (T.uwrapForward p
            (hmany (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !>> p) fsep fp) p))
          (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
            (\ fxs p ->
              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                (T.con2 T.mkNoSrcPos p T.Cons T.aCons fx fxs)))))

gsepEndBy1,gsepEndBy ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun (GenParser tok st sep) (GenParser tok st (T.List a))))

hsepEndBy1 ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st sep)) ->
      T.RefExp -> T.R (GenParser tok st (T.List a))

hsepEndBy ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st sep)) ->
      T.RefExp -> T.R (GenParser tok st (T.List a))

gsepEndBy1 psepEndBy1 p = T.ufun2 asepEndBy1 psepEndBy1 p hsepEndBy1

hsepEndBy1 fp fsep p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fx p ->
        T.uwrapForward p
          (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p) fsep
                (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (T.uwrapForward p (hsepEndBy fp fsep p))
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fxs p ->
                      T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                        (T.con2 T.mkNoSrcPos p T.Cons T.aCons fx fxs)))))
              *<|>
              (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                (T.fromExpList T.mkNoSrcPos p [fx]))) p)))

gsepEndBy psepEndBy p = T.ufun2 asepEndBy psepEndBy p hsepEndBy

hsepEndBy fp fsep p =
  T.uwrapForward p
    (((T.uwrapForward p (hsepEndBy1 fp fsep p))
        *<|>
        (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
          (T.con0 T.mkNoSrcPos p T.List T.aList))) p)

gendBy1,gendBy ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun (GenParser tok st sep) (GenParser tok st (T.List a))))

hendBy1 ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st sep)) ->
      T.RefExp -> T.R (GenParser tok st (T.List a))

hendBy ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st sep)) ->
      T.RefExp -> T.R (GenParser tok st (T.List a))

gendBy1 pendBy1 p = T.ufun2 aendBy1 pendBy1 p hendBy1

hendBy1 fp fsep p =
  T.uwrapForward p
    (hmany1
      (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
        (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
          (\ fx p ->
            T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p) fsep
              (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)))) p)

gendBy pendBy p = T.ufun2 aendBy pendBy p hendBy

hendBy fp fsep p =
  T.uwrapForward p
    (hmany
      (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
        (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
          (\ fx p ->
            T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p) fsep
              (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)))) p)

gcount ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun Int (T.Fun (GenParser tok st a) (GenParser tok st (T.List a))))

hcount ::
  (T.R Int) ->
    (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st (T.List a))

gcount pcount p = T.ufun2 acount pcount p hcount

hcount fn fp p =
  T.ucguard
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !<= p) fn
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 0)))
    (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.List T.aList))
    (T.ucguard (gotherwise T.mkNoSrcPos p)
      (T.uap1 T.mkNoSrcPos p (gsequence T.mkNoSrcPos p)
        (T.uwrapForward p (hreplicate fn fp p))) (T.fatal p))

gchainr pchainr p = T.ufun3 achainr pchainr p hchainr

hchainr fp fop fx p =
  T.uwrapForward p
    (((T.uwrapForward p (hchainr1 fp fop p))
        *<|>
        (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)) p)

gchainl pchainl p = T.ufun3 achainl pchainl p hchainl

hchainl fp fop fx p =
  T.uwrapForward p
    (((T.uwrapForward p (hchainl1 fp fop p))
        *<|>
        (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)) p)

gchainr1,gchainl1 ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun (GenParser tok st (T.Fun a (T.Fun a a))) (GenParser tok st a)))

hchainr1 ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st (T.Fun a (T.Fun a a)))) ->
      T.RefExp -> T.R (GenParser tok st a)

hchainl1 ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st (T.Fun a (T.Fun a a)))) ->
      T.RefExp -> T.R (GenParser tok st a)

gchainl1 pchainl1 p = T.ufun2 achainl1 pchainl1 p hchainl1

hchainl1 fp fop p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fx p -> T.uwrapForward p (hrest fx p)))
  where
  
  grest prest p = T.ufun1 a108v23v112v44rest prest p hrest
  
  arest = a108v23v112v44rest
  
  hrest fx p =
    T.uwrapForward p
      (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fop
            (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
              (\ ff p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fy p ->
                      T.uwrapForward p
                        (hrest (T.uap2 T.mkNoSrcPos p ff fx fy) p))))))
          *<|>
          (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)) p)
  

gchainr1 pchainr1 p = T.ufun2 achainr1 pchainr1 p hchainr1

hchainr1 fp fop p =
  gscan T.mkNoSrcPos p
  where
  
  gscan pscan p = T.uconstUse pscan p sscan
  
  sscan =
    T.uconstDef p a116v23v116v52scan
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
          (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
            (\ fx p -> T.uwrapForward p (hrest fx p))))
  
  grest prest p = T.ufun1 a118v23v122v44rest prest p hrest
  
  arest = a118v23v122v44rest
  
  hrest fx p =
    T.uwrapForward p
      (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fop
            (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
              (\ ff p ->
                T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                  (gscan T.mkNoSrcPos p)
                  (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                    (\ fy p ->
                      T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                        (T.uap2 T.mkNoSrcPos p ff fx fy))))))
          *<|>
          (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)) p)
  

ganyToken :: Show tok => T.RefSrcPos -> T.RefExp -> T.R (GenParser tok st tok)

sanyToken :: Show tok => T.R (GenParser tok st tok)

ganyToken panyToken p = T.uconstUse panyToken p sanyToken

sanyToken =
  T.uconstDef T.mkRoot aanyToken
    (\ p ->
      T.uwrapForward p
        (htokenPrim (gshow T.mkNoSrcPos p)
          (T.ufun3 T.mkLambda T.mkNoSrcPos p
            (\ fpos ftok ftoks p -> T.projection T.mkNoSrcPos p fpos))
          (T.pa0 Just T.cn1 T.mkNoSrcPos p aJust) p))

geof :: Show tok => T.RefSrcPos -> T.RefExp -> T.R (GenParser tok st T.Tuple0)

seof :: Show tok => T.R (GenParser tok st T.Tuple0)

geof peof p = T.uconstUse peof p seof

seof =
  T.uconstDef T.mkRoot aeof
    (\ p ->
      T.uwrapForward p
        (((T.uwrapForward p (hnotFollowedBy (ganyToken T.mkNoSrcPos p) p))
            *<?>
            (T.fromLitString T.mkNoSrcPos p "end of input")) p))

gnotFollowedBy ::
  Show tok =>
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (GenParser tok st tok) (GenParser tok st T.Tuple0))

hnotFollowedBy ::
  Show tok =>
  (T.R (GenParser tok st tok)) -> T.RefExp -> T.R (GenParser tok st T.Tuple0)

gnotFollowedBy pnotFollowedBy p =
  T.ufun1 anotFollowedBy pnotFollowedBy p hnotFollowedBy

hnotFollowedBy fp p =
  T.uwrapForward p
    (htry
      (T.uwrapForward p
        (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fc p ->
                  T.uwrapForward p
                    (hunexpected
                      (T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p)
                        (T.fromExpList T.mkNoSrcPos p [fc])) p))))
            *<|>
            (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0))) p)) p)

gmanyTill ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun (GenParser tok st end) (GenParser tok st (T.List a))))

hmanyTill ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st end)) ->
      T.RefExp -> T.R (GenParser tok st (T.List a))

gmanyTill pmanyTill p = T.ufun2 amanyTill pmanyTill p hmanyTill

hmanyTill fp fend p =
  gscan T.mkNoSrcPos p
  where
  
  gscan pscan p = T.uconstUse pscan p sscan
  
  sscan =
    T.uconstDef p a141v23v143v66scan
      (\ p ->
        T.uwrapForward p
          (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p) fend
                (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                  (T.con0 T.mkNoSrcPos p T.List T.aList)))
              *<|>
              (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
                (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                  (\ fx p ->
                    T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                      (gscan T.mkNoSrcPos p)
                      (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                        (\ fxs p ->
                          T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                            (T.con2 T.mkNoSrcPos p T.Cons T.aCons fx fxs)))))))
            p))
  

glookAhead ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (GenParser tok st a) (GenParser tok st a))

hlookAhead :: (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st a)

glookAhead plookAhead p = T.ufun1 alookAhead plookAhead p hlookAhead

hlookAhead fp p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
    (ggetParserState T.mkNoSrcPos p)
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fstate p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
          (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
            (\ fx p ->
              T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p)
                (T.uwrapForward p (hsetParserState fstate p))
                (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)))))

tText_ParserCombinators_Parsec_Combinator =
  T.mkModule "Text.ParserCombinators.Parsec.Combinator"
    "Text/ParserCombinators/Parsec/Combinator.hs" Prelude.False

achoice =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 410001 410042 3 1
    "choice" Prelude.False

aoption =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 440001 440036 3 2
    "option" Prelude.False

aoptional =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 470001 470055 3 1
    "optional" Prelude.False

abetween =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 510001 520055 3 3
    "between" Prelude.False

askipMany1 =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 560001 560039 3 1
    "skipMany1" Prelude.False

amany1 =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 640001 640060 3 1
    "many1" Prelude.False

asepBy =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 750001 750048 3 2
    "sepBy" Prelude.False

asepBy1 =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 760001 780038 3 2
    "sepBy1" Prelude.False

asepEndBy1 =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 820001 870040 3 2
    "sepEndBy1" Prelude.False

asepEndBy =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 900001 900051 3 2
    "sepEndBy" Prelude.False

aendBy1 =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 940001 940054 3 2
    "endBy1" Prelude.False

aendBy =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 950001 950053 3 2
    "endBy" Prelude.False

acount =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 980001 990057 3 2
    "count" Prelude.False

achainr =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1020001 1020047 3 3
    "chainr" Prelude.False

achainl =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1030001 1030047 3 3
    "chainl" Prelude.False

achainl1 =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1060001 1120044 3 2
    "chainl1" Prelude.False

achainr1 =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1140001 1220044 3 2
    "chainr1" Prelude.False

aanyToken =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1280001 1280064 3 0
    "anyToken" Prelude.False

aeof =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1310001 1310063 3 0
    "eof" Prelude.False

anotFollowedBy =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1340001 1350041 3 1
    "notFollowedBy" Prelude.False

amanyTill =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1390001 1430066 3 2
    "manyTill" Prelude.False

alookAhead =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1470001 1500034 3 1
    "lookAhead" Prelude.False

a108v23v112v44rest =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1080023 1120044 3 1
    "rest" Prelude.True

a116v23v116v52scan =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1160023 1160052 3 0
    "scan" Prelude.True

a118v23v122v44rest =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1180023 1220044 3 1
    "rest" Prelude.True

a141v23v143v66scan =
  T.mkVariable tText_ParserCombinators_Parsec_Combinator 1410023 1430066 3 0
    "scan" Prelude.True
