module Hat.Text.ParserCombinators.Parsec.Error
  (Message(SysUnExpect,UnExpect,Expect,Message),aSysUnExpect,aUnExpect,aExpect
    ,aMessage,gmessageString,amessageString,hmessageString,gmessageCompare
    ,amessageCompare,hmessageCompare,gmessageEq,amessageEq,hmessageEq
    ,ParseError(),gerrorPos,aerrorPos,herrorPos,gerrorMessages,aerrorMessages
    ,herrorMessages,gerrorIsUnknown,aerrorIsUnknown,herrorIsUnknown
    ,gshowErrorMessages,ashowErrorMessages,hshowErrorMessages,gnewErrorMessage
    ,anewErrorMessage,hnewErrorMessage,gnewErrorUnknown,anewErrorUnknown
    ,hnewErrorUnknown,gaddErrorMessage,aaddErrorMessage,haddErrorMessage
    ,gsetErrorPos,asetErrorPos,hsetErrorPos,gsetErrorMessage,asetErrorMessage
    ,hsetErrorMessage,gmergeError,amergeError,hmergeError) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Data.List  (gnub,gsortBy,asortBy,hsortBy)
import Hat.Text.ParserCombinators.Parsec.Pos 

data Message =
  SysUnExpect !(T.R String) | UnExpect !(T.R String) | Expect !(T.R String)
  | Message !(T.R String)

instance T.WrapVal (Message)
  where
  
  wrapVal pwrapVal (kwrapVal@(SysUnExpect (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aSysUnExpect z1wrapVal)
  wrapVal pwrapVal (kwrapVal@(UnExpect (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aUnExpect z1wrapVal)
  wrapVal pwrapVal (kwrapVal@(Expect (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aExpect z1wrapVal)
  wrapVal pwrapVal (kwrapVal@(Message (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aMessage z1wrapVal)
  

gmessageToEnum pmessageToEnum p =
  T.ufun1 amessageToEnum pmessageToEnum p hmessageToEnum

hmessageToEnum fmsg p =
  T.uccase T.mkNoSrcPos p
    (let
      v42v7v45v36v1 (T.R (SysUnExpect _) _) p =
        T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
            (T.conInteger T.mkNoSrcPos p 0)
          :: T.R Integer
      v42v7v45v36v1 (T.R (UnExpect _) _) p =
        T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
          (T.conInteger T.mkNoSrcPos p 1)
      v42v7v45v36v1 (T.R (Expect _) _) p =
        T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
          (T.conInteger T.mkNoSrcPos p 2)
      v42v7v45v36v1 (T.R (Message _) _) p =
        T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
          (T.conInteger T.mkNoSrcPos p 3)
      v42v7v45v36v1 _ p = T.fatal p in (v42v7v45v36v1)) fmsg

gmessageCompare ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Message (T.Fun Message Ordering))

hmessageCompare :: (T.R Message) -> (T.R Message) -> T.RefExp -> T.R Ordering

gmessageCompare pmessageCompare p =
  T.ufun2 amessageCompare pmessageCompare p hmessageCompare

hmessageCompare fmsg1 fmsg2 p =
  T.uap2 T.mkNoSrcPos p (gcompare T.mkNoSrcPos p)
    (T.uwrapForward p (hmessageToEnum fmsg1 p))
    (T.uwrapForward p (hmessageToEnum fmsg2 p))

gmessageString :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun Message String)

hmessageString :: (T.R Message) -> T.RefExp -> T.R String

gmessageString pmessageString p =
  T.ufun1 amessageString pmessageString p hmessageString

hmessageString fmsg p =
  T.uccase T.mkNoSrcPos p
    (let
      v53v7v56v36v1 (T.R (SysUnExpect fs) _) p = T.projection T.mkNoSrcPos p fs
      v53v7v56v36v1 (T.R (UnExpect fs) _) p = T.projection T.mkNoSrcPos p fs
      v53v7v56v36v1 (T.R (Expect fs) _) p = T.projection T.mkNoSrcPos p fs
      v53v7v56v36v1 (T.R (Message fs) _) p = T.projection T.mkNoSrcPos p fs
      v53v7v56v36v1 _ p = T.fatal p in (v53v7v56v36v1)) fmsg

gmessageEq ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Message (T.Fun Message Bool))

hmessageEq :: (T.R Message) -> (T.R Message) -> T.RefExp -> T.R Bool

gmessageEq pmessageEq p = T.ufun2 amessageEq pmessageEq p hmessageEq

hmessageEq fmsg1 fmsg2 p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !== p)
    (T.uwrapForward p (hmessageCompare fmsg1 fmsg2 p))
    (T.con0 T.mkNoSrcPos p EQ aEQ)

data ParseError = ParseError !(T.R SourcePos) (T.R (T.List Message))

instance T.WrapVal (ParseError)
  where
  
  wrapVal pwrapVal (kwrapVal@(ParseError (T.R _ z1wrapVal) (T.R _ z2wrapVal)))
    p =
    T.R kwrapVal (T.mkValueApp2 p pwrapVal aParseError z1wrapVal z2wrapVal)
  

gerrorPos :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun ParseError SourcePos)

herrorPos :: (T.R ParseError) -> T.RefExp -> T.R SourcePos

gerrorPos perrorPos p = T.ufun1 aerrorPos perrorPos p herrorPos

herrorPos (T.R (ParseError fpos fmsgs) _) p = T.projection T.mkNoSrcPos p fpos
herrorPos _ p = T.fatal p

gerrorMessages ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun ParseError (T.List Message))

herrorMessages :: (T.R ParseError) -> T.RefExp -> T.R (T.List Message)

gerrorMessages perrorMessages p =
  T.ufun1 aerrorMessages perrorMessages p herrorMessages

herrorMessages (T.R (ParseError fpos fmsgs) _) p =
  T.uap2 T.mkNoSrcPos p (gsortBy T.mkNoSrcPos p)
    (gmessageCompare T.mkNoSrcPos p) fmsgs
herrorMessages _ p = T.fatal p

gerrorIsUnknown :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun ParseError Bool)

herrorIsUnknown :: (T.R ParseError) -> T.RefExp -> T.R Bool

gerrorIsUnknown perrorIsUnknown p =
  T.ufun1 aerrorIsUnknown perrorIsUnknown p herrorIsUnknown

herrorIsUnknown (T.R (ParseError fpos fmsgs) _) p =
  T.uwrapForward p (hnull fmsgs p)
herrorIsUnknown _ p = T.fatal p

gnewErrorUnknown :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun SourcePos ParseError)

hnewErrorUnknown :: (T.R SourcePos) -> T.RefExp -> T.R ParseError

gnewErrorUnknown pnewErrorUnknown p =
  T.ufun1 anewErrorUnknown pnewErrorUnknown p hnewErrorUnknown

hnewErrorUnknown fpos p =
  T.con2 T.mkNoSrcPos p ParseError aParseError fpos
    (T.con0 T.mkNoSrcPos p T.List T.aList)

gnewErrorMessage ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Message (T.Fun SourcePos ParseError))

hnewErrorMessage ::
  (T.R Message) -> (T.R SourcePos) -> T.RefExp -> T.R ParseError

gnewErrorMessage pnewErrorMessage p =
  T.ufun2 anewErrorMessage pnewErrorMessage p hnewErrorMessage

hnewErrorMessage fmsg fpos p =
  T.con2 T.mkNoSrcPos p ParseError aParseError fpos
    (T.fromExpList T.mkNoSrcPos p [fmsg])

gaddErrorMessage ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Message (T.Fun ParseError ParseError))

haddErrorMessage ::
  (T.R Message) -> (T.R ParseError) -> T.RefExp -> T.R ParseError

gaddErrorMessage paddErrorMessage p =
  T.ufun2 aaddErrorMessage paddErrorMessage p haddErrorMessage

haddErrorMessage fmsg (T.R (ParseError fpos fmsgs) _) p =
  T.con2 T.mkNoSrcPos p ParseError aParseError fpos
    (T.con2 T.mkNoSrcPos p T.Cons T.aCons fmsg fmsgs)
haddErrorMessage _ _ p = T.fatal p

gsetErrorPos ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun SourcePos (T.Fun ParseError ParseError))

hsetErrorPos ::
  (T.R SourcePos) -> (T.R ParseError) -> T.RefExp -> T.R ParseError

gsetErrorPos psetErrorPos p = T.ufun2 asetErrorPos psetErrorPos p hsetErrorPos

hsetErrorPos fpos (T.R (ParseError _ fmsgs) _) p =
  T.con2 T.mkNoSrcPos p ParseError aParseError fpos fmsgs
hsetErrorPos _ _ p = T.fatal p

gsetErrorMessage ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun Message (T.Fun ParseError ParseError))

hsetErrorMessage ::
  (T.R Message) -> (T.R ParseError) -> T.RefExp -> T.R ParseError

gsetErrorMessage psetErrorMessage p =
  T.ufun2 asetErrorMessage psetErrorMessage p hsetErrorMessage

hsetErrorMessage fmsg (T.R (ParseError fpos fmsgs) _) p =
  T.con2 T.mkNoSrcPos p ParseError aParseError fpos
    (T.con2 T.mkNoSrcPos p T.Cons T.aCons fmsg
      (T.uwrapForward p
        (hfilter
          (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (gnot T.mkNoSrcPos p)
            (T.uap1 T.mkNoSrcPos p (gmessageEq T.mkNoSrcPos p) fmsg)) fmsgs p)))
hsetErrorMessage _ _ p = T.fatal p

gmergeError ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun ParseError (T.Fun ParseError ParseError))

hmergeError ::
  (T.R ParseError) -> (T.R ParseError) -> T.RefExp -> T.R ParseError

gmergeError pmergeError p = T.ufun2 amergeError pmergeError p hmergeError

hmergeError (T.R (ParseError fpos fmsgs1) _) (T.R (ParseError _ fmsgs2) _) p =
  T.con2 T.mkNoSrcPos p ParseError aParseError fpos
    (T.uwrapForward p ((fmsgs1 *++ fmsgs2) p))
hmergeError _ _ p = T.fatal p

instance Show (ParseError)
  where
  
  gshow pshow p =
    T.ufun1 a115v3v119v41show pshow p hshow
    where
    
    hshow ferr p =
      T.uwrapForward p
        (((T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p)
              (T.uwrapForward p (herrorPos ferr p)))
            *++
            (T.uwrapForward p
              (((T.fromLitString T.mkNoSrcPos p ":")
                  *++
                  (T.uap6 T.mkNoSrcPos p (gshowErrorMessages T.mkNoSrcPos p)
                    (T.fromLitString T.mkNoSrcPos p "or")
                    (T.fromLitString T.mkNoSrcPos p "unknown parse error")
                    (T.fromLitString T.mkNoSrcPos p "expecting")
                    (T.fromLitString T.mkNoSrcPos p "unexpected")
                    (T.fromLitString T.mkNoSrcPos p "end of input")
                    (T.uwrapForward p (herrorMessages ferr p)))) p))) p)
    
  

gshowErrorMessages pshowErrorMessages p =
  T.ufun6 ashowErrorMessages pshowErrorMessages p hshowErrorMessages

hshowErrorMessages fmsgOr fmsgUnknown fmsgExpecting fmsgUnExpected
  fmsgEndOfInput fmsgs p =
  T.ucguard (T.uwrapForward p (hnull fmsgs p))
    (T.projection T.mkNoSrcPos p fmsgUnknown)
    (T.ucguard (gotherwise T.mkNoSrcPos p)
      (T.uwrapForward p
        (((gconcat T.mkNoSrcPos p)
            *$
            (T.uwrapForward p
              (((T.uap1 T.mkNoSrcPos p (gmap T.mkNoSrcPos p)
                    (T.uap1 T.mkNoSrcPos p (T.mkNoSrcPos !++ p)
                      (T.fromLitString T.mkNoSrcPos p "\n")))
                  *$
                  (T.uwrapForward p
                    (((gclean T.mkNoSrcPos p)
                        *$
                        (T.fromExpList T.mkNoSrcPos p
                          [gshowSysUnExpect T.mkNoSrcPos p
                            ,gshowUnExpect T.mkNoSrcPos p
                            ,gshowExpect T.mkNoSrcPos p
                            ,gshowMessages T.mkNoSrcPos p])) p))) p))) p))
      (T.fatal p))
  where
  
  gsysUnExpect psysUnExpect p = T.uconstUse psysUnExpect p ssysUnExpect
  
  gmsgs1 psysUnExpect p = T.uconstUse psysUnExpect p smsgs1
  
  j128v7v128v25sysUnExpect =
    case
      T.uwrapForward p
        (hspan
          (T.uap1 T.mkNoSrcPos p (gmessageEq T.mkNoSrcPos p)
            (T.con1 T.mkNoSrcPos p SysUnExpect aSysUnExpect
              (T.fromLitString T.mkNoSrcPos p ""))) fmsgs p) of
      T.R (T.Tuple2 fsysUnExpect fmsgs1) ksysUnExpect ->
        (ksysUnExpect,fsysUnExpect,fmsgs1)
      _ -> T.fatal p
  
  ssysUnExpect =
    T.uconstDef p a128v8v128v18sysUnExpect
      (\ _ ->
        case j128v7v128v25sysUnExpect of
          (ksysUnExpect,fsysUnExpect,fmsgs1) -> fsysUnExpect)
  
  smsgs1 =
    T.uconstDef p a128v20v128v24msgs1
      (\ _ ->
        case j128v7v128v25sysUnExpect of
          (ksysUnExpect,fsysUnExpect,fmsgs1) -> fmsgs1)
  
  gunExpect punExpect p = T.uconstUse punExpect p sunExpect
  
  gmsgs2 punExpect p = T.uconstUse punExpect p smsgs2
  
  j129v7v129v22unExpect =
    case
      T.uwrapForward p
        (hspan
          (T.uap1 T.mkNoSrcPos p (gmessageEq T.mkNoSrcPos p)
            (T.con1 T.mkNoSrcPos p UnExpect aUnExpect
              (T.fromLitString T.mkNoSrcPos p ""))) (gmsgs1 T.mkNoSrcPos p)
          p) of
      T.R (T.Tuple2 funExpect fmsgs2) kunExpect -> (kunExpect,funExpect,fmsgs2)
      _ -> T.fatal p
  
  sunExpect =
    T.uconstDef p a129v8v129v15unExpect
      (\ _ ->
        case j129v7v129v22unExpect of (kunExpect,funExpect,fmsgs2) -> funExpect)
  
  smsgs2 =
    T.uconstDef p a129v17v129v21msgs2
      (\ _ ->
        case j129v7v129v22unExpect of (kunExpect,funExpect,fmsgs2) -> fmsgs2)
  
  gexpect pexpect p = T.uconstUse pexpect p sexpect
  
  gmessages pexpect p = T.uconstUse pexpect p smessages
  
  j130v7v130v23expect =
    case
      T.uwrapForward p
        (hspan
          (T.uap1 T.mkNoSrcPos p (gmessageEq T.mkNoSrcPos p)
            (T.con1 T.mkNoSrcPos p Expect aExpect
              (T.fromLitString T.mkNoSrcPos p ""))) (gmsgs2 T.mkNoSrcPos p)
          p) of
      T.R (T.Tuple2 fexpect fmessages) kexpect -> (kexpect,fexpect,fmessages)
      _ -> T.fatal p
  
  sexpect =
    T.uconstDef p a130v8v130v13expect
      (\ _ ->
        case j130v7v130v23expect of (kexpect,fexpect,fmessages) -> fexpect)
  
  smessages =
    T.uconstDef p a130v15v130v22messages
      (\ _ ->
        case j130v7v130v23expect of (kexpect,fexpect,fmessages) -> fmessages)
  
  gshowExpect pshowExpect p = T.uconstUse pshowExpect p sshowExpect
  
  sshowExpect =
    T.uconstDef p a132v7v132v54showExpect
      (\ p ->
        T.uwrapForward p (hshowMany fmsgExpecting (gexpect T.mkNoSrcPos p) p))
  
  gshowUnExpect pshowUnExpect p = T.uconstUse pshowUnExpect p sshowUnExpect
  
  sshowUnExpect =
    T.uconstDef p a133v7v133v57showUnExpect
      (\ p ->
        T.uwrapForward p
          (hshowMany fmsgUnExpected (gunExpect T.mkNoSrcPos p) p))
  
  gshowSysUnExpect pshowSysUnExpect p =
    T.uconstUse pshowSysUnExpect p sshowSysUnExpect
  
  sshowSysUnExpect =
    T.uconstDef p a134v7v139v69showSysUnExpect
      (\ p ->
        let
          gfirstMsg pfirstMsg p = T.uconstUse pfirstMsg p sfirstMsg
          sfirstMsg =
            T.uconstDef p a139v27v139v69firstMsg
              (\ p ->
                T.uwrapForward p
                  (hmessageString
                    (T.uwrapForward p (hhead (gsysUnExpect T.mkNoSrcPos p) p))
                    p)) in
          (T.ucguard
            (T.uwrapForward p
              (((T.uwrapForward p
                    (hnot
                      (T.uwrapForward p (hnull (gunExpect T.mkNoSrcPos p) p))
                      p))
                  *||
                  (T.uwrapForward p (hnull (gsysUnExpect T.mkNoSrcPos p) p)))
                p)) (T.fromLitString T.mkNoSrcPos p "")
            (T.ucguard (T.uwrapForward p (hnull (gfirstMsg T.mkNoSrcPos p) p))
              (T.uwrapForward p
                ((fmsgUnExpected
                    *++
                    (T.uwrapForward p
                      (((T.fromLitString T.mkNoSrcPos p " ") *++ fmsgEndOfInput)
                        p))) p))
              (T.ucguard (gotherwise T.mkNoSrcPos p)
                (T.uwrapForward p
                  ((fmsgUnExpected
                      *++
                      (T.uwrapForward p
                        (((T.fromLitString T.mkNoSrcPos p " ")
                            *++
                            (gfirstMsg T.mkNoSrcPos p)) p))) p)) (T.fatal p)))))
  
  gshowMessages pshowMessages p = T.uconstUse pshowMessages p sshowMessages
  
  sshowMessages =
    T.uconstDef p a141v7v141v46showMessages
      (\ p ->
        T.uwrapForward p
          (hshowMany (T.fromLitString T.mkNoSrcPos p "")
            (gmessages T.mkNoSrcPos p) p))
  
  gshowMany pshowMany p = T.ufun2 a145v7v148v71showMany pshowMany p hshowMany
  
  ashowMany = a145v7v148v71showMany
  
  hshowMany fpre fmsgs p =
    T.uccase T.mkNoSrcPos p
      (let
        v145v27v148v71v1 (T.R T.List _) p = T.fromLitString T.mkNoSrcPos p ""
        v145v27v148v71v1 fms p =
          T.ucguard (T.uwrapForward p (hnull fpre p))
            (T.uwrapForward p (hcommasOr fms p))
            (T.ucguard (gotherwise T.mkNoSrcPos p)
              (T.uwrapForward p
                ((fpre
                    *++
                    (T.uwrapForward p
                      (((T.fromLitString T.mkNoSrcPos p " ")
                          *++
                          (T.uwrapForward p (hcommasOr fms p))) p))) p))
              (T.fatal p)) in (v145v27v148v71v1))
      (T.uap1 T.mkNoSrcPos p (gclean T.mkNoSrcPos p)
        (T.uwrapForward p (hmap (gmessageString T.mkNoSrcPos p) fmsgs p)))
  
  gcommasOr pcommasOr p = T.ufun1 a150v7v152v78commasOr pcommasOr p hcommasOr
  
  acommasOr = a150v7v152v78commasOr
  
  hcommasOr (T.R T.List _) p = T.fromLitString T.mkNoSrcPos p ""
  hcommasOr (T.R (T.Cons fm (T.R T.List _)) _) p =
    T.projection T.mkNoSrcPos p fm
  hcommasOr fms p =
    T.uwrapForward p
      (((T.uap1 T.mkNoSrcPos p (gcommaSep T.mkNoSrcPos p)
            (T.uwrapForward p (hinit fms p)))
          *++
          (T.uwrapForward p
            (((T.fromLitString T.mkNoSrcPos p " ")
                *++
                (T.uwrapForward p
                  ((fmsgOr
                      *++
                      (T.uwrapForward p
                        (((T.fromLitString T.mkNoSrcPos p " ")
                            *++
                            (T.uwrapForward p (hlast fms p))) p))) p))) p))) p)
  
  gcommaSep pcommaSep p = T.uconstUse pcommaSep p scommaSep
  
  scommaSep =
    T.uconstDef p a154v7v154v47commaSep
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.uap1 T.mkNoSrcPos p (gseperate T.mkNoSrcPos p)
            (T.fromLitString T.mkNoSrcPos p ", ")) (gclean T.mkNoSrcPos p))
  
  gsemiSep psemiSep p = T.uconstUse psemiSep p ssemiSep
  
  ssemiSep =
    T.uconstDef p a155v7v155v47semiSep
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p)
          (T.uap1 T.mkNoSrcPos p (gseperate T.mkNoSrcPos p)
            (T.fromLitString T.mkNoSrcPos p "; ")) (gclean T.mkNoSrcPos p))
  
  gseperate pseperate p = T.ufun2 a157v7v159v55seperate pseperate p hseperate
  
  aseperate = a157v7v159v55seperate
  
  hseperate fsep (T.R T.List _) p = T.fromLitString T.mkNoSrcPos p ""
  hseperate fsep (T.R (T.Cons fm (T.R T.List _)) _) p =
    T.projection T.mkNoSrcPos p fm
  hseperate fsep (T.R (T.Cons fm fms) _) p =
    T.uwrapForward p
      ((fm
          *++
          (T.uwrapForward p
            ((fsep *++ (T.uwrapForward p (hseperate fsep fms p))) p))) p)
  hseperate _ _ p = T.fatal p
  
  gclean pclean p = T.uconstUse pclean p sclean
  
  sclean =
    T.uconstDef p a161v7v161v48clean
      (\ p ->
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (gnub T.mkNoSrcPos p)
          (T.uap1 T.mkNoSrcPos p (gfilter T.mkNoSrcPos p)
            (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !. p) (gnot T.mkNoSrcPos p)
              (gnull T.mkNoSrcPos p))))
  

tText_ParserCombinators_Parsec_Error =
  T.mkModule "Text.ParserCombinators.Parsec.Error"
    "Text/ParserCombinators/Parsec/Error.hs" Prelude.False

aSysUnExpect =
  T.mkConstructor tText_ParserCombinators_Parsec_Error 360023 360033 3 1
    "SysUnExpect"

aUnExpect =
  T.mkConstructor tText_ParserCombinators_Parsec_Error 370023 370030 3 1
    "UnExpect"

aExpect =
  T.mkConstructor tText_ParserCombinators_Parsec_Error 380023 380028 3 1
    "Expect"

aMessage =
  T.mkConstructor tText_ParserCombinators_Parsec_Error 390023 390029 3 1
    "Message"

aParseError =
  T.mkConstructor tText_ParserCombinators_Parsec_Error 660023 660032 3 2
    "ParseError"

amessageToEnum =
  T.mkVariable tText_ParserCombinators_Parsec_Error 410001 450036 3 1
    "messageToEnum" Prelude.False

amessageCompare =
  T.mkVariable tText_ParserCombinators_Parsec_Error 480001 490054 3 2
    "messageCompare" Prelude.False

amessageString =
  T.mkVariable tText_ParserCombinators_Parsec_Error 520001 560036 3 1
    "messageString" Prelude.False

amessageEq =
  T.mkVariable tText_ParserCombinators_Parsec_Error 590001 600037 3 2
    "messageEq" Prelude.False

aerrorPos =
  T.mkVariable tText_ParserCombinators_Parsec_Error 690001 700009 3 1 "errorPos"
    Prelude.False

aerrorMessages =
  T.mkVariable tText_ParserCombinators_Parsec_Error 730001 740032 3 1
    "errorMessages" Prelude.False

aerrorIsUnknown =
  T.mkVariable tText_ParserCombinators_Parsec_Error 770001 780015 3 1
    "errorIsUnknown" Prelude.False

anewErrorUnknown =
  T.mkVariable tText_ParserCombinators_Parsec_Error 850001 860023 3 1
    "newErrorUnknown" Prelude.False

anewErrorMessage =
  T.mkVariable tText_ParserCombinators_Parsec_Error 890001 900026 3 2
    "newErrorMessage" Prelude.False

aaddErrorMessage =
  T.mkVariable tText_ParserCombinators_Parsec_Error 930001 940030 3 2
    "addErrorMessage" Prelude.False

asetErrorPos =
  T.mkVariable tText_ParserCombinators_Parsec_Error 970001 980025 3 2
    "setErrorPos" Prelude.False

asetErrorMessage =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1010001 1020059 3 2
    "setErrorMessage" Prelude.False

amergeError =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1060001 1070036 3 2
    "mergeError" Prelude.False

a115v3v119v41show =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1150003 1190041 3 1 "show"
    Prelude.False

ashowErrorMessages =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1230001 1610048 3 6
    "showErrorMessages" Prelude.False

a128v8v128v18sysUnExpect =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1280008 1280018 3 0
    "sysUnExpect" Prelude.True

a128v20v128v24msgs1 =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1280020 1280024 3 0 "msgs1"
    Prelude.True

a129v8v129v15unExpect =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1290008 1290015 3 0
    "unExpect" Prelude.True

a129v17v129v21msgs2 =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1290017 1290021 3 0 "msgs2"
    Prelude.True

a130v8v130v13expect =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1300008 1300013 3 0 "expect"
    Prelude.True

a130v15v130v22messages =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1300015 1300022 3 0
    "messages" Prelude.True

a132v7v132v54showExpect =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1320007 1320054 3 0
    "showExpect" Prelude.True

a133v7v133v57showUnExpect =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1330007 1330057 3 0
    "showUnExpect" Prelude.True

a134v7v139v69showSysUnExpect =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1340007 1390069 3 0
    "showSysUnExpect" Prelude.True

a141v7v141v46showMessages =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1410007 1410046 3 0
    "showMessages" Prelude.True

a145v7v148v71showMany =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1450007 1480071 3 2
    "showMany" Prelude.True

a150v7v152v78commasOr =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1500007 1520078 3 1
    "commasOr" Prelude.True

a154v7v154v47commaSep =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1540007 1540047 3 0
    "commaSep" Prelude.True

a155v7v155v47semiSep =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1550007 1550047 3 0
    "semiSep" Prelude.True

a157v7v159v55seperate =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1570007 1590055 3 2
    "seperate" Prelude.True

a161v7v161v48clean =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1610007 1610048 3 0 "clean"
    Prelude.True

a139v27v139v69firstMsg =
  T.mkVariable tText_ParserCombinators_Parsec_Error 1390027 1390069 3 0
    "firstMsg" Prelude.True
