module Hat.Text.ParserCombinators.Parsec.Expr
  (Assoc(AssocNone,AssocLeft,AssocRight),aAssocNone,aAssocLeft,aAssocRight
    ,Operator(Infix,Prefix,Postfix),aInfix,aPrefix,aPostfix,OperatorTable()
    ,gbuildExpressionParser,abuildExpressionParser,hbuildExpressionParser) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Text.ParserCombinators.Parsec.Prim 
import Hat.Text.ParserCombinators.Parsec.Combinator 

data Assoc = AssocNone  | AssocLeft  | AssocRight 

instance T.WrapVal (Assoc)
  where
  
  wrapVal pwrapVal (kwrapVal@AssocNone) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aAssocNone)
  wrapVal pwrapVal (kwrapVal@AssocLeft) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aAssocLeft)
  wrapVal pwrapVal (kwrapVal@AssocRight) p =
    T.R kwrapVal (T.mkValueUse p pwrapVal aAssocRight)
  

data Operator t st a =
  Infix (T.R (GenParser t st (T.Fun a (T.Fun a a)))) (T.R Assoc)
  | Prefix (T.R (GenParser t st (T.Fun a a)))
  | Postfix (T.R (GenParser t st (T.Fun a a)))

instance T.WrapVal ((Operator t st a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Infix (T.R _ z1wrapVal) (T.R _ z2wrapVal))) p =
    T.R kwrapVal (T.mkValueApp2 p pwrapVal aInfix z1wrapVal z2wrapVal)
  wrapVal pwrapVal (kwrapVal@(Prefix (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aPrefix z1wrapVal)
  wrapVal pwrapVal (kwrapVal@(Postfix (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aPostfix z1wrapVal)
  

type OperatorTable t st a = T.List (T.List (Operator t st a))

gbuildExpressionParser ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (OperatorTable tok st a)
          (T.Fun (GenParser tok st a) (GenParser tok st a)))

hbuildExpressionParser ::
  (T.R (OperatorTable tok st a)) ->
    (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st a)

gbuildExpressionParser pbuildExpressionParser p =
  T.ufun2 abuildExpressionParser pbuildExpressionParser p hbuildExpressionParser

hbuildExpressionParser foperators fsimpleExpr p =
  T.uwrapForward p
    (hfoldl (gmakeParser T.mkNoSrcPos p) fsimpleExpr foperators p)
  where
  
  gmakeParser pmakeParser p =
    T.ufun2 a48v7v108v33makeParser pmakeParser p hmakeParser
  
  amakeParser = a48v7v108v33makeParser
  
  hmakeParser fterm fops p =
    let
      grassoc prassoc p = T.uconstUse prassoc p srassoc
      glassoc prassoc p = T.uconstUse prassoc p slassoc
      gnassoc prassoc p = T.uconstUse prassoc p snassoc
      gprefix prassoc p = T.uconstUse prassoc p sprefix
      gpostfix prassoc p = T.uconstUse prassoc p spostfix
      j49v15v50v31rassoc =
        case
          T.uwrapForward p
            (hfoldr (gsplitOp T.mkNoSrcPos p)
              (T.con5 T.mkNoSrcPos p T.Tuple5 T.aTuple5
                (T.con0 T.mkNoSrcPos p T.List T.aList)
                (T.con0 T.mkNoSrcPos p T.List T.aList)
                (T.con0 T.mkNoSrcPos p T.List T.aList)
                (T.con0 T.mkNoSrcPos p T.List T.aList)
                (T.con0 T.mkNoSrcPos p T.List T.aList)) fops p) of
          T.R (T.Tuple5 frassoc flassoc fnassoc fprefix fpostfix) krassoc ->
            (krassoc,frassoc,flassoc,fnassoc,fprefix,fpostfix)
          _ -> T.fatal p
      srassoc =
        T.uconstDef p a49v16v49v21rassoc
          (\ _ ->
            case j49v15v50v31rassoc of
              (krassoc,frassoc,flassoc,fnassoc,fprefix,fpostfix) -> frassoc)
      slassoc =
        T.uconstDef p a49v23v49v28lassoc
          (\ _ ->
            case j49v15v50v31rassoc of
              (krassoc,frassoc,flassoc,fnassoc,fprefix,fpostfix) -> flassoc)
      snassoc =
        T.uconstDef p a49v30v49v35nassoc
          (\ _ ->
            case j49v15v50v31rassoc of
              (krassoc,frassoc,flassoc,fnassoc,fprefix,fpostfix) -> fnassoc)
      sprefix =
        T.uconstDef p a50v17v50v22prefix
          (\ _ ->
            case j49v15v50v31rassoc of
              (krassoc,frassoc,flassoc,fnassoc,fprefix,fpostfix) -> fprefix)
      spostfix =
        T.uconstDef p a50v24v50v30postfix
          (\ _ ->
            case j49v15v50v31rassoc of
              (krassoc,frassoc,flassoc,fnassoc,fprefix,fpostfix) -> fpostfix)
      grassocOp prassocOp p = T.uconstUse prassocOp p srassocOp
      srassocOp =
        T.uconstDef p a52v15v52v40rassocOp
          (\ p -> T.uwrapForward p (hchoice (grassoc T.mkNoSrcPos p) p))
      glassocOp plassocOp p = T.uconstUse plassocOp p slassocOp
      slassocOp =
        T.uconstDef p a53v15v53v40lassocOp
          (\ p -> T.uwrapForward p (hchoice (glassoc T.mkNoSrcPos p) p))
      gnassocOp pnassocOp p = T.uconstUse pnassocOp p snassocOp
      snassocOp =
        T.uconstDef p a54v15v54v40nassocOp
          (\ p -> T.uwrapForward p (hchoice (gnassoc T.mkNoSrcPos p) p))
      gprefixOp pprefixOp p = T.uconstUse pprefixOp p sprefixOp
      sprefixOp =
        T.uconstDef p a55v15v55v48prefixOp
          (\ p ->
            T.uwrapForward p
              (((T.uwrapForward p (hchoice (gprefix T.mkNoSrcPos p) p))
                  *<?>
                  (T.fromLitString T.mkNoSrcPos p "")) p))
      gpostfixOp ppostfixOp p = T.uconstUse ppostfixOp p spostfixOp
      spostfixOp =
        T.uconstDef p a56v15v56v48postfixOp
          (\ p ->
            T.uwrapForward p
              (((T.uwrapForward p (hchoice (gpostfix T.mkNoSrcPos p) p))
                  *<?>
                  (T.fromLitString T.mkNoSrcPos p "")) p))
      gambigious pambigious p =
        T.ufun2 a58v15v60v75ambigious pambigious p hambigious
      aambigious = a58v15v60v75ambigious
      hambigious fassoc fop p =
        T.uwrapForward p
          (((gtry T.mkNoSrcPos p)
              *$
              (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p) fop
                (T.uap1 T.mkNoSrcPos p (gfail T.mkNoSrcPos p)
                  (T.uwrapForward p
                    (((T.fromLitString T.mkNoSrcPos p "ambiguous use of a ")
                        *++
                        (T.uwrapForward p
                          ((fassoc
                              *++
                              (T.fromLitString T.mkNoSrcPos p
                                " associative operator")) p))) p))))) p)
      gambigiousRight pambigiousRight p =
        T.uconstUse pambigiousRight p sambigiousRight
      sambigiousRight =
        T.uconstDef p a63v15v63v60ambigiousRight
          (\ p ->
            T.uwrapForward p
              (hambigious (T.fromLitString T.mkNoSrcPos p "right")
                (grassocOp T.mkNoSrcPos p) p))
      gambigiousLeft pambigiousLeft p =
        T.uconstUse pambigiousLeft p sambigiousLeft
      sambigiousLeft =
        T.uconstDef p a64v15v64v59ambigiousLeft
          (\ p ->
            T.uwrapForward p
              (hambigious (T.fromLitString T.mkNoSrcPos p "left")
                (glassocOp T.mkNoSrcPos p) p))
      gambigiousNon pambigiousNon p = T.uconstUse pambigiousNon p sambigiousNon
      sambigiousNon =
        T.uconstDef p a65v15v65v58ambigiousNon
          (\ p ->
            T.uwrapForward p
              (hambigious (T.fromLitString T.mkNoSrcPos p "non")
                (gnassocOp T.mkNoSrcPos p) p))
      gtermP ptermP p = T.uconstUse ptermP p stermP
      stermP =
        T.uconstDef p a67v15v70v50termP
          (\ p ->
            T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
              (gprefixP T.mkNoSrcPos p)
              (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                (\ fpre p ->
                  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fterm
                    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                      (\ fx p ->
                        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                          (gpostfixP T.mkNoSrcPos p)
                          (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                            (\ fpost p ->
                              T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                                (T.uap1 T.mkNoSrcPos p fpost
                                  (T.uap1 T.mkNoSrcPos p fpre fx)))))))))
      gpostfixP ppostfixP p = T.uconstUse ppostfixP p spostfixP
      spostfixP =
        T.uconstDef p a73v15v73v50postfixP
          (\ p ->
            T.uwrapForward p
              (((gpostfixOp T.mkNoSrcPos p)
                  *<|>
                  (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                    (gid T.mkNoSrcPos p))) p))
      gprefixP pprefixP p = T.uconstUse pprefixP p sprefixP
      sprefixP =
        T.uconstDef p a75v15v75v49prefixP
          (\ p ->
            T.uwrapForward p
              (((gprefixOp T.mkNoSrcPos p)
                  *<|>
                  (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                    (gid T.mkNoSrcPos p))) p))
      grassocP prassocP p = T.ufun1 a77v15v82v43rassocP prassocP p hrassocP
      arassocP = a77v15v82v43rassocP
      hrassocP fx p =
        T.uwrapForward p
          (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                (grassocOp T.mkNoSrcPos p)
                (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                  (\ ff p ->
                    T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                      (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                        (gtermP T.mkNoSrcPos p)
                        (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                          (\ fz p -> T.uwrapForward p (hrassocP1 fz p))))
                      (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                        (\ fy p ->
                          T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                            (T.uap2 T.mkNoSrcPos p ff fx fy))))))
              *<|>
              (T.uwrapForward p
                (((gambigiousLeft T.mkNoSrcPos p)
                    *<|>
                    (gambigiousNon T.mkNoSrcPos p)) p))) p)
      grassocP1 prassocP1 p = T.ufun1 a85v15v85v50rassocP1 prassocP1 p hrassocP1
      arassocP1 = a85v15v85v50rassocP1
      hrassocP1 fx p =
        T.uwrapForward p
          (((T.uwrapForward p (hrassocP fx p))
              *<|>
              (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)) p)
      glassocP plassocP p = T.ufun1 a87v15v92v43lassocP plassocP p hlassocP
      alassocP = a87v15v92v43lassocP
      hlassocP fx p =
        T.uwrapForward p
          (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                (glassocOp T.mkNoSrcPos p)
                (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                  (\ ff p ->
                    T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                      (gtermP T.mkNoSrcPos p)
                      (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                        (\ fy p ->
                          T.uwrapForward p
                            (hlassocP1 (T.uap2 T.mkNoSrcPos p ff fx fy) p))))))
              *<|>
              (T.uwrapForward p
                (((gambigiousRight T.mkNoSrcPos p)
                    *<|>
                    (gambigiousNon T.mkNoSrcPos p)) p))) p)
      glassocP1 plassocP1 p = T.ufun1 a95v15v95v49lassocP1 plassocP1 p hlassocP1
      alassocP1 = a95v15v95v49lassocP1
      hlassocP1 fx p =
        T.uwrapForward p
          (((T.uwrapForward p (hlassocP fx p))
              *<|>
              (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx)) p)
      gnassocP pnassocP p = T.ufun1 a97v15v102v47nassocP pnassocP p hnassocP
      anassocP = a97v15v102v47nassocP
      hnassocP fx p =
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
          (gnassocOp T.mkNoSrcPos p)
          (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
            (\ ff p ->
              T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
                (gtermP T.mkNoSrcPos p)
                (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
                  (\ fy p ->
                    T.uwrapForward p
                      (((gambigiousRight T.mkNoSrcPos p)
                          *<|>
                          (T.uwrapForward p
                            (((gambigiousLeft T.mkNoSrcPos p)
                                *<|>
                                (T.uwrapForward p
                                  (((gambigiousNon T.mkNoSrcPos p)
                                      *<|>
                                      (T.uap1 T.mkNoSrcPos p
                                        (greturn T.mkNoSrcPos p)
                                        (T.uap2 T.mkNoSrcPos p ff fx fy))) p)))
                              p))) p))))) in
      (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
        (gtermP T.mkNoSrcPos p)
        (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
          (\ fx p ->
            T.uwrapForward p
              (((T.uwrapForward p
                    (((T.uwrapForward p (hrassocP fx p))
                        *<|>
                        (T.uwrapForward p
                          (((T.uwrapForward p (hlassocP fx p))
                              *<|>
                              (T.uwrapForward p
                                (((T.uwrapForward p (hnassocP fx p))
                                    *<|>
                                    (T.uap1 T.mkNoSrcPos p
                                      (greturn T.mkNoSrcPos p) fx)) p))) p)))
                      p))
                  *<?>
                  (T.fromLitString T.mkNoSrcPos p "operator")) p))))
  
  gsplitOp psplitOp p = T.ufun2 a112v7v122v50splitOp psplitOp p hsplitOp
  
  asplitOp = a112v7v122v50splitOp
  
  hsplitOp (T.R (Infix fop fassoc) _)
    (T.R (T.Tuple5 frassoc flassoc fnassoc fprefix fpostfix) _) p =
    T.uccase T.mkNoSrcPos p
      (let
        v113v11v116v66v1 (T.R AssocNone _) p =
          T.con5 T.mkNoSrcPos p T.Tuple5 T.aTuple5 frassoc flassoc
            (T.con2 T.mkNoSrcPos p T.Cons T.aCons fop fnassoc) fprefix fpostfix
        v113v11v116v66v1 (T.R AssocLeft _) p =
          T.con5 T.mkNoSrcPos p T.Tuple5 T.aTuple5 frassoc
            (T.con2 T.mkNoSrcPos p T.Cons T.aCons fop flassoc) fnassoc fprefix
            fpostfix
        v113v11v116v66v1 (T.R AssocRight _) p =
          T.con5 T.mkNoSrcPos p T.Tuple5 T.aTuple5
            (T.con2 T.mkNoSrcPos p T.Cons T.aCons fop frassoc) flassoc fnassoc
            fprefix fpostfix
        v113v11v116v66v1 _ p = T.fatal p in (v113v11v116v66v1)) fassoc
  hsplitOp (T.R (Prefix fop) _)
    (T.R (T.Tuple5 frassoc flassoc fnassoc fprefix fpostfix) _) p =
    T.con5 T.mkNoSrcPos p T.Tuple5 T.aTuple5 frassoc flassoc fnassoc
      (T.con2 T.mkNoSrcPos p T.Cons T.aCons fop fprefix) fpostfix
  hsplitOp (T.R (Postfix fop) _)
    (T.R (T.Tuple5 frassoc flassoc fnassoc fprefix fpostfix) _) p =
    T.con5 T.mkNoSrcPos p T.Tuple5 T.aTuple5 frassoc flassoc fnassoc fprefix
      (T.con2 T.mkNoSrcPos p T.Cons T.aCons fop fpostfix)
  hsplitOp _ _ p = T.fatal p
  

tText_ParserCombinators_Parsec_Expr =
  T.mkModule "Text.ParserCombinators.Parsec.Expr"
    "Text/ParserCombinators/Parsec/Expr.hs" Prelude.False

aAssocNone =
  T.mkConstructor tText_ParserCombinators_Parsec_Expr 280029 280037 3 0
    "AssocNone"

aAssocLeft =
  T.mkConstructor tText_ParserCombinators_Parsec_Expr 290029 290037 3 0
    "AssocLeft"

aAssocRight =
  T.mkConstructor tText_ParserCombinators_Parsec_Expr 300029 300038 3 0
    "AssocRight"

aInfix =
  T.mkConstructor tText_ParserCombinators_Parsec_Expr 320029 320033 3 2 "Infix"

aPrefix =
  T.mkConstructor tText_ParserCombinators_Parsec_Expr 330029 330034 3 1 "Prefix"

aPostfix =
  T.mkConstructor tText_ParserCombinators_Parsec_Expr 340029 340035 3 1
    "Postfix"

abuildExpressionParser =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 450001 1220050 3 2
    "buildExpressionParser" Prelude.False

a48v7v108v33makeParser =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 480007 1080033 3 2
    "makeParser" Prelude.True

a112v7v122v50splitOp =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 1120007 1220050 3 2 "splitOp"
    Prelude.True

a49v16v49v21rassoc =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 490016 490021 3 0 "rassoc"
    Prelude.True

a49v23v49v28lassoc =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 490023 490028 3 0 "lassoc"
    Prelude.True

a49v30v49v35nassoc =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 490030 490035 3 0 "nassoc"
    Prelude.True

a50v17v50v22prefix =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 500017 500022 3 0 "prefix"
    Prelude.True

a50v24v50v30postfix =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 500024 500030 3 0 "postfix"
    Prelude.True

a52v15v52v40rassocOp =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 520015 520040 3 0 "rassocOp"
    Prelude.True

a53v15v53v40lassocOp =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 530015 530040 3 0 "lassocOp"
    Prelude.True

a54v15v54v40nassocOp =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 540015 540040 3 0 "nassocOp"
    Prelude.True

a55v15v55v48prefixOp =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 550015 550048 3 0 "prefixOp"
    Prelude.True

a56v15v56v48postfixOp =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 560015 560048 3 0 "postfixOp"
    Prelude.True

a58v15v60v75ambigious =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 580015 600075 3 2 "ambigious"
    Prelude.True

a63v15v63v60ambigiousRight =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 630015 630060 3 0
    "ambigiousRight" Prelude.True

a64v15v64v59ambigiousLeft =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 640015 640059 3 0
    "ambigiousLeft" Prelude.True

a65v15v65v58ambigiousNon =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 650015 650058 3 0
    "ambigiousNon" Prelude.True

a67v15v70v50termP =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 670015 700050 3 0 "termP"
    Prelude.True

a73v15v73v50postfixP =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 730015 730050 3 0 "postfixP"
    Prelude.True

a75v15v75v49prefixP =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 750015 750049 3 0 "prefixP"
    Prelude.True

a77v15v82v43rassocP =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 770015 820043 3 1 "rassocP"
    Prelude.True

a85v15v85v50rassocP1 =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 850015 850050 3 1 "rassocP1"
    Prelude.True

a87v15v92v43lassocP =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 870015 920043 3 1 "lassocP"
    Prelude.True

a95v15v95v49lassocP1 =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 950015 950049 3 1 "lassocP1"
    Prelude.True

a97v15v102v47nassocP =
  T.mkVariable tText_ParserCombinators_Parsec_Expr 970015 1020047 3 1 "nassocP"
    Prelude.True
