module Hat.Text.ParserCombinators.Parsec.Perm
  (PermParser(),gpermute,apermute,hpermute,(!<||>),(+<||>),(*<||>),(!<$$>)
    ,(+<$$>),(*<$$>),(!<|?>),(+<|?>),(*<|?>),(!<$?>),(+<$?>),(*<$?>)) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Text.ParserCombinators.Parsec 

gtest ptest p = T.ufun1 atest ptest p htest

htest finput p =
  T.uwrapForward p
    (hparse
      (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
        (gptest T.mkNoSrcPos p)
        (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
          (\ fx p ->
            T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p)
              (geof T.mkNoSrcPos p)
              (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx))))
      (T.fromLitString T.mkNoSrcPos p "") finput p)

gptest :: T.RefSrcPos -> T.RefExp -> T.R (Parser (T.Tuple3 String Char Char))

sptest :: T.R (Parser (T.Tuple3 String Char Char))

gptest pptest p = T.uconstUse pptest p sptest

sptest =
  T.uconstDef T.mkRoot aptest
    (\ p ->
      T.uwrapForward p
        (((gpermute T.mkNoSrcPos p)
            *$
            (T.uwrapForward p
              (((T.uwrapForward p
                    (((T.uwrapForward p
                          (((T.pa0 T.Tuple3 T.cn3 T.mkNoSrcPos p T.aTuple3)
                              *<$?>
                              (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                                (T.fromLitString T.mkNoSrcPos p "")
                                (T.uwrapForward p
                                  (hmany1
                                    (T.uwrapForward p
                                      (hchar (T.conChar T.mkNoSrcPos p 'a') p))
                                    p)))) p))
                        *<||>
                        (T.uwrapForward p
                          (hchar (T.conChar T.mkNoSrcPos p 'b') p))) p))
                  *<|?>
                  (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2
                    (T.conChar T.mkNoSrcPos p '_')
                    (T.uwrapForward p
                      (hchar (T.conChar T.mkNoSrcPos p 'c') p)))) p))) p))

(!<||>) ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (PermParser tok st (T.Fun a b))
          (T.Fun (GenParser tok st a) (PermParser tok st b)))

(*<||>) ::
  (T.R (PermParser tok st (T.Fun a b))) ->
    (T.R (GenParser tok st a)) -> T.RefExp -> T.R (PermParser tok st b)

(!<||>) (%<||>) p = T.ufun2 (+<||>) (%<||>) p (*<||>)

(*<||>) fperm fp p = T.uwrapForward p (hadd fperm fp p)

(!<$$>) (%<$$>) p = T.ufun2 (+<$$>) (%<$$>) p (*<$$>)

(*<$$>) ff fp p =
  T.uwrapForward p (((T.uwrapForward p (hnewperm ff p)) *<||> fp) p)

(!<|?>) (%<|?>) p = T.ufun2 (+<|?>) (%<|?>) p (*<|?>)

(*<|?>) fperm (T.R (T.Tuple2 fx fp) _) p =
  T.uwrapForward p (haddopt fperm fx fp p)
(*<|?>) _ _ p = T.fatal p

(!<$?>) (%<$?>) p = T.ufun2 (+<$?>) (%<$?>) p (*<$?>)

(*<$?>) ff (T.R (T.Tuple2 fx fp) _) p =
  T.uwrapForward p
    (((T.uwrapForward p (hnewperm ff p))
        *<|?>
        (T.con2 T.mkNoSrcPos p T.Tuple2 T.aTuple2 fx fp)) p)
(*<$?>) _ _ p = T.fatal p

data PermParser tok st a = Perm (T.R (Maybe a)) (T.R (T.List (Branch tok st a)))

instance T.WrapVal ((PermParser tok st a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Perm (T.R _ z1wrapVal) (T.R _ z2wrapVal))) p =
    T.R kwrapVal (T.mkValueApp2 p pwrapVal aPerm z1wrapVal z2wrapVal)
  

data Branch tok st a =
  forall b. Branch
    (T.R (PermParser tok st (T.Fun b a))) (T.R (GenParser tok st b))

instance T.WrapVal ((Branch tok st a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Branch (T.R _ z1wrapVal) (T.R _ z2wrapVal))) p =
    T.R kwrapVal (T.mkValueApp2 p pwrapVal aBranch z1wrapVal z2wrapVal)
  

gpermute ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (PermParser tok st a) (GenParser tok st a))

hpermute :: (T.R (PermParser tok st a)) -> T.RefExp -> T.R (GenParser tok st a)

gpermute ppermute p = T.ufun1 apermute ppermute p hpermute

hpermute (T.R (Perm fdef fxs) _) p =
  T.uwrapForward p
    (hchoice
      (T.uwrapForward p
        (((T.uwrapForward p (hmap (gbranch T.mkNoSrcPos p) fxs p))
            *++
            (gempty T.mkNoSrcPos p)) p)) p)
  where
  
  gempty pempty p = T.uconstUse pempty p sempty
  
  sempty =
    T.uconstDef p a79v5v82v31empty
      (\ p ->
        T.uccase T.mkNoSrcPos p
          (let
            v80v9v82v31v1 (T.R Nothing _) p =
              T.con0 T.mkNoSrcPos p T.List T.aList
            v80v9v82v31v1 (T.R (Just fx) _) p =
              T.fromExpList T.mkNoSrcPos p
                [T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p) fx]
            v80v9v82v31v1 _ p = T.fatal p in (v80v9v82v31v1)) fdef)
  
  gbranch pbranch p = T.ufun1 a84v5v87v23branch pbranch p hbranch
  
  abranch = a84v5v87v23branch
  
  hbranch (T.R (Branch fperm fp) _) p =
    T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p) fp
      (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
        (\ fx p ->
          T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
            (T.uwrapForward p (hpermute fperm p))
            (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
              (\ ff p ->
                T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
                  (T.uap1 T.mkNoSrcPos p ff fx)))))
  hbranch _ p = T.fatal p
  
hpermute _ p = T.fatal p

gnewperm ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.Fun a b) (PermParser tok st (T.Fun a b)))

hnewperm :: (T.R (T.Fun a b)) -> T.RefExp -> T.R (PermParser tok st (T.Fun a b))

gnewperm pnewperm p = T.ufun1 anewperm pnewperm p hnewperm

hnewperm ff p =
  T.con2 T.mkNoSrcPos p Perm aPerm (T.con1 T.mkNoSrcPos p Just aJust ff)
    (T.con0 T.mkNoSrcPos p T.List T.aList)

gadd ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (PermParser tok st (T.Fun a b))
          (T.Fun (GenParser tok st a) (PermParser tok st b)))

hadd ::
  (T.R (PermParser tok st (T.Fun a b))) ->
    (T.R (GenParser tok st a)) -> T.RefExp -> T.R (PermParser tok st b)

gadd padd p = T.ufun2 aadd padd p hadd

hadd (fperm@(T.R (Perm fmf ffs) _)) fp p =
  T.con2 T.mkNoSrcPos p Perm aPerm (T.con0 T.mkNoSrcPos p Nothing aNothing)
    (T.con2 T.mkNoSrcPos p T.Cons T.aCons (gfirst T.mkNoSrcPos p)
      (T.uwrapForward p (hmap (ginsert T.mkNoSrcPos p) ffs p)))
  where
  
  gfirst pfirst p = T.uconstUse pfirst p sfirst
  
  sfirst =
    T.uconstDef p a99v5v99v27first
      (\ p -> T.con2 T.mkNoSrcPos p Branch aBranch fperm fp)
  
  ginsert pinsert p = T.ufun1 a100v5v101v53insert pinsert p hinsert
  
  ainsert = a100v5v101v53insert
  
  hinsert (T.R (Branch fperm' fp') _) p =
    T.con2 T.mkNoSrcPos p Branch aBranch
      (T.uwrapForward p
        (hadd (T.uwrapForward p (hmapPerms (gflip T.mkNoSrcPos p) fperm' p)) fp
          p)) fp'
  hinsert _ p = T.fatal p
  
hadd _ _ p = T.fatal p

gaddopt ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (PermParser tok st (T.Fun a b))
          (T.Fun a (T.Fun (GenParser tok st a) (PermParser tok st b))))

haddopt ::
  (T.R (PermParser tok st (T.Fun a b))) ->
    (T.R a) ->
      (T.R (GenParser tok st a)) -> T.RefExp -> T.R (PermParser tok st b)

gaddopt paddopt p = T.ufun3 aaddopt paddopt p haddopt

haddopt (fperm@(T.R (Perm fmf ffs) _)) fx fp p =
  T.con2 T.mkNoSrcPos p Perm aPerm
    (T.uap2 T.mkNoSrcPos p (gfmap T.mkNoSrcPos p)
      (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gflip T.mkNoSrcPos p)
        (T.mkNoSrcPos !$ p) fx) fmf)
    (T.con2 T.mkNoSrcPos p T.Cons T.aCons (gfirst T.mkNoSrcPos p)
      (T.uwrapForward p (hmap (ginsert T.mkNoSrcPos p) ffs p)))
  where
  
  gfirst pfirst p = T.uconstUse pfirst p sfirst
  
  sfirst =
    T.uconstDef p a107v5v107v27first
      (\ p -> T.con2 T.mkNoSrcPos p Branch aBranch fperm fp)
  
  ginsert pinsert p = T.ufun1 a108v5v109v58insert pinsert p hinsert
  
  ainsert = a108v5v109v58insert
  
  hinsert (T.R (Branch fperm' fp') _) p =
    T.con2 T.mkNoSrcPos p Branch aBranch
      (T.uwrapForward p
        (haddopt (T.uwrapForward p (hmapPerms (gflip T.mkNoSrcPos p) fperm' p))
          fx fp p)) fp'
  hinsert _ p = T.fatal p
  
haddopt _ _ _ p = T.fatal p

gmapPerms ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun a b) (T.Fun (PermParser tok st a) (PermParser tok st b)))

hmapPerms ::
  (T.R (T.Fun a b)) ->
    (T.R (PermParser tok st a)) -> T.RefExp -> T.R (PermParser tok st b)

gmapPerms pmapPerms p = T.ufun2 amapPerms pmapPerms p hmapPerms

hmapPerms ff (T.R (Perm fx fxs) _) p =
  T.con2 T.mkNoSrcPos p Perm aPerm
    (T.uap2 T.mkNoSrcPos p (gfmap T.mkNoSrcPos p) ff fx)
    (T.uwrapForward p
      (hmap (T.uap1 T.mkNoSrcPos p (gmapBranch T.mkNoSrcPos p) ff) fxs p))
  where
  
  gmapBranch pmapBranch p =
    T.ufun2 a116v5v117v37mapBranch pmapBranch p hmapBranch
  
  amapBranch = a116v5v117v37mapBranch
  
  hmapBranch ff (T.R (Branch fperm fp) _) p =
    T.con2 T.mkNoSrcPos p Branch aBranch
      (T.uwrapForward p
        (hmapPerms (T.uap1 T.mkNoSrcPos p (T.mkNoSrcPos !. p) ff) fperm p)) fp
  hmapBranch _ _ p = T.fatal p
  
hmapPerms _ _ p = T.fatal p

tText_ParserCombinators_Parsec_Perm =
  T.mkModule "Text.ParserCombinators.Parsec.Perm"
    "Text/ParserCombinators/Parsec/Perm.hs" Prelude.False

aPerm =
  T.mkConstructor tText_ParserCombinators_Parsec_Perm 700028 700031 3 2 "Perm"

aBranch =
  T.mkConstructor tText_ParserCombinators_Parsec_Perm 710038 710043 3 2 "Branch"

atest =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 440001 450052 3 1 "test"
    Prelude.False

aptest =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 480001 520028 3 0 "ptest"
    Prelude.False

(+<||>) =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 590002 590030 6 2 "<||>"
    Prelude.False

(+<$$>) =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 600002 600036 10 2 "<$$>"
    Prelude.False

(+<|?>) =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 620002 620035 6 2 "<|?>"
    Prelude.False

(+<$?>) =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 630002 630040 10 2 "<$?>"
    Prelude.False

apermute =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 760001 870023 3 1 "permute"
    Prelude.False

anewperm =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 920001 930020 3 1 "newperm"
    Prelude.False

aadd =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 960001 1010053 3 2 "add"
    Prelude.False

aaddopt =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 1040001 1090058 3 3 "addopt"
    Prelude.False

amapPerms =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 1130001 1170037 3 2
    "mapPerms" Prelude.False

a79v5v82v31empty =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 790005 820031 3 0 "empty"
    Prelude.True

a84v5v87v23branch =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 840005 870023 3 1 "branch"
    Prelude.True

a99v5v99v27first =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 990005 990027 3 0 "first"
    Prelude.True

a100v5v101v53insert =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 1000005 1010053 3 1 "insert"
    Prelude.True

a107v5v107v27first =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 1070005 1070027 3 0 "first"
    Prelude.True

a108v5v109v58insert =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 1080005 1090058 3 1 "insert"
    Prelude.True

a116v5v117v37mapBranch =
  T.mkVariable tText_ParserCombinators_Parsec_Perm 1160005 1170037 3 2
    "mapBranch" Prelude.True
