module Hat.Text.ParserCombinators.Parsec.Pos
  (SourceName(),Line(),Column(),SourcePos(),gsourceLine,asourceLine,hsourceLine
    ,gsourceColumn,asourceColumn,hsourceColumn,gsourceName,asourceName
    ,hsourceName,gincSourceLine,aincSourceLine,hincSourceLine,gincSourceColumn
    ,aincSourceColumn,hincSourceColumn,gsetSourceLine,asetSourceLine
    ,hsetSourceLine,gsetSourceColumn,asetSourceColumn,hsetSourceColumn
    ,gsetSourceName,asetSourceName,hsetSourceName,gnewPos,anewPos,hnewPos
    ,ginitialPos,ainitialPos,hinitialPos,gupdatePosChar,aupdatePosChar
    ,hupdatePosChar,gupdatePosString,aupdatePosString,hupdatePosString) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 

type SourceName = String

type Line = Int

type Column = Int

data SourcePos = SourcePos (T.R SourceName) !(T.R Line) !(T.R Column)

instance T.WrapVal (SourcePos)
  where
  
  wrapVal pwrapVal
    (kwrapVal@(SourcePos (T.R _ z1wrapVal) (T.R _ z2wrapVal) (T.R _ z3wrapVal)))
    p =
    T.R kwrapVal
      (T.mkValueApp3 p pwrapVal aSourcePos z1wrapVal z2wrapVal z3wrapVal)
  

instance Eq (SourcePos)
  where
  
  (!==) (%==) p =
    T.ufun2 (+%&=%$=%&=%%==) (%==) p (*==)
    where
    
    (*==) (T.R (SourcePos fy1 fy2 fy3) _) (T.R (SourcePos fy4 fy5 fy6) _) p =
      T.uwrapForward p
        (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!== p) fy1 fy4)
            Hat.Prelude.*&&
            (T.uwrapForward p
              (((T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!== p) fy2 fy5)
                  Hat.Prelude.*&&
                  (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!== p) fy3
                    fy6)) p))) p)
    (*==) _ _ p = T.con0 T.mkNoSrcPos p Hat.Prelude.False Hat.Prelude.aFalse
    
  

instance Ord (SourcePos)
  where
  
  gcompare pcompare p =
    T.ufun2 a34v35v34v37compare pcompare p hcompare
    where
    
    hcompare (T.R (SourcePos fy3 fy4 fy5) _) (T.R (SourcePos fy6 fy7 fy8) _) p =
      T.uccase T.mkNoSrcPos p
        (let
          v34v35v34v37v1 (T.R Hat.Prelude.EQ _) p =
            T.uccase T.mkNoSrcPos p
              (let
                v34v35v34v37v1 (T.R Hat.Prelude.EQ _) p =
                  T.uap2 T.mkNoSrcPos p (Hat.Prelude.gcompare T.mkNoSrcPos p)
                    fy5 fy8
                v34v35v34v37v1 fy1 p = T.projection T.mkNoSrcPos p fy1 in
                (v34v35v34v37v1))
              (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gcompare T.mkNoSrcPos p) fy4
                fy7)
          v34v35v34v37v1 fy1 p = T.projection T.mkNoSrcPos p fy1 in
          (v34v35v34v37v1))
        (T.uap2 T.mkNoSrcPos p (Hat.Prelude.gcompare T.mkNoSrcPos p) fy3 fy6)
    hcompare fy1 fy2 p =
      T.uap2 T.mkNoSrcPos p (Hat.Prelude.gcompare T.mkNoSrcPos p)
        (T.uwrapForward p (hlocalFromEnum fy1 p) :: T.R Hat.Prelude.Int)
        (T.uwrapForward p (hlocalFromEnum fy2 p))
      where
      
      glocalFromEnum plocalFromEnum p =
        T.ufun1 a34v35v34v37localFromEnum plocalFromEnum p hlocalFromEnum
      
      alocalFromEnum = a34v35v34v37localFromEnum
      
      hlocalFromEnum (T.R (SourcePos _ _ _) _) p =
        T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
          (T.conInteger T.mkNoSrcPos p 0)
      hlocalFromEnum _ p = T.fatal p
      
    
  

gnewPos ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun SourceName (T.Fun Line (T.Fun Column SourcePos)))

hnewPos ::
  (T.R SourceName) -> (T.R Line) -> (T.R Column) -> T.RefExp -> T.R SourcePos

gnewPos pnewPos p = T.ufun3 anewPos pnewPos p hnewPos

hnewPos fsourceName fline fcolumn p =
  T.con3 T.mkNoSrcPos p SourcePos aSourcePos fsourceName fline fcolumn

ginitialPos pinitialPos p = T.ufun1 ainitialPos pinitialPos p hinitialPos

hinitialPos fsourceName p =
  T.uwrapForward p
    (hnewPos fsourceName
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 1))
      (T.uap1 T.mkNoSrcPos p (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
        (T.conInteger T.mkNoSrcPos p 1)) p)

gsourceName psourceName p = T.ufun1 asourceName psourceName p hsourceName

hsourceName (T.R (SourcePos fname fline fcolumn) _) p =
  T.projection T.mkNoSrcPos p fname
hsourceName _ p = T.fatal p

gsourceLine psourceLine p = T.ufun1 asourceLine psourceLine p hsourceLine

hsourceLine (T.R (SourcePos fname fline fcolumn) _) p =
  T.projection T.mkNoSrcPos p fline
hsourceLine _ p = T.fatal p

gsourceColumn psourceColumn p =
  T.ufun1 asourceColumn psourceColumn p hsourceColumn

hsourceColumn (T.R (SourcePos fname fline fcolumn) _) p =
  T.projection T.mkNoSrcPos p fcolumn
hsourceColumn _ p = T.fatal p

gincSourceLine pincSourceLine p =
  T.ufun2 aincSourceLine pincSourceLine p hincSourceLine

hincSourceLine (T.R (SourcePos fname fline fcolumn) _) fn p =
  T.con3 T.mkNoSrcPos p SourcePos aSourcePos fname
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fline fn) fcolumn
hincSourceLine _ _ p = T.fatal p

gincSourceColumn pincSourceColumn p =
  T.ufun2 aincSourceColumn pincSourceColumn p hincSourceColumn

hincSourceColumn (T.R (SourcePos fname fline fcolumn) _) fn p =
  T.con3 T.mkNoSrcPos p SourcePos aSourcePos fname fline
    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fcolumn fn)
hincSourceColumn _ _ p = T.fatal p

gsetSourceName psetSourceName p =
  T.ufun2 asetSourceName psetSourceName p hsetSourceName

hsetSourceName (T.R (SourcePos fname fline fcolumn) _) fn p =
  T.con3 T.mkNoSrcPos p SourcePos aSourcePos fn fline fcolumn
hsetSourceName _ _ p = T.fatal p

gsetSourceLine psetSourceLine p =
  T.ufun2 asetSourceLine psetSourceLine p hsetSourceLine

hsetSourceLine (T.R (SourcePos fname fline fcolumn) _) fn p =
  T.con3 T.mkNoSrcPos p SourcePos aSourcePos fname fn fcolumn
hsetSourceLine _ _ p = T.fatal p

gsetSourceColumn psetSourceColumn p =
  T.ufun2 asetSourceColumn psetSourceColumn p hsetSourceColumn

hsetSourceColumn (T.R (SourcePos fname fline fcolumn) _) fn p =
  T.con3 T.mkNoSrcPos p SourcePos aSourcePos fname fline fn
hsetSourceColumn _ _ p = T.fatal p

gupdatePosString ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun SourcePos (T.Fun String SourcePos))

hupdatePosString :: (T.R SourcePos) -> (T.R String) -> T.RefExp -> T.R SourcePos

gupdatePosString pupdatePosString p =
  T.ufun2 aupdatePosString pupdatePosString p hupdatePosString

hupdatePosString fpos fstring p =
  T.uwrapForward p
    (hforcePos
      (T.uwrapForward p (hfoldl (gupdatePosChar T.mkNoSrcPos p) fpos fstring p))
      p)

gupdatePosChar ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun SourcePos (T.Fun Char SourcePos))

hupdatePosChar :: (T.R SourcePos) -> (T.R Char) -> T.RefExp -> T.R SourcePos

gupdatePosChar pupdatePosChar p =
  T.ufun2 aupdatePosChar pupdatePosChar p hupdatePosChar

hupdatePosChar (fpos@(T.R (SourcePos fname fline fcolumn) _)) fc p =
  T.uwrapForward p
    (((gforcePos T.mkNoSrcPos p)
        *$
        (T.uccase T.mkNoSrcPos p
          (let
            v65v7v69v47v1 (T.R '\n' _) p =
              T.con3 T.mkNoSrcPos p SourcePos aSourcePos fname
                (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fline
                  (T.uap1 T.mkNoSrcPos p
                    (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                    (T.conInteger T.mkNoSrcPos p 1)))
                (T.uap1 T.mkNoSrcPos p
                  (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                  (T.conInteger T.mkNoSrcPos p 1))
            v65v7v69v47v1 (T.R '\o015' _) p =
              T.con3 T.mkNoSrcPos p SourcePos aSourcePos fname
                (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fline
                  (T.uap1 T.mkNoSrcPos p
                    (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                    (T.conInteger T.mkNoSrcPos p 1)))
                (T.uap1 T.mkNoSrcPos p
                  (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                  (T.conInteger T.mkNoSrcPos p 1))
            v65v7v69v47v1 (T.R '\t' _) p =
              T.con3 T.mkNoSrcPos p SourcePos aSourcePos fname fline
                (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p)
                  (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fcolumn
                    (T.uap1 T.mkNoSrcPos p
                      (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                      (T.conInteger T.mkNoSrcPos p 8)))
                  (T.uap2 T.mkNoSrcPos p (gmod T.mkNoSrcPos p)
                    (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !- p) fcolumn
                      (T.uap1 T.mkNoSrcPos p
                        (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                        (T.conInteger T.mkNoSrcPos p 1)))
                    (T.uap1 T.mkNoSrcPos p
                      (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                      (T.conInteger T.mkNoSrcPos p 8))))
            v65v7v69v47v1 _ p =
              T.con3 T.mkNoSrcPos p SourcePos aSourcePos fname fline
                (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !+ p) fcolumn
                  (T.uap1 T.mkNoSrcPos p
                    (Hat.PreludeBasic.gfromInteger T.mkNoSrcPos p)
                    (T.conInteger T.mkNoSrcPos p 1))) in (v65v7v69v47v1)) fc))
      p)
hupdatePosChar _ _ p = T.fatal p

gforcePos :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun SourcePos SourcePos)

hforcePos :: (T.R SourcePos) -> T.RefExp -> T.R SourcePos

gforcePos pforcePos p = T.ufun1 aforcePos pforcePos p hforcePos

hforcePos (fpos@(T.R (SourcePos fname fline fcolumn) _)) p =
  T.uwrapForward p (hseq fline (T.uwrapForward p (hseq fcolumn fpos p)) p)
hforcePos _ p = T.fatal p

instance Show (SourcePos)
  where
  
  gshow pshow p =
    T.ufun1 a80v3v86v29show pshow p hshow
    where
    
    hshow (T.R (SourcePos fname fline fcolumn) _) p =
      T.ucguard (T.uwrapForward p (hnull fname p))
        (gshowLineColumn T.mkNoSrcPos p)
        (T.ucguard (gotherwise T.mkNoSrcPos p)
          (T.uwrapForward p
            (((T.fromLitString T.mkNoSrcPos p "\"")
                *++
                (T.uwrapForward p
                  ((fname
                      *++
                      (T.uwrapForward p
                        (((T.fromLitString T.mkNoSrcPos p "\" ")
                            *++
                            (gshowLineColumn T.mkNoSrcPos p)) p))) p))) p))
          (T.fatal p))
      where
      
      gshowLineColumn pshowLineColumn p =
        T.uconstUse pshowLineColumn p sshowLineColumn
      
      sshowLineColumn =
        T.uconstDef p a84v7v86v29showLineColumn
          (\ p ->
            T.uwrapForward p
              (((T.fromLitString T.mkNoSrcPos p "(line ")
                  *++
                  (T.uwrapForward p
                    (((T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p) fline)
                        *++
                        (T.uwrapForward p
                          (((T.fromLitString T.mkNoSrcPos p ", column ")
                              *++
                              (T.uwrapForward p
                                (((T.uap1 T.mkNoSrcPos p (gshow T.mkNoSrcPos p)
                                      fcolumn)
                                    *++
                                    (T.fromLitString T.mkNoSrcPos p ")")) p)))
                            p))) p))) p))
      
    hshow _ p = T.fatal p
    
  

tText_ParserCombinators_Parsec_Pos =
  T.mkModule "Text.ParserCombinators.Parsec.Pos"
    "Text/ParserCombinators/Parsec/Pos.hs" Prelude.False

aSourcePos =
  T.mkConstructor tText_ParserCombinators_Parsec_Pos 330023 330031 3 3
    "SourcePos"

(+%&=%$=%&=%%==) =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 340032 340033 3 2 "=="
    Prelude.False

a34v35v34v37compare =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 340035 340037 3 2 "compare"
    Prelude.False

anewPos =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 380001 390038 3 3 "newPos"
    Prelude.False

ainitialPos =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 410001 420027 3 1 "initialPos"
    Prelude.False

asourceName =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 440001 440050 3 1 "sourceName"
    Prelude.False

asourceLine =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 450001 450050 3 1 "sourceLine"
    Prelude.False

asourceColumn =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 460001 460052 3 1
    "sourceColumn" Prelude.False

aincSourceLine =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 480001 480082 3 2
    "incSourceLine" Prelude.False

aincSourceColumn =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 490001 490081 3 2
    "incSourceColumn" Prelude.False

asetSourceName =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 510001 510075 3 2
    "setSourceName" Prelude.False

asetSourceLine =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 520001 520075 3 2
    "setSourceLine" Prelude.False

asetSourceColumn =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 530001 530073 3 2
    "setSourceColumn" Prelude.False

aupdatePosString =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 590001 600046 3 2
    "updatePosString" Prelude.False

aupdatePosChar =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 630001 690047 3 2
    "updatePosChar" Prelude.False

aforcePos =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 730001 740031 3 1 "forcePos"
    Prelude.False

a80v3v86v29show =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 800003 860029 3 1 "show"
    Prelude.False

a34v35v34v37localFromEnum =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 340035 340037 3 1
    "localFromEnum" Prelude.True

a84v7v86v29showLineColumn =
  T.mkVariable tText_ParserCombinators_Parsec_Pos 840007 860029 3 0
    "showLineColumn" Prelude.True
