module Hat.Text.ParserCombinators.Parsec.Prim
  ((!<?>),(+<?>),(*<?>),(!<|>),(+<|>),(*<|>),Parser(),GenParser(),grunParser
    ,arunParser,hrunParser,gparse,aparse,hparse,gparseFromFile,aparseFromFile
    ,hparseFromFile,gparseTest,aparseTest,hparseTest,gtoken,atoken,htoken
    ,gtokens,atokens,htokens,gtokenPrim,atokenPrim,htokenPrim,gtry,atry,htry
    ,glabel,alabel,hlabel,glabels,alabels,hlabels,gunexpected,aunexpected
    ,hunexpected,gpzero,gmany,amany,hmany,gskipMany,askipMany,hskipMany
    ,ggetState,gsetState,asetState,hsetState,gupdateState,aupdateState
    ,hupdateState,ggetPosition,gsetPosition,asetPosition,hsetPosition,ggetInput
    ,gsetInput,asetInput,hsetInput,ggetParserState,gsetParserState
    ,asetParserState,hsetParserState) where

import qualified Hat.PreludeBasic 
import qualified Prelude 
import Hat.Hack 
import qualified Hat.Hat as T 
import Hat.Hat  (WrapVal(wrapVal))
import Hat.Prelude 
import Hat.Text.ParserCombinators.Parsec.Pos 
import Hat.Text.ParserCombinators.Parsec.Error 
import Hat.Control.Monad 

(!<?>) ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (GenParser tok st a) (T.Fun String (GenParser tok st a)))

(*<?>) ::
  (T.R (GenParser tok st a)) ->
    (T.R String) -> T.RefExp -> T.R (GenParser tok st a)

(!<?>) (%<?>) p = T.ufun2 (+<?>) (%<?>) p (*<?>)

(*<?>) fp fmsg p = T.uwrapForward p (hlabel fp fmsg p)

(!<|>) ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun (GenParser tok st a) (GenParser tok st a)))

(*<|>) ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st a)

(!<|>) (%<|>) p = T.ufun2 (+<|>) (%<|>) p (*<|>)

(*<|>) fp1 fp2 p = T.uap2 T.mkNoSrcPos p (gmplus T.mkNoSrcPos p) fp1 fp2

ggetState :: T.RefSrcPos -> T.RefExp -> T.R (GenParser tok st st)

sgetState :: T.R (GenParser tok st st)

ggetState pgetState p = T.uconstUse pgetState p sgetState

sgetState =
  T.uconstDef T.mkRoot agetState
    (\ p ->
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
        (ggetParserState T.mkNoSrcPos p)
        (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
          (\ fstate p ->
            T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.uwrapForward p (hstateUser fstate p)))))

gsetState ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun st (GenParser tok st T.Tuple0))

hsetState :: (T.R st) -> T.RefExp -> T.R (GenParser tok st T.Tuple0)

gsetState psetState p = T.ufun1 asetState psetState p hsetState

hsetState fst p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p)
    (T.uwrapForward p
      (hupdateParserState
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ v79v42v79v83v1 p ->
            case (v79v42v79v83v1) of
              (T.R (State finput fpos _) _) ->
                T.con3 T.mkNoSrcPos p State aState finput fpos fst
              _ -> T.fatal p)) p))
    (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0))

gupdateState ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.Fun st st) (GenParser tok st T.Tuple0))

hupdateState ::
  (T.R (T.Fun st st)) -> T.RefExp -> T.R (GenParser tok st T.Tuple0)

gupdateState pupdateState p = T.ufun1 aupdateState pupdateState p hupdateState

hupdateState ff p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p)
    (T.uwrapForward p
      (hupdateParserState
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ v84v42v84v91v1 p ->
            case (v84v42v84v91v1) of
              (T.R (State finput fpos fuser) _) ->
                T.con3 T.mkNoSrcPos p State aState finput fpos
                  (T.uap1 T.mkNoSrcPos p ff fuser)
              _ -> T.fatal p)) p))
    (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0))

ggetPosition :: T.RefSrcPos -> T.RefExp -> T.R (GenParser tok st SourcePos)

sgetPosition :: T.R (GenParser tok st SourcePos)

ggetPosition pgetPosition p = T.uconstUse pgetPosition p sgetPosition

sgetPosition =
  T.uconstDef T.mkRoot agetPosition
    (\ p ->
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
        (ggetParserState T.mkNoSrcPos p)
        (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
          (\ fstate p ->
            T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.uwrapForward p (hstatePos fstate p)))))

ggetInput :: T.RefSrcPos -> T.RefExp -> T.R (GenParser tok st (T.List tok))

sgetInput :: T.R (GenParser tok st (T.List tok))

ggetInput pgetInput p = T.uconstUse pgetInput p sgetInput

sgetInput =
  T.uconstDef T.mkRoot agetInput
    (\ p ->
      T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
        (ggetParserState T.mkNoSrcPos p)
        (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
          (\ fstate p ->
            T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
              (T.uwrapForward p (hstateInput fstate p)))))

gsetPosition ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun SourcePos (GenParser tok st T.Tuple0))

hsetPosition :: (T.R SourcePos) -> T.RefExp -> T.R (GenParser tok st T.Tuple0)

gsetPosition psetPosition p = T.ufun1 asetPosition psetPosition p hsetPosition

hsetPosition fpos p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p)
    (T.uwrapForward p
      (hupdateParserState
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ v100v46v100v90v1 p ->
            case (v100v46v100v90v1) of
              (T.R (State finput _ fuser) _) ->
                T.con3 T.mkNoSrcPos p State aState finput fpos fuser
              _ -> T.fatal p)) p))
    (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0))

gsetInput ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (T.List tok) (GenParser tok st T.Tuple0))

hsetInput :: (T.R (T.List tok)) -> T.RefExp -> T.R (GenParser tok st T.Tuple0)

gsetInput psetInput p = T.ufun1 asetInput psetInput p hsetInput

hsetInput finput p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p)
    (T.uwrapForward p
      (hupdateParserState
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ v105v46v105v88v1 p ->
            case (v105v46v105v88v1) of
              (T.R (State _ fpos fuser) _) ->
                T.con3 T.mkNoSrcPos p State aState finput fpos fuser
              _ -> T.fatal p)) p))
    (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0))

ggetParserState ::
  T.RefSrcPos -> T.RefExp -> T.R (GenParser tok st (State tok st))

sgetParserState :: T.R (GenParser tok st (State tok st))

ggetParserState pgetParserState p =
  T.uconstUse pgetParserState p sgetParserState

sgetParserState =
  T.uconstDef T.mkRoot agetParserState
    (\ p -> T.uwrapForward p (hupdateParserState (gid T.mkNoSrcPos p) p))

gsetParserState ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (State tok st) (GenParser tok st (State tok st)))

hsetParserState ::
  (T.R (State tok st)) -> T.RefExp -> T.R (GenParser tok st (State tok st))

gsetParserState psetParserState p =
  T.ufun1 asetParserState psetParserState p hsetParserState

hsetParserState fst p =
  T.uwrapForward p
    (hupdateParserState (T.uap1 T.mkNoSrcPos p (gconst T.mkNoSrcPos p) fst) p)

type Parser a = GenParser Char T.Tuple0 a

newtype GenParser tok st a =
  Parser (T.R (T.Fun (State tok st) (Consumed (Reply tok st a))))

instance T.WrapVal ((GenParser tok st a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Parser (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aParser z1wrapVal)
  

grunP prunP p = T.ufun1 arunP prunP p hrunP

hrunP (T.R (Parser fp) _) p =
  gp T.mkNoSrcPos p
  where
  
  gp pp p = T.uconstUse pp p sp
  
  sp = T.uconstDef p a0v0v0v0p (\ p -> T.projection T.mkNoSrcPos p fp)
  
hrunP _ p = T.fatal p

data Consumed a = Consumed (T.R a) | Empty !(T.R a)

instance T.WrapVal ((Consumed a))
  where
  
  wrapVal pwrapVal (kwrapVal@(Consumed (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aConsumed z1wrapVal)
  wrapVal pwrapVal (kwrapVal@(Empty (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aEmpty z1wrapVal)
  

data Reply tok st a =
  Ok (T.R a) (T.R (State tok st)) (T.R ParseError) | Error (T.R ParseError)

instance T.WrapVal ((Reply tok st a))
  where
  
  wrapVal pwrapVal
    (kwrapVal@(Ok (T.R _ z1wrapVal) (T.R _ z2wrapVal) (T.R _ z3wrapVal))) p =
    T.R kwrapVal (T.mkValueApp3 p pwrapVal aOk z1wrapVal z2wrapVal z3wrapVal)
  wrapVal pwrapVal (kwrapVal@(Error (T.R _ z1wrapVal))) p =
    T.R kwrapVal (T.mkValueApp1 p pwrapVal aError z1wrapVal)
  

data State tok st =
  State
    {bstateInput :: T.R (T.List tok),bstatePos :: T.R SourcePos
      ,bstateUser :: !(T.R st)}

instance T.WrapVal ((State tok st))
  where
  
  wrapVal pwrapVal
    (kwrapVal@(State (T.R _ z1wrapVal) (T.R _ z2wrapVal) (T.R _ z3wrapVal))) p =
    T.R kwrapVal (T.mkValueApp3 p pwrapVal aState z1wrapVal z2wrapVal z3wrapVal)
  

gstateInput pstateInput p = T.ufun1 astateInput pstateInput p hstateInput

hstateInput (T.R z1stateInput _) p =
  T.projection T.mkNoSrcPos p (bstateInput z1stateInput)

gstatePos pstatePos p = T.ufun1 astatePos pstatePos p hstatePos

hstatePos (T.R z1statePos _) p =
  T.projection T.mkNoSrcPos p (bstatePos z1statePos)

gstateUser pstateUser p = T.ufun1 astateUser pstateUser p hstateUser

hstateUser (T.R z1stateUser _) p =
  T.projection T.mkNoSrcPos p (bstateUser z1stateUser)

gparseFromFile ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (Parser a) (T.Fun SourceName (IO (Either ParseError a))))

hparseFromFile ::
  (T.R (Parser a)) ->
    (T.R SourceName) -> T.RefExp -> T.R (IO (Either ParseError a))

gparseFromFile pparseFromFile p =
  T.ufun2 aparseFromFile pparseFromFile p hparseFromFile

hparseFromFile fp ffname p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
    (T.uwrapForward p (hreadFile ffname p))
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ finput p ->
        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
          (T.uwrapForward p (hparse fp ffname finput p))))

gparseTest ::
  Show a =>
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (GenParser tok T.Tuple0 a) (T.Fun (T.List tok) (IO T.Tuple0)))

hparseTest ::
  Show a =>
  (T.R (GenParser tok T.Tuple0 a)) ->
    (T.R (T.List tok)) -> T.RefExp -> T.R (IO T.Tuple0)

gparseTest pparseTest p = T.ufun2 aparseTest pparseTest p hparseTest

hparseTest fp finput p =
  T.uccase T.mkNoSrcPos p
    (let
      v152v7v156v27v1 (T.R (Left ferr) _) p =
        T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p)
          (T.uwrapForward p
            (hputStr (T.fromLitString T.mkNoSrcPos p "parse error at ") p))
          (T.uwrapForward p (hprint ferr p))
      v152v7v156v27v1 (T.R (Right fx) _) p = T.uwrapForward p (hprint fx p)
      v152v7v156v27v1 _ p = T.fatal p in (v152v7v156v27v1))
    (T.uwrapForward p
      (hrunParser fp (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0)
        (T.fromLitString T.mkNoSrcPos p "") finput p))

gparse ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok T.Tuple0 a)
          (T.Fun SourceName (T.Fun (T.List tok) (Either ParseError a))))

hparse ::
  (T.R (GenParser tok T.Tuple0 a)) ->
    (T.R SourceName) ->
      (T.R (T.List tok)) -> T.RefExp -> T.R (Either ParseError a)

gparse pparse p = T.ufun3 aparse pparse p hparse

hparse fp fname finput p =
  T.uwrapForward p
    (hrunParser fp (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0) fname finput p)

grunParser ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun st
            (T.Fun SourceName (T.Fun (T.List tok) (Either ParseError a)))))

hrunParser ::
  (T.R (GenParser tok st a)) ->
    (T.R st) ->
      (T.R SourceName) ->
        (T.R (T.List tok)) -> T.RefExp -> T.R (Either ParseError a)

grunParser prunParser p = T.ufun4 arunParser prunParser p hrunParser

hrunParser fp fst fname finput p =
  T.uccase T.mkNoSrcPos p
    (let
      v166v7v168v31v1 (T.R (Ok fx _ _) _) p =
        T.con1 T.mkNoSrcPos p Right aRight fx
      v166v7v168v31v1 (T.R (Error ferr) _) p =
        T.con1 T.mkNoSrcPos p Left aLeft ferr
      v166v7v168v31v1 _ p = T.fatal p in (v166v7v168v31v1))
    (T.uwrapForward p
      (hparserReply
        (T.uap2 T.mkNoSrcPos p (grunP T.mkNoSrcPos p) fp
          (T.con3 T.mkNoSrcPos p State aState finput
            (T.uwrapForward p (hinitialPos fname p)) fst)) p))

gparserReply pparserReply p = T.ufun1 aparserReply pparserReply p hparserReply

hparserReply fresult p =
  T.uccase T.mkNoSrcPos p
    (let
      v171v7v173v31v1 (T.R (Consumed freply) _) p =
        T.projection T.mkNoSrcPos p freply
      v171v7v173v31v1 (T.R (Empty freply) _) p =
        T.projection T.mkNoSrcPos p freply
      v171v7v173v31v1 _ p = T.fatal p in (v171v7v173v31v1)) fresult

instance Functor ((GenParser tok st))
  where
  
  gfmap pfmap p =
    T.ufun2 a180v3v180v27fmap pfmap p hfmap
    where
    
    hfmap ff fp p = T.uwrapForward p (hparsecMap ff fp p)
    
  

gparsecMap ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (T.Fun a b) (T.Fun (GenParser tok st a) (GenParser tok st b)))

hparsecMap ::
  (T.R (T.Fun a b)) ->
    (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st b)

gparsecMap pparsecMap p = T.ufun2 aparsecMap pparsecMap p hparsecMap

hparsecMap ff (T.R (Parser fp) _) p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ fstate p ->
        T.uccase T.mkNoSrcPos p
          (let
            v185v9v187v52v1 (T.R (Consumed freply) _) p =
              T.con1 T.mkNoSrcPos p Consumed aConsumed
                (T.uwrapForward p (hmapReply freply p))
            v185v9v187v52v1 (T.R (Empty freply) _) p =
              T.con1 T.mkNoSrcPos p Empty aEmpty
                (T.uwrapForward p (hmapReply freply p))
            v185v9v187v52v1 _ p = T.fatal p in (v185v9v187v52v1))
          (T.uap1 T.mkNoSrcPos p (gp T.mkNoSrcPos p) fstate)))
  where
  
  gp pp p = T.uconstUse pp p sp
  
  sp = T.uconstDef p a0v0v0v0p (\ p -> T.projection T.mkNoSrcPos p fp)
  
  gmapReply pmapReply p = T.ufun1 a190v7v194v39mapReply pmapReply p hmapReply
  
  amapReply = a190v7v194v39mapReply
  
  hmapReply freply p =
    T.uccase T.mkNoSrcPos p
      (let
        v191v11v194v39v1 (T.R (Ok fx fstate ferr) _) p =
          let
            gfx pfx p = T.uconstUse pfx p sfx
            sfx =
              T.uconstDef p a192v35v192v42fx
                (\ p -> T.uap1 T.mkNoSrcPos p ff fx) in
            (T.uwrapForward p
              (hseq (gfx T.mkNoSrcPos p)
                (T.con3 T.mkNoSrcPos p Ok aOk (gfx T.mkNoSrcPos p) fstate ferr)
                p))
        v191v11v194v39v1 (T.R (Error ferr) _) p =
          T.con1 T.mkNoSrcPos p Error aError ferr
        v191v11v194v39v1 _ p = T.fatal p in (v191v11v194v39v1)) freply
  
hparsecMap _ _ p = T.fatal p

instance Monad ((GenParser tok st))
  where
  
  greturn preturn p =
    T.ufun1 a201v3v201v29return preturn p hreturn
    where
    
    hreturn fx p = T.uwrapForward p (hparsecReturn fx p)
    
  
  (!>>=) (%>>=) p =
    T.ufun2 (+$!$=*=$!$=^>>=) (%>>=) p (*>>=)
    where
    
    (*>>=) fp ff p = T.uwrapForward p (hparsecBind fp ff p)
    
  
  gfail pfail p =
    T.ufun1 a203v3v203v29fail pfail p hfail
    where
    
    hfail fmsg p = T.uwrapForward p (hparsecFail fmsg p)
    
  

gparsecReturn :: T.RefSrcPos -> T.RefExp -> T.R (T.Fun a (GenParser tok st a))

hparsecReturn :: (T.R a) -> T.RefExp -> T.R (GenParser tok st a)

gparsecReturn pparsecReturn p =
  T.ufun1 aparsecReturn pparsecReturn p hparsecReturn

hparsecReturn fx p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ fstate p ->
        T.con1 T.mkNoSrcPos p Empty aEmpty
          (T.con3 T.mkNoSrcPos p Ok aOk fx fstate
            (T.uwrapForward p (hunknownError fstate p)))))

gparsecBind ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun (T.Fun a (GenParser tok st b)) (GenParser tok st b)))

hparsecBind ::
  (T.R (GenParser tok st a)) ->
    (T.R (T.Fun a (GenParser tok st b))) -> T.RefExp -> T.R (GenParser tok st b)

gparsecBind pparsecBind p = T.ufun2 aparsecBind pparsecBind p hparsecBind

hparsecBind (T.R (Parser fp) _) ff p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ fstate p ->
        T.uccase T.mkNoSrcPos p
          (let
            v212v9v226v54v1 (T.R (Consumed freply1) _) p =
              T.uwrapForward p
                (((T.pa0 Consumed T.cn1 T.mkNoSrcPos p aConsumed)
                    *$
                    (T.uccase T.mkNoSrcPos p
                      (let
                        v215v16v219v47v1 (T.R (Ok fx fstate1 ferr1) _) p =
                          T.uccase T.mkNoSrcPos p
                            (let
                              v216v38v218v64v1 (T.R (Empty freply2) _) p =
                                T.uwrapForward p
                                  (hmergeErrorReply ferr1 freply2 p)
                              v216v38v218v64v1 (T.R (Consumed freply2) _) p =
                                T.projection T.mkNoSrcPos p freply2
                              v216v38v218v64v1 _ p = T.fatal p in
                              (v216v38v218v64v1))
                            (T.uap2 T.mkNoSrcPos p (grunP T.mkNoSrcPos p)
                              (T.uap1 T.mkNoSrcPos p ff fx) fstate1)
                        v215v16v219v47v1 (T.R (Error ferr1) _) p =
                          T.con1 T.mkNoSrcPos p Error aError ferr1
                        v215v16v219v47v1 _ p = T.fatal p in (v215v16v219v47v1))
                      freply1)) p)
            v212v9v226v54v1 (T.R (Empty freply1) _) p =
              T.uccase T.mkNoSrcPos p
                (let
                  v222v16v226v54v1 (T.R (Ok fx fstate1 ferr1) _) p =
                    T.uccase T.mkNoSrcPos p
                      (let
                        v223v38v225v60v1 (T.R (Empty freply2) _) p =
                          T.con1 T.mkNoSrcPos p Empty aEmpty
                            (T.uwrapForward p
                              (hmergeErrorReply ferr1 freply2 p))
                        v223v38v225v60v1 fother p =
                          T.projection T.mkNoSrcPos p fother in
                        (v223v38v225v60v1))
                      (T.uap2 T.mkNoSrcPos p (grunP T.mkNoSrcPos p)
                        (T.uap1 T.mkNoSrcPos p ff fx) fstate1)
                  v222v16v226v54v1 (T.R (Error ferr1) _) p =
                    T.con1 T.mkNoSrcPos p Empty aEmpty
                      (T.con1 T.mkNoSrcPos p Error aError ferr1)
                  v222v16v226v54v1 _ p = T.fatal p in (v222v16v226v54v1))
                freply1
            v212v9v226v54v1 _ p = T.fatal p in (v212v9v226v54v1))
          (T.uap1 T.mkNoSrcPos p (gp T.mkNoSrcPos p) fstate)))
  where
  
  gp pp p = T.uconstUse pp p sp
  
  sp = T.uconstDef p a0v0v0v0p (\ p -> T.projection T.mkNoSrcPos p fp)
  
hparsecBind _ _ p = T.fatal p

gmergeErrorReply pmergeErrorReply p =
  T.ufun2 amergeErrorReply pmergeErrorReply p hmergeErrorReply

hmergeErrorReply ferr1 freply p =
  T.uccase T.mkNoSrcPos p
    (let
      v230v5v232v52v1 (T.R (Ok fx fstate ferr2) _) p =
        T.con3 T.mkNoSrcPos p Ok aOk fx fstate
          (T.uwrapForward p (hmergeError ferr1 ferr2 p))
      v230v5v232v52v1 (T.R (Error ferr2) _) p =
        T.con1 T.mkNoSrcPos p Error aError
          (T.uwrapForward p (hmergeError ferr1 ferr2 p))
      v230v5v232v52v1 _ p = T.fatal p in (v230v5v232v52v1)) freply

gparsecFail ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun String (GenParser tok st a))

hparsecFail :: (T.R String) -> T.RefExp -> T.R (GenParser tok st a)

gparsecFail pparsecFail p = T.ufun1 aparsecFail pparsecFail p hparsecFail

hparsecFail fmsg p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ fstate p ->
        T.con1 T.mkNoSrcPos p Empty aEmpty
          (T.con1 T.mkNoSrcPos p Error aError
            (T.uwrapForward p
              (hnewErrorMessage (T.con1 T.mkNoSrcPos p Message aMessage fmsg)
                (T.uwrapForward p (hstatePos fstate p)) p)))))

instance MonadPlus ((GenParser tok st))
  where
  
  gmzero pmzero p = T.uconstUse pmzero p smzero
  
  smzero =
    T.uconstDef T.mkRoot a245v3v245v28mzero (\ p -> gparsecZero T.mkNoSrcPos p)
  
  gmplus pmplus p =
    T.ufun2 a246v3v246v34mplus pmplus p hmplus
    where
    
    hmplus fp1 fp2 p = T.uwrapForward p (hparsecPlus fp1 fp2 p)
    
  

gpzero :: T.RefSrcPos -> T.RefExp -> T.R (GenParser tok st a)

spzero :: T.R (GenParser tok st a)

gpzero ppzero p = T.uconstUse ppzero p spzero

spzero = T.uconstDef T.mkRoot apzero (\ p -> gparsecZero T.mkNoSrcPos p)

gparsecZero :: T.RefSrcPos -> T.RefExp -> T.R (GenParser tok st a)

sparsecZero :: T.R (GenParser tok st a)

gparsecZero pparsecZero p = T.uconstUse pparsecZero p sparsecZero

sparsecZero =
  T.uconstDef T.mkRoot aparsecZero
    (\ p ->
      T.con1 T.mkNoSrcPos p Parser aParser
        (T.ufun1 T.mkLambda T.mkNoSrcPos p
          (\ fstate p ->
            T.con1 T.mkNoSrcPos p Empty aEmpty
              (T.con1 T.mkNoSrcPos p Error aError
                (T.uwrapForward p (hunknownError fstate p))))))

gparsecPlus ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun (GenParser tok st a) (GenParser tok st a)))

hparsecPlus ::
  (T.R (GenParser tok st a)) ->
    (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st a)

gparsecPlus pparsecPlus p = T.ufun2 aparsecPlus pparsecPlus p hparsecPlus

hparsecPlus (T.R (Parser fp1) _) (T.R (Parser fp2) _) p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ fstate p ->
        T.uccase T.mkNoSrcPos p
          (let
            v259v9v263v36v1 (T.R (Empty (T.R (Error ferr) _)) _) p =
              T.uccase T.mkNoSrcPos p
                (let
                  v260v32v262v56v1 (T.R (Empty freply) _) p =
                    T.con1 T.mkNoSrcPos p Empty aEmpty
                      (T.uwrapForward p (hmergeErrorReply ferr freply p))
                  v260v32v262v56v1 fconsumed p =
                    T.projection T.mkNoSrcPos p fconsumed in (v260v32v262v56v1))
                (T.uap1 T.mkNoSrcPos p (gp2 T.mkNoSrcPos p) fstate)
            v259v9v263v36v1 fother p = T.projection T.mkNoSrcPos p fother in
            (v259v9v263v36v1))
          (T.uap1 T.mkNoSrcPos p (gp1 T.mkNoSrcPos p) fstate)))
  where
  
  gp1 pp1 p = T.uconstUse pp1 p sp1
  
  sp1 = T.uconstDef p a0v0v0v0p1 (\ p -> T.projection T.mkNoSrcPos p fp1)
  
  gp2 pp2 p = T.uconstUse pp2 p sp2
  
  sp2 = T.uconstDef p a0v0v0v0p2 (\ p -> T.projection T.mkNoSrcPos p fp2)
  
hparsecPlus _ _ p = T.fatal p

gtry ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (GenParser tok st a) (GenParser tok st a))

htry :: (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st a)

gtry ptry p = T.ufun1 atry ptry p htry

htry (T.R (Parser fp) _) p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ v288v15v292v40v1 p ->
        case (v288v15v292v40v1) of
          (fstate@(T.R (State finput fpos fuser) _)) ->
            T.uccase T.mkNoSrcPos p
              (let
                v289v9v292v40v1 (T.R (Consumed (T.R (Error ferr) _)) _) p =
                  T.con1 T.mkNoSrcPos p Empty aEmpty
                    (T.con1 T.mkNoSrcPos p Error aError
                      (T.uwrapForward p (hsetErrorPos fpos ferr p)))
                v289v9v292v40v1 (T.R (Consumed fok) _) p =
                  T.con1 T.mkNoSrcPos p Consumed aConsumed fok
                v289v9v292v40v1 fempty p = T.projection T.mkNoSrcPos p fempty in
                (v289v9v292v40v1))
              (T.uap1 T.mkNoSrcPos p (gp T.mkNoSrcPos p) fstate)
          _ -> T.fatal p))
  where
  
  gp pp p = T.uconstUse pp p sp
  
  sp = T.uconstDef p a0v0v0v0p (\ p -> T.projection T.mkNoSrcPos p fp)
  
htry _ p = T.fatal p

gtoken ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun tok String)
          (T.Fun (T.Fun tok SourcePos)
            (T.Fun (T.Fun tok (Maybe a)) (GenParser tok st a))))

htoken ::
  (T.R (T.Fun tok String)) ->
    (T.R (T.Fun tok SourcePos)) ->
      (T.R (T.Fun tok (Maybe a))) -> T.RefExp -> T.R (GenParser tok st a)

gtoken ptoken p = T.ufun3 atoken ptoken p htoken

htoken fshow ftokpos ftest p =
  T.uwrapForward p (htokenPrim fshow (gnextpos T.mkNoSrcPos p) ftest p)
  where
  
  gnextpos pnextpos p = T.ufun3 a300v5v301v42nextpos pnextpos p hnextpos
  
  anextpos = a300v5v301v42nextpos
  
  hnextpos _ _ (T.R (T.Cons ftok ftoks) _) p =
    T.uap1 T.mkNoSrcPos p ftokpos ftok
  hnextpos _ ftok (T.R T.List _) p = T.uap1 T.mkNoSrcPos p ftokpos ftok
  hnextpos _ _ _ p = T.fatal p
  

gtokenPrim ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun tok String)
          (T.Fun (T.Fun SourcePos (T.Fun tok (T.Fun (T.List tok) SourcePos)))
            (T.Fun (T.Fun tok (Maybe a)) (GenParser tok st a))))

htokenPrim ::
  (T.R (T.Fun tok String)) ->
    (T.R (T.Fun SourcePos (T.Fun tok (T.Fun (T.List tok) SourcePos)))) ->
      (T.R (T.Fun tok (Maybe a))) -> T.RefExp -> T.R (GenParser tok st a)

gtokenPrim ptokenPrim p = T.ufun3 atokenPrim ptokenPrim p htokenPrim

htokenPrim fshow fnextpos ftest p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ v305v15v313v50v1 p ->
        case (v305v15v313v50v1) of
          (fstate@(T.R (State finput fpos fuser) _)) ->
            T.uccase T.mkNoSrcPos p
              (let
                v306v9v313v50v1 (T.R (T.Cons fc fcs) _) p =
                  T.uccase T.mkNoSrcPos p
                    (let
                      v307v21v312v69v1 (T.R (Just fx) _) p =
                        let
                          gnewpos pnewpos p = T.uconstUse pnewpos p snewpos
                          snewpos =
                            T.uconstDef p a308v38v308v64newpos
                              (\ p ->
                                T.uap3 T.mkNoSrcPos p fnextpos fpos fc fcs)
                          gnewstate pnewstate p =
                            T.uconstUse pnewstate p snewstate
                          snewstate =
                            T.uconstDef p a309v38v309v68newstate
                              (\ p ->
                                T.con3 T.mkNoSrcPos p State aState fcs
                                  (gnewpos T.mkNoSrcPos p) fuser) in
                          (T.uwrapForward p
                            (((T.uap1 T.mkNoSrcPos p (gseq T.mkNoSrcPos p)
                                  (gnewpos T.mkNoSrcPos p))
                                *$
                                (T.uwrapForward p
                                  (((T.uap1 T.mkNoSrcPos p (gseq T.mkNoSrcPos p)
                                        (gnewstate T.mkNoSrcPos p))
                                      *$
                                      (T.con1 T.mkNoSrcPos p Consumed aConsumed
                                        (T.con3 T.mkNoSrcPos p Ok aOk fx
                                          (gnewstate T.mkNoSrcPos p)
                                          (T.uwrapForward p
                                            (hnewErrorUnknown
                                              (gnewpos T.mkNoSrcPos p) p)))))
                                    p))) p))
                      v307v21v312v69v1 (T.R Nothing _) p =
                        T.con1 T.mkNoSrcPos p Empty aEmpty
                          (T.uwrapForward p
                            (hsysUnExpectError (T.uap1 T.mkNoSrcPos p fshow fc)
                              fpos p))
                      v307v21v312v69v1 _ p = T.fatal p in (v307v21v312v69v1))
                    (T.uap1 T.mkNoSrcPos p ftest fc)
                v306v9v313v50v1 (T.R T.List _) p =
                  T.con1 T.mkNoSrcPos p Empty aEmpty
                    (T.uwrapForward p
                      (hsysUnExpectError (T.fromLitString T.mkNoSrcPos p "")
                        fpos p))
                v306v9v313v50v1 _ p = T.fatal p in (v306v9v313v50v1)) finput
          _ -> T.fatal p))

glabel ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R (T.Fun (GenParser tok st a) (T.Fun String (GenParser tok st a)))

hlabel ::
  (T.R (GenParser tok st a)) ->
    (T.R String) -> T.RefExp -> T.R (GenParser tok st a)

glabel plabel p = T.ufun2 alabel plabel p hlabel

hlabel fp fmsg p =
  T.uwrapForward p (hlabels fp (T.fromExpList T.mkNoSrcPos p [fmsg]) p)

glabels ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (GenParser tok st a)
          (T.Fun (T.List String) (GenParser tok st a)))

hlabels ::
  (T.R (GenParser tok st a)) ->
    (T.R (T.List String)) -> T.RefExp -> T.R (GenParser tok st a)

glabels plabels p = T.ufun2 alabels plabels p hlabels

hlabels (T.R (Parser fp) _) fmsgs p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ fstate p ->
        T.uccase T.mkNoSrcPos p
          (let
            v324v9v330v30v1 (T.R (Empty freply) _) p =
              T.uwrapForward p
                (((T.pa0 Empty T.cn1 T.mkNoSrcPos p aEmpty)
                    *$
                    (T.uccase T.mkNoSrcPos p
                      (let
                        v326v26v329v96v1 (T.R (Error ferr) _) p =
                          T.con1 T.mkNoSrcPos p Error aError
                            (T.uwrapForward p (hsetExpectErrors ferr fmsgs p))
                        v326v26v329v96v1 (T.R (Ok fx fstate1 ferr) _) p =
                          T.ucguard (T.uwrapForward p (herrorIsUnknown ferr p))
                            (T.projection T.mkNoSrcPos p freply)
                            (T.ucguard (gotherwise T.mkNoSrcPos p)
                              (T.con3 T.mkNoSrcPos p Ok aOk fx fstate1
                                (T.uwrapForward p
                                  (hsetExpectErrors ferr fmsgs p))) (T.fatal p))
                        v326v26v329v96v1 _ p = T.fatal p in (v326v26v329v96v1))
                      freply)) p)
            v324v9v330v30v1 fother p = T.projection T.mkNoSrcPos p fother in
            (v324v9v330v30v1))
          (T.uap1 T.mkNoSrcPos p (gp T.mkNoSrcPos p) fstate)))
  where
  
  gp pp p = T.uconstUse pp p sp
  
  sp = T.uconstDef p a0v0v0v0p (\ p -> T.projection T.mkNoSrcPos p fp)
  
hlabels _ _ p = T.fatal p

gupdateParserState ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (State tok st) (State tok st))
          (GenParser tok st (State tok st)))

hupdateParserState ::
  (T.R (T.Fun (State tok st) (State tok st))) ->
    T.RefExp -> T.R (GenParser tok st (State tok st))

gupdateParserState pupdateParserState p =
  T.ufun1 aupdateParserState pupdateParserState p hupdateParserState

hupdateParserState ff p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ fstate p ->
        let
          gnewstate pnewstate p = T.uconstUse pnewstate p snewstate
          snewstate =
            T.uconstDef p a336v29v336v46newstate
              (\ p -> T.uap1 T.mkNoSrcPos p ff fstate) in
          (T.uwrapForward p
            (((T.uap1 T.mkNoSrcPos p (gseq T.mkNoSrcPos p)
                  (gnewstate T.mkNoSrcPos p))
                *$
                (T.con1 T.mkNoSrcPos p Empty aEmpty
                  (T.con3 T.mkNoSrcPos p Ok aOk fstate
                    (gnewstate T.mkNoSrcPos p)
                    (T.uwrapForward p
                      (hunknownError (gnewstate T.mkNoSrcPos p) p))))) p))))

gunexpected ::
  T.RefSrcPos -> T.RefExp -> T.R (T.Fun String (GenParser tok st a))

hunexpected :: (T.R String) -> T.RefExp -> T.R (GenParser tok st a)

gunexpected punexpected p = T.ufun1 aunexpected punexpected p hunexpected

hunexpected fmsg p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ fstate p ->
        T.con1 T.mkNoSrcPos p Empty aEmpty
          (T.con1 T.mkNoSrcPos p Error aError
            (T.uwrapForward p
              (hnewErrorMessage (T.con1 T.mkNoSrcPos p UnExpect aUnExpect fmsg)
                (T.uwrapForward p (hstatePos fstate p)) p)))))

gsetExpectErrors psetExpectErrors p =
  T.ufun2 asetExpectErrors psetExpectErrors p hsetExpectErrors

hsetExpectErrors ferr (T.R T.List _) p =
  T.uwrapForward p
    (hsetErrorMessage
      (T.con1 T.mkNoSrcPos p Expect aExpect (T.fromLitString T.mkNoSrcPos p ""))
      ferr p)
hsetExpectErrors ferr (T.R (T.Cons fmsg (T.R T.List _)) _) p =
  T.uwrapForward p
    (hsetErrorMessage (T.con1 T.mkNoSrcPos p Expect aExpect fmsg) ferr p)
hsetExpectErrors ferr (T.R (T.Cons fmsg fmsgs) _) p =
  T.uwrapForward p
    (hfoldr
      (T.ufun2 T.mkLambda T.mkNoSrcPos p
        (\ fmsg ferr p ->
          T.uwrapForward p
            (haddErrorMessage (T.con1 T.mkNoSrcPos p Expect aExpect fmsg) ferr
              p)))
      (T.uwrapForward p
        (hsetErrorMessage (T.con1 T.mkNoSrcPos p Expect aExpect fmsg) ferr p))
      fmsgs p)
hsetExpectErrors _ _ p = T.fatal p

gsysUnExpectError psysUnExpectError p =
  T.ufun2 asysUnExpectError psysUnExpectError p hsysUnExpectError

hsysUnExpectError fmsg fpos p =
  T.con1 T.mkNoSrcPos p Error aError
    (T.uwrapForward p
      (hnewErrorMessage (T.con1 T.mkNoSrcPos p SysUnExpect aSysUnExpect fmsg)
        fpos p))

gunknownError punknownError p =
  T.ufun1 aunknownError punknownError p hunknownError

hunknownError fstate p =
  T.uwrapForward p (hnewErrorUnknown (T.uwrapForward p (hstatePos fstate p)) p)

gmany ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (GenParser tok st a) (GenParser tok st (T.List a)))

hmany ::
  (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st (T.List a))

gmany pmany p = T.ufun1 amany pmany p hmany

hmany fp p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>>= p)
    (T.uwrapForward p
      (hmanyAccum (T.pa0 T.Cons T.cn2 T.mkNoSrcPos p T.aCons) fp p))
    (T.ufun1 T.mkDoLambda T.mkNoSrcPos p
      (\ fxs p ->
        T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
          (T.uap1 T.mkNoSrcPos p (greverse T.mkNoSrcPos p) fxs)))

gskipMany ::
  T.RefSrcPos ->
    T.RefExp -> T.R (T.Fun (GenParser tok st a) (GenParser tok st T.Tuple0))

hskipMany ::
  (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st T.Tuple0)

gskipMany pskipMany p = T.ufun1 askipMany pskipMany p hskipMany

hskipMany fp p =
  T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos Hat.Prelude.!>> p)
    (T.uwrapForward p
      (hmanyAccum
        (T.ufun2 T.mkLambda T.mkNoSrcPos p
          (\ fx fxs p -> T.con0 T.mkNoSrcPos p T.List T.aList)) fp p))
    (T.uap1 T.mkNoSrcPos p (greturn T.mkNoSrcPos p)
      (T.con0 T.mkNoSrcPos p T.Tuple0 T.aTuple0))

gmanyAccum ::
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun a (T.Fun (T.List a) (T.List a)))
          (T.Fun (GenParser tok st a) (GenParser tok st (T.List a))))

hmanyAccum ::
  (T.R (T.Fun a (T.Fun (T.List a) (T.List a)))) ->
    (T.R (GenParser tok st a)) -> T.RefExp -> T.R (GenParser tok st (T.List a))

gmanyAccum pmanyAccum p = T.ufun2 amanyAccum pmanyAccum p hmanyAccum

hmanyAccum faccum (T.R (Parser fp) _) p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ fstate p ->
        let
          gwalk pwalk p = T.ufun3 a374v9v379v92walk pwalk p hwalk
          awalk = a374v9v379v92walk
          hwalk fxs fstate fr p =
            T.uccase T.mkNoSrcPos p
              (let
                v374v27v379v92v1 (T.R (Empty (T.R (Error ferr) _)) _) p =
                  T.con3 T.mkNoSrcPos p Ok aOk fxs fstate ferr
                v374v27v379v92v1 (T.R (Empty fok) _) p =
                  T.uwrapForward p
                    (herror
                      (T.fromLitString T.mkNoSrcPos p
                        "Text.ParserCombinators.Parsec.Prim.many: combinator 'many' is applied to a parser that accepts an empty string.")
                      p)
                v374v27v379v92v1 (T.R (Consumed (T.R (Error ferr) _)) _) p =
                  T.con1 T.mkNoSrcPos p Error aError ferr
                v374v27v379v92v1 (T.R (Consumed (T.R (Ok fx fstate' ferr) _)) _)
                  p =
                  let
                    gys pys p = T.uconstUse pys p sys
                    sys =
                      T.uconstDef p a378v62v378v76ys
                        (\ p -> T.uap2 T.mkNoSrcPos p faccum fx fxs) in
                    (T.uwrapForward p
                      (hseq (gys T.mkNoSrcPos p)
                        (T.uwrapForward p
                          (hwalk (gys T.mkNoSrcPos p) fstate'
                            (T.uap1 T.mkNoSrcPos p (gp T.mkNoSrcPos p) fstate')
                            p)) p))
                v374v27v379v92v1 _ p = T.fatal p in (v374v27v379v92v1)) fr in
          (T.uccase T.mkNoSrcPos p
            (let
              v380v8v384v58v1 (T.R (Empty freply) _) p =
                T.uccase T.mkNoSrcPos p
                  (let
                    v381v26v383v68v1 (T.R (Ok fx fstate' ferr) _) p =
                      T.uwrapForward p
                        (herror
                          (T.fromLitString T.mkNoSrcPos p
                            "Text.ParserCombinators.Parsec.Prim.many: combinator 'many' is applied to a parser that accepts an empty string.")
                          p)
                    v381v26v383v68v1 (T.R (Error ferr) _) p =
                      T.con1 T.mkNoSrcPos p Empty aEmpty
                        (T.con3 T.mkNoSrcPos p Ok aOk
                          (T.con0 T.mkNoSrcPos p T.List T.aList) fstate ferr)
                    v381v26v383v68v1 _ p = T.fatal p in (v381v26v383v68v1))
                  freply
              v380v8v384v58v1 fconsumed p =
                T.uwrapForward p
                  (((T.pa0 Consumed T.cn1 T.mkNoSrcPos p aConsumed)
                      *$
                      (T.uwrapForward p
                        (hwalk (T.con0 T.mkNoSrcPos p T.List T.aList) fstate
                          fconsumed p))) p) in (v380v8v384v58v1))
            (T.uap1 T.mkNoSrcPos p (gp T.mkNoSrcPos p) fstate))))
  where
  
  gp pp p = T.uconstUse pp p sp
  
  sp = T.uconstDef p a0v0v0v0p (\ p -> T.projection T.mkNoSrcPos p fp)
  
hmanyAccum _ _ p = T.fatal p

gtokens ::
  Eq tok =>
  T.RefSrcPos ->
    T.RefExp ->
      T.R
        (T.Fun (T.Fun (T.List tok) String)
          (T.Fun (T.Fun SourcePos (T.Fun (T.List tok) SourcePos))
            (T.Fun (T.List tok) (GenParser tok st (T.List tok)))))

htokens ::
  Eq tok =>
  (T.R (T.Fun (T.List tok) String)) ->
    (T.R (T.Fun SourcePos (T.Fun (T.List tok) SourcePos))) ->
      (T.R (T.List tok)) -> T.RefExp -> T.R (GenParser tok st (T.List tok))

gtokens ptokens p = T.ufun3 atokens ptokens p htokens

htokens fshows fnextposs fs p =
  T.con1 T.mkNoSrcPos p Parser aParser
    (T.ufun1 T.mkLambda T.mkNoSrcPos p
      (\ v406v15v428v23v1 p ->
        case (v406v15v428v23v1) of
          (fstate@(T.R (State finput fpos fuser) _)) ->
            let
              gok pok p = T.ufun1 a408v9v411v69ok pok p hok
              aok = a408v9v411v69ok
              hok fcs p =
                let
                  gnewpos pnewpos p = T.uconstUse pnewpos p snewpos
                  snewpos =
                    T.uconstDef p a408v33v408v57newpos
                      (\ p -> T.uap2 T.mkNoSrcPos p fnextposs fpos fs)
                  gnewstate pnewstate p = T.uconstUse pnewstate p snewstate
                  snewstate =
                    T.uconstDef p a409v33v409v63newstate
                      (\ p ->
                        T.con3 T.mkNoSrcPos p State aState fcs
                          (gnewpos T.mkNoSrcPos p) fuser) in
                  (T.uwrapForward p
                    (((T.uap1 T.mkNoSrcPos p (gseq T.mkNoSrcPos p)
                          (gnewpos T.mkNoSrcPos p))
                        *$
                        (T.uwrapForward p
                          (((T.uap1 T.mkNoSrcPos p (gseq T.mkNoSrcPos p)
                                (gnewstate T.mkNoSrcPos p))
                              *$
                              (T.con3 T.mkNoSrcPos p Ok aOk fs
                                (gnewstate T.mkNoSrcPos p)
                                (T.uwrapForward p
                                  (hnewErrorUnknown (gnewpos T.mkNoSrcPos p)
                                    p)))) p))) p))
              gerrEof perrEof p = T.uconstUse perrEof p serrEof
              serrEof =
                T.uconstDef p a413v9v414v74errEof
                  (\ p ->
                    T.con1 T.mkNoSrcPos p Error aError
                      (T.uwrapForward p
                        (hsetErrorMessage
                          (T.con1 T.mkNoSrcPos p Expect aExpect
                            (T.uap1 T.mkNoSrcPos p fshows fs))
                          (T.uwrapForward p
                            (hnewErrorMessage
                              (T.con1 T.mkNoSrcPos p SysUnExpect aSysUnExpect
                                (T.fromLitString T.mkNoSrcPos p "")) fpos p))
                          p)))
              gerrExpect perrExpect p =
                T.ufun1 a415v9v416v83errExpect perrExpect p herrExpect
              aerrExpect = a415v9v416v83errExpect
              herrExpect fc p =
                T.con1 T.mkNoSrcPos p Error aError
                  (T.uwrapForward p
                    (hsetErrorMessage
                      (T.con1 T.mkNoSrcPos p Expect aExpect
                        (T.uap1 T.mkNoSrcPos p fshows fs))
                      (T.uwrapForward p
                        (hnewErrorMessage
                          (T.con1 T.mkNoSrcPos p SysUnExpect aSysUnExpect
                            (T.uap1 T.mkNoSrcPos p fshows
                              (T.fromExpList T.mkNoSrcPos p [fc]))) fpos p)) p))
              gwalk pwalk p = T.ufun2 a418v9v421v55walk pwalk p hwalk
              awalk = a418v9v421v55walk
              hwalk (T.R T.List _) fcs p = T.uwrapForward p (hok fcs p)
              hwalk fxs (T.R T.List _) p = gerrEof T.mkNoSrcPos p
              hwalk (T.R (T.Cons fx fxs) _) (T.R (T.Cons fc fcs) _) p =
                T.ucguard (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !== p) fx fc)
                  (T.uwrapForward p (hwalk fxs fcs p))
                  (T.ucguard (gotherwise T.mkNoSrcPos p)
                    (T.uwrapForward p (herrExpect fc p)) (T.fatal p))
              hwalk _ _ p = T.fatal p
              gwalk1 pwalk1 p = T.ufun2 a423v9v426v63walk1 pwalk1 p hwalk1
              awalk1 = a423v9v426v63walk1
              hwalk1 (T.R T.List _) fcs p =
                T.con1 T.mkNoSrcPos p Empty aEmpty
                  (T.uwrapForward p (hok fcs p))
              hwalk1 fxs (T.R T.List _) p =
                T.con1 T.mkNoSrcPos p Empty aEmpty (gerrEof T.mkNoSrcPos p)
              hwalk1 (T.R (T.Cons fx fxs) _) (T.R (T.Cons fc fcs) _) p =
                T.ucguard (T.uap2 T.mkNoSrcPos p (T.mkNoSrcPos !== p) fx fc)
                  (T.con1 T.mkNoSrcPos p Consumed aConsumed
                    (T.uwrapForward p (hwalk fxs fcs p)))
                  (T.ucguard (gotherwise T.mkNoSrcPos p)
                    (T.con1 T.mkNoSrcPos p Empty aEmpty
                      (T.uwrapForward p (herrExpect fc p))) (T.fatal p))
              hwalk1 _ _ p = T.fatal p in
              (T.uwrapForward p (hwalk1 fs finput p))
          _ -> T.fatal p))

tText_ParserCombinators_Parsec_Prim =
  T.mkModule "Text.ParserCombinators.Parsec.Prim"
    "Text/ParserCombinators/Parsec/Prim.hs" Prelude.False

aParser =
  T.mkConstructor tText_ParserCombinators_Parsec_Prim 1260030 1260035 3 1
    "Parser"

aConsumed =
  T.mkConstructor tText_ParserCombinators_Parsec_Prim 1290027 1290034 3 1
    "Consumed"

aEmpty =
  T.mkConstructor tText_ParserCombinators_Parsec_Prim 1300027 1300031 3 1
    "Empty"

aOk =
  T.mkConstructor tText_ParserCombinators_Parsec_Prim 1320027 1320028 3 3 "Ok"

aError =
  T.mkConstructor tText_ParserCombinators_Parsec_Prim 1330027 1330031 3 1
    "Error"

aState =
  T.mkConstructorWFields tText_ParserCombinators_Parsec_Prim 1350027 1350031 3 3
    "State" (astateInput : (astatePos : (astateUser : [])))

(+<?>) =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 640003 640005 0 2 "<?>"
    Prelude.False

(+<|>) =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 670004 670006 5 2 "<|>"
    Prelude.False

agetState =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 740001 750045 3 0 "getState"
    Prelude.False

asetState =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 790001 800032 3 1 "setState"
    Prelude.False

aupdateState =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 840001 850032 3 1
    "updateState" Prelude.False

agetPosition =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 930001 930073 3 0
    "getPosition" Prelude.False

agetInput =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 960001 960075 3 0 "getInput"
    Prelude.False

asetPosition =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1000001 1010036 3 1
    "setPosition" Prelude.False

asetInput =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1050001 1060036 3 1
    "setInput" Prelude.False

agetParserState =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1100001 1100043 3 0
    "getParserState" Prelude.False

asetParserState =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1130001 1130049 3 1
    "setParserState" Prelude.False

arunP =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1270001 1270030 3 1 "runP"
    Prelude.False

astateInput =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1350035 1350044 3 1
    "stateInput" Prelude.False

astatePos =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1360035 1360042 3 1
    "statePos" Prelude.False

astateUser =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1370035 1370043 3 1
    "stateUser" Prelude.False

aparseFromFile =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1450001 1470037 3 2
    "parseFromFile" Prelude.False

aparseTest =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1510001 1560027 3 2
    "parseTest" Prelude.False

aparse =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1600001 1610032 3 3 "parse"
    Prelude.False

arunParser =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1650001 1680031 3 4
    "runParser" Prelude.False

aparserReply =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1700001 1730031 3 1
    "parserReply" Prelude.False

a180v3v180v27fmap =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1800003 1800027 3 2 "fmap"
    Prelude.False

aparsecMap =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1830001 1940039 3 2
    "parsecMap" Prelude.False

a201v3v201v29return =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2010003 2010029 3 1 "return"
    Prelude.False

(+$!$=*=$!$=^>>=) =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2020005 2020007 6 2 ">>="
    Prelude.False

a203v3v203v29fail =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2030003 2030029 3 1 "fail"
    Prelude.False

aparsecReturn =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2060001 2070059 3 1
    "parsecReturn" Prelude.False

aparsecBind =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2100001 2260054 3 2
    "parsecBind" Prelude.False

amergeErrorReply =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2290001 2320052 3 2
    "mergeErrorReply" Prelude.False

aparsecFail =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2360001 2380065 3 1
    "parsecFail" Prelude.False

a245v3v245v28mzero =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2450003 2450028 3 0 "mzero"
    Prelude.False

a246v3v246v34mplus =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2460003 2460034 3 2 "mplus"
    Prelude.False

apzero =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2500001 2500018 3 0 "pzero"
    Prelude.False

aparsecZero =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2530001 2540056 3 0
    "parsecZero" Prelude.False

aparsecPlus =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2570001 2630036 3 2
    "parsecPlus" Prelude.False

atry =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2870001 2920040 3 1 "try"
    Prelude.False

atoken =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 2970001 3010042 3 3 "token"
    Prelude.False

atokenPrim =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3040001 3130050 3 3
    "tokenPrim" Prelude.False

alabel =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3180001 3190018 3 2 "label"
    Prelude.False

alabels =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3220001 3300030 3 2 "labels"
    Prelude.False

aupdateParserState =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3350001 3380074 3 1
    "updateParserState" Prelude.False

aunexpected =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3420001 3430084 3 1
    "unexpected" Prelude.False

asetExpectErrors =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3460001 3490078 3 2
    "setExpectErrors" Prelude.False

asysUnExpectError =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3510001 3510072 3 2
    "sysUnExpectError" Prelude.False

aunknownError =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3520001 3520059 3 1
    "unknownError" Prelude.False

amany =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3600001 3620026 3 1 "many"
    Prelude.False

askipMany =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3660001 3680018 3 1
    "skipMany" Prelude.False

amanyAccum =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3720001 3840058 3 2
    "manyAccum" Prelude.False

atokens =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 4050001 4280023 3 3 "tokens"
    Prelude.False

a0v0v0v0p =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 0 0 3 0 "p" Prelude.True

a190v7v194v39mapReply =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1900007 1940039 3 1
    "mapReply" Prelude.True

a192v35v192v42fx =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 1920035 1920042 3 0 "fx"
    Prelude.True

a0v0v0v0p1 =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 0 0 3 0 "p1" Prelude.True

a0v0v0v0p2 =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 0 0 3 0 "p2" Prelude.True

a300v5v301v42nextpos =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3000005 3010042 3 3 "nextpos"
    Prelude.True

a308v38v308v64newpos =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3080038 3080064 3 0 "newpos"
    Prelude.True

a309v38v309v68newstate =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3090038 3090068 3 0
    "newstate" Prelude.True

a336v29v336v46newstate =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3360029 3360046 3 0
    "newstate" Prelude.True

a374v9v379v92walk =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3740009 3790092 3 3 "walk"
    Prelude.True

a378v62v378v76ys =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 3780062 3780076 3 0 "ys"
    Prelude.True

a408v9v411v69ok =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 4080009 4110069 3 1 "ok"
    Prelude.True

a413v9v414v74errEof =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 4130009 4140074 3 0 "errEof"
    Prelude.True

a415v9v416v83errExpect =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 4150009 4160083 3 1
    "errExpect" Prelude.True

a418v9v421v55walk =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 4180009 4210055 3 2 "walk"
    Prelude.True

a423v9v426v63walk1 =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 4230009 4260063 3 2 "walk1"
    Prelude.True

a408v33v408v57newpos =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 4080033 4080057 3 0 "newpos"
    Prelude.True

a409v33v409v63newstate =
  T.mkVariable tText_ParserCombinators_Parsec_Prim 4090033 4090063 3 0
    "newstate" Prelude.True
